2001-07-16  Sam Steingold  <sds@gnu.org>

	* version.h: 2.27 is released

2001-07-16  Sam Steingold  <sds@gnu.org>

	* stream.d (previous_line_virtual): fixed an off-by-one error

2001-07-16  Sam Steingold  <sds@gnu.org>

	* defstruct.lisp (defstruct): warn when the slot accessor shadows
	the predicate (i.e., when the slot is named "P")

2001-07-13  Bruno Haible  <haible@clisp.cons.org>

	* io.d (char_reader): do not search for hyphens.

2001-07-13  Sam Steingold  <sds@gnu.org>

	* stream.d (bitbuff_is_I): fixed the bin i/o for (signed-byte n)
	with n>32 on LITTLE_ENDIAN architecture

2001-07-12  Sam Steingold  <sds@gnu.org>

	abstracted some code
	* stream.d (bitbuff_iu_I, bitbuff_is_I): new functions
	(read-integer): use them
	(rd_by_iu_I): use bitbuff_iu_I()
	(rd_by_is_I): use bitbuff_is_I()
	(bitbuff_ixu_sub, bitbuff_ixs_sub): new functions
	(write-integer): use them
	(wr_by_ixu_sub): use bitbuff_ixu_sub()
	(wr_by_ixs_sub): use bitbuff_ixs_sub()

2001-07-11  Sam Steingold  <sds@gnu.org>

	YAPT (yet another pathname tweak)
	* pathname.d (lslashp): removed, replaced with slashp
	(looks_logical_p): new local function
	(parse-namestring): with *PARSE-NAMESTRING-ANSI* non-nil, parse as
	logical when pathname contains ";" - this is what others do
	(merge-pathnames): merge to logical even when only one is logical
	(make-pathname): coerce defaults to logical when the path is
	logical already

2001-07-10  Sam Steingold  <sds@gnu.org>

	* encoding.d, hashtabl.d, stream.d: unified some error messages

2001-07-10  Sam Steingold  <sds@gnu.org>

	finished the 2001-06-21 patch
	* lispbibl.d (make_file_stream): declare direction arg as direction_t
	* stream.d (make_unbuffered_stream, make_buffered_stream,
	make_file_stream): ditto
	* dirkey.d (open_reg_key): declare if_not_exists arg as
	if_does_not_exist_t

2001-07-10  Sam Steingold  <sds@gnu.org>

	* condition.lisp (appease-cerrors, muffle-cerrors): do not cons
	up a lambda for handler
	(exit-on-error, appease-cerrors, muffle-cerrors, batchmode-errors):
	turned comments into doc strings

2001-07-10  Sam Steingold  <sds@gnu.org>

	* eval.d (invoke_handlers): do not popSTACK twice!

2001-07-10  Sam Steingold  <sds@gnu.org>

	replaced chartcopy with memcpy
	compilation time of compile.lisp went down 3.76%
	fixed bug #438486
	* charstrg.d (chartcopy): removed
	* lispbibl.d (chartcopy): defined to expand to memcpy()

2001-07-09  Sam Steingold  <sds@gnu.org>

	* stream.d (handle_isset): use listen_byte() for binary sockets

2001-07-09  Sam Steingold  <sds@gnu.org>

	fixed the 2001-05-01 patch
	* spvw.d (main): call set_ansi only
	when either -ansi or -traditional was given

2001-07-03  Sam Steingold  <sds@gnu.org>

	tweak the 2001-06-27 patch
	* debug.d (read_form): ignore only whitespace

2001-06-29  Sam Steingold  <sds@gnu.org>

	command-oriented-history-2
	* constsym.d (*TERMINAL-READ-STREAM*): added
	* spvw.d (*TERMINAL-READ-STREAM*): define
	* stream.d (terminal_stream_p): use it
	* debug.d (read_form): bind it
	* io.d (string_reader): unbind *TERMINAL-READ-OPEN-OBJECT*
	in case of an error too

2001-06-27  Sam Steingold  <sds@gnu.org>

	command-oriented-history-1
	* constsym.d (*TERMINAL-READ-OPEN-OBJECT*): added
	* spvw.d (*TERMINAL-READ-OPEN-OBJECT*): define
	* lispbibl.d (terminal_stream_p): declare
	* stream.d (terminal_stream_p): define
	(rd_ch_terminal3): when *TERMINAL-READ-OPEN-OBJECT* is bound,
	add the new lines to the old history item
	(next_line_virtual, previous_line_virtual): readline helper
	functions
	(init_streamvars): bind them to M-p and M-n
	* io.d (read_token_1, read_delimited_list, string_reader): bind
	*TERMINAL-READ-OPEN-OBJECT*

2001-06-27  Sam Steingold  <sds@gnu.org>

	Fixed the win32/emacs bug when commands were ignored because of ^M
	* debug.d (read_form): use string_eqcomp_ci() instead of
	string_equal() and skip the extra chars in the line

2001-06-27  Sam Steingold  <sds@gnu.org>

	* stream.d (strip_white): new local function
	(rd_ch_terminal3): use it to trim the line

2001-06-27  Sam Steingold  <sds@gnu.org>

	non-whole byte i/o finally works
	* stream.d (rd_by_aux_icx_buffered): fixed (rewrote)

2001-06-25  Bruno Haible  <haible@clisp.cons.org>

	Optimize away local functions that are not used.
	* compiler.lisp (var): New slot 'fnode'.
	(fnode): New slots 'Tags', 'far-used-vars', 'far-assigned-vars',
	'far-used-blocks', 'far-used-tagbodys'.
	(note-far-used-var, note-far-assigned-var, note-far-used-block,
	note-far-used-tagbody, propagate-far-used): New functions.
	(c-VAR): If variable is defined in different fnode, store var
	for later propagation, instead of setting (var-closurep var).
	(c-VARSET): Likewise.
	(bind-fixed-var-1, process-fixed-var-list, bind-movable-var): Let the
	variable point to *func*.
	(c-LAMBDABODY): Set fnode-venvconst, fnode-far-used-blocks,
	fnode-far-used-tagbodys for use by the caller.
	(c-RETURN-FROM): If block is defined in different fnode, store it
	for later propagation, instead of setting (block-used-far block).
	(c-TAGBODY): Initialize tagbody-used-far differently. Compute
	tagbody-used-far only at the end.
	(c-GO): If tag is defined in different fnode, store it for later
	propagation, instead of augmenting (tagbody-used-far tagbody).
	(c-FUNCTION): After c-lambdabody, call propagate-far-used.
	(c-%GENERIC-FUNCTION-LAMBDA): Likewise.
	(c-%OPTIMIZE-FUNCTION-LAMBDA): Likewise.
	(c-FLET): After compiling the body and before deciding about the
	closurevars, call propagate-far-used.
	(c-LABELS): Likewise.
	(c-FUNCTION-MACRO-LET): Likewise.
	(c-GENERIC-FLET): Let the variable point to *func*.
	(c-GENERIC-LABELS): Likewise.
	(traverse-anode): For GO instructions, extract tag index that was
	computed at the end of the first pass.
	(compile-lambdabody): Make sure there are no lost closure variables.

2001-06-25  Bruno Haible  <haible@clisp.cons.org>

	* condition.lisp (handler-case): After signalling a warning for
	duplicated :NO-ERROR clause, don't treat it like a regular clause.

2001-06-16  Bruno Haible  <haible@clisp.cons.org>

	Back out unneeded 2001-04-06 patch.
	* makemake.in (NLS_INCLUDES): Set to empty if not using unicode.
	* encoding.d: When not UNICODE, don't include "nls_ascii.c" and don't
	define nls_ascii_table and nls_tables.
	* pseudofun.d: When not UNICODE, don't relocate nls_ascii_table.

2001-06-16  Bruno Haible  <haible@clisp.cons.org>

	Tweak 2001-03-27 patch.
	* eval.d (coerce_function): Mark unreachable code with NOTREACHED.
	(apply): Likewise.
	(funcall): Likewise.

2001-06-16  Bruno Haible  <haible@clisp.cons.org>

	* list.d (up2_test): Don't go through funcall() if the test function
	is #'eq, #'eql or #'equal.
	(up_test): Likewise.
	(funcall_key): New macro.
	(subst, nsubst, sublis, nsublis, member, ADJOIN, assoc, rassoc): Use
	it.

2001-06-23  Bruno Haible  <haible@clisp.cons.org>

	* aclocal.m4 (CL_GETPAGESIZE): Add check for sys/param.h. For mingw32.

2001-06-22  Sam Steingold  <sds@gnu.org>

	New debug command "Reset"(:re)
	to restore the i/o - *PACKAGE* and *READTABLE*
	* reploop.lisp (debug-reset-io): new function
	(*saved-debug-package*, *saved-debug-readtable*): new variables
	(commands1): bind "Reset" and ":re" to `debug-reset-io'

2001-06-21  Sam Steingold  <sds@gnu.org>

	SOCKET-STATUS now accepts SOCKET-SERVERs too
	and the direction of the checks can be specified
	* lispbibl.d (direction_t, if_does_not_exist_t, if_exists_t):
	 new enum types
	(check_direction, check_if_does_not_exist, check_if_exists,
	input_stream_p, output_stream_p): declare
	* pathname.d (check_direction, check_if_does_not_exist,
	check_if_exists): new global functions
	(OPEN): use them
	(open_file): use symbolic values for direction,
	if_exists and if_does_not_exist
	* stream.d (input_stream_p, output_stream_p): global functions now
	(READ_P, RO_P, WRITE_P, DIRECTION_FLAGS): new macros on direction_t
	(make_unbuffered_stream, make_buffered_stream, make_file_stream):
	 use them
	(socket_handle): new local function
	(handle_set, handle_isset): turned into functions
	(SOCKET-STATUS): accept socket servers too,
	 allow request specialization (just :INPUT or just :OUTPUT)
	* io.d (pr_stream): print stream direction
	* constobj.d (printstring_(input|output|io)): new constants
	* dirkey.d (DIR_KEY_*, IDNE_*, parse_if_not_exists,
	parse_direction): removed
	(open_reg_key): convert from direction_t to REGSAM

2001-06-19  Sam Steingold  <sds@gnu.org>

	* stream.d: use memset(3) and memcpy(3) instead of dotimes

2001-06-19  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-FORMAT): avoid calling FORMAT altogether when
	the destination is T and the format string is constant

2001-06-19  Sam Steingold  <sds@gnu.org>

	* makemake.in (test): strip gensyms before cmp(1)

2001-06-17  Sam Steingold  <sds@gnu.org>

	some symbols appeared in wrong packages - fix this
	* compiler.lisp (function-signature): FOREIGN-FUNCTION is in FFI
	* constobj.d: added package prefixes to non-CL symbols
	* constsym.d (MACRO): all ttype designators are in EXT
	* describe.d: FOREIGN-FUNCTION, FOREIGN-VARIABLE, FOREIGN-ADDRESS
	are in FFI, FOREIGN-POINTER is in EXT
	* foreign1.lisp: export FOREIGN-* from FFI
	* init.lisp: export MACRO from EXT

2001-06-17  Sam Steingold  <sds@gnu.org>

	* disassem.lisp (orig-fundef): new aux function
	(disassemble): moved here and made into a generic function
	handle SYMBOL-MACROs too
	* compiler.lisp (disassemble): removed
	* init.lisp: load "disassem" after CLOS
	* makemake.in (LPARTS): reorder

2001-06-15  Sam Steingold  <sds@gnu.org>

	* makemake.in (makemake, Makefile): new development targets
	(RUN): new Makefile variable
	(halfcompiled): restored; now compilation goes like this:
	*.lisp --> interpreted.mem
	*.lisp + compiler.fas --> halfcompiled.mem
	*.fas --> lispinit.mem
	(stage): create a separate memory image for compilation testing
	and reset *GENSYM-COUNTER* in it from halfcompiled.mem

2001-06-15  Sam Steingold  <sds@gnu.org>

	* threads.lisp (with-timeout, with-lock): do not use WITH-GENSYMS
	which is defined only in inspect.lisp

2001-06-14  Sam Steingold  <sds@gnu.org>

	* stream.d (stream_char_p): new macro
	(socket-status): go through `listen_char()' for
	character streams only
	Reported by Lennart Staflin.

2001-06-11  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (compile-file-pathname-helper): thweak the
	2001-05-30 patch making sure FILE is treated as a pathname

2001-06-09  Sam Steingold  <sds@gnu.org>

	* constpack.d: create THREADS package when MULTITHREAD
	* spvw.d: put :MT into *FEATURES* when MULTITHREAD
	* threads.lisp: new file
	* init.lisp: load it when #+MT
	* makemake.in (LPARTS): add it
	* xthread.d (xthread_init): [win32]: noop
	(xmutex_init, xmutex_destroy, xmutex_lock, xmutex_unlock):
	[win32]: use GetLastError() to get the error status

2001-06-09  Sam Steingold  <sds@gnu.org>

	some MT compilation errors fixed
	* lispbibl.d (OS_error): [macro]: use asciz_out_1()
	(SP_bound): [MULTITHREAD]: no semicolon
	* spvw_circ.d: varbrace does not work with #if,
	so expand var manually

2001-06-09  Sam Steingold  <sds@gnu.org>

	* install.lisp: create CLISP.BAT on desktop

2001-06-08  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/libtool.m4: Upgrade to libtool-1.4.

2001-06-08  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/config.guess: Update to GNU version 2001-05-11.
	* autoconf/config.sub: Likewise.

2001-06-08  Sam Steingold  <sds@gnu.org>

	Fixed MIT-CLX build.
	* modules/clx/mit-clx/dependent.lisp (conditional-store):
	GET-SETF-METHOD is in EXT now
	Reported by Paolo Amoroso <amoroso@mclink.it>
	* modules/clx/mit-clx/manager.lisp (cut-buffer): use
	DEFINE-SETF-EXPANDER instead of DEFINE-SETF-METHOD
	* modules/clx/mit-clx/resource.lisp (initialize-resource-database):
	WM-RESOURCES is not exported from XLIB
	* modules/clx/mit-clx/package.lisp: added IN-PACKAGE statement

2001-06-07  Sam Steingold  <sds@gnu.org>

	Print (c-ptr (c-function)) with arguments and correct "()"
	* foreign1.lisp (element, deref, slot, cast, typeof, sizeof,
	bitsizeof): new local (flet) function `foreign-place-p'
	(ctype-type): new function
	(parse-c-function, prepare-c-typedecl, to-c-typedecl,
	note-c-call-in): use it
	(flag-set-p): new function
	(deparse-c-type, note-c-call-in, count-inarguments): use it
	(flag-to-language, language-to-flag): new functions
	(deparse-c-type, parse-c-function): use them, respectively
	(deparse-c-type): new labels: `new-type' and `deparse-slot'
	(split-c-fun-arglist): new function
	(note-c-call-in): use it
	(to-c-typedecl): print the function name in () for c-prt
	and also print the arglist

2001-06-07  Sam Steingold  <sds@gnu.org>

	* modules/clx/mit-clx/clx.lisp (boolean): built-in CLISP type
	since 1998-04-08, do not redefine
	* modules/clx/mit-clx/package.lisp (boolean): do not shadow
	Reported by Paolo Amoroso <amoroso@mclink.it>

2001-06-07  Sam Steingold  <sds@gnu.org>

	* makemake.in (LPARTS): add foreign1 only when foreign is in CPARTS

2001-06-02  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (to-c-typedecl): tweak the 2001-05-30 patch.
	struct t1234 { struct t1234 * NEXT; ... }

2001-06-02  Sam Steingold  <sds@gnu.org>

	made GETENV setfable
	* lispbibl.d: declare clisp_setenv()
	* subr.d, constsym.d: added SYS::SETENV (set_env)
	* spvw_language.d: removed mysetenv, use clisp_setenv()
	* misc.d (clisp_setenv, SETENV): new functions
	(GETENV): barf on non-string arg instead of returning NIL
	* places.lisp: defsetf getenv when setenv is present

2001-06-02  Sam Steingold  <sds@gnu.org>

	* makemake.in (LPARTS): added dirkey

2001-06-01  Sam Steingold  <sds@gnu.org>

	* screen.lisp: use DEFPACKAGE instead of USE-PACKAGE since this
	file is compiled even when it is not subsequently loaded.

2001-05-30  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (compile-file-pathname-helper): return a logical
	pathname when file is a logical pathname

2001-05-30  Sam Steingold  <sds@gnu.org>

	* pathname.d (merge-pathnames): fixed the 2001-05-24 patch to
	handle unbound defaults

2001-05-30  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (*package-tasks-treat-specially*): set to NIL
	(#+CROSS subr-info): `in-package' is now an always-evaluated macro
	(c-GLOBAL-FUNCTION-CALL): remove `in-package' from the list of
	specially treated tasks.

2001-05-30  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (with-defining-c-type): new macro
	(parse-components, c-struct-constructor): new functions
	(parse-c-type): use the above
	(to-c-typedecl): handle the recursive types (like linked lists)
	(def-c-enum): make `name' a synonym for `int'

2001-05-27  Sam Steingold  <sds@gnu.org>

	* regexp.lisp (mregerror): FINALIZE is in EXT

2001-05-25  Sam Steingold  <sds@gnu.org>

	* install.lisp, install.bat: bind LISP, FAS and MEM files with CLISP
	* makemake.in: added install.* to the win32 binary distribution

2001-05-25  Sam Steingold  <sds@gnu.org>

	* dirkey.lisp (dir-key-info): `dkey-info' is in LDAP, not SYS
	(with-dir-key-search): ditto for `dkey-search-iterator',
	`dkey-search-next-key', and `dkey-search-next-att'

2001-05-24  Sam Steingold  <sds@gnu.org>

	* pathname.d (merge-pathnames): if PATHNAME is a logical
	namestring, while DEFAULT is a physical pathname, coerse DEFAULT
	to logical using whole_namestring().

2001-05-24  Sam Steingold  <sds@gnu.org>

	hostname resolution is now optional in
	SOCKET-STREAM-PEER and SOCKET-STREAM-LOCAL.
	* stream.d (host_data_fetcher): accept an additional boolean argument.
	(publish_host_data): pass `resolve_p' to func
	(SOCKET-STREAM-PEER, SOCKET-STREAM-LOCAL): 1 optional argument
	* subr.d: ditto
	* socket.d (socket_getlocalname, socket_getpeername): accept an
	additional `resolve_p' argument.

2001-05-23  Sam Steingold  <sds@gnu.org>

	* makemake.in (distrib): pack in the build directory.

2001-05-23  Sam Steingold  <sds@gnu.org>

	* version.h: 2.26 is released

2001-05-21  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (dfloat): ARM saves the doubles as two little-endian
	words, in big-endian order. Reported by Richard Kreckel.

2001-05-21  Bruno Haible  <haible@clisp.cons.org>

	* ariarm.d: Use #0x instead of #& to designate hexadecimal constants.

2001-05-15  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.lisp: use DEFPACKAGE to define XLIB;
	 import SYS::CONCAT-STRINGS
	* modules/clx/new-clx/demos/clx-demos.lisp: load/compile
	 sokoban.lisp only when the package XPM is present

2001-05-14  Sam Steingold  <sds@gnu.org>

	* constobj.d (current_language): use the package prefix I18N

2001-05-14  Sam Steingold  <sds@gnu.org>

	* defs2.lisp (with-standard-io-syntax): finish the 2000-12-12
	patch - bind *PRINT-RPARS* and *PRINT-INDENT-LISTS* appropriately

2001-05-12  Sam Steingold  <sds@gnu.org>

	* pathname.d (pslashp, lslashp, Z_AT_SLASH, Z_SHIFT): new macros
	(parse_as_logical): new helper function
	(logical_pathname, merge_pathnames): use it
	(merge_pathnames): new macros SPECIFIED, NAMETYPE_MATCH, and
	 VERSION_MATCH; changed the previous patch: re-parse pathname
	 as logical when the default is logical
	(make_pathname): do not translate :name :wild to :name "*"
	(has_wildcards): replaced with wild_p() which handles :WILD
	(has_word_wildcards): ditto with word_wild_p()
	(has_*_wildcards): simplified accordingly

2001-05-11  Sam Steingold  <sds@gnu.org>

	* makemake.in (cpu): set to "arm" when "$host_cpu" is "arm*"
	Reported by Ola Rinta-Koski <ola@cyberell.com>.

2001-05-10  Sam Steingold  <sds@gnu.org>

	Fixed a crash, reported by Christophe Rhodes <csr21@cam.ac.uk>
	ANSI CL compliance: (merge-pathnames lp) --> lp
	* pathname.d: more debugging instrumentation
	(string2wild, wild2string): new macros
	(split_name_type): use them; "*.*" ==> :name :wild :device :wild
	(directory_namestring_parts): :name and :type maybe :wild
	(merge-pathnames): as per ANSI CL, return a logical pathname when
	 the first argument is one.
	(directory_match, nametype_match, version_match):
	 unbound matches everything
	(directory_diff, nametype_diff, version_diff):
	 treat unbound appropriately too
	(translate_device, translate_nametype_aux): :WILD is the same as NIL

2001-05-09  Sam Steingold  <sds@gnu.org>

	Implemented the ANSI CL issue CONSTANTP-ENVIRONMENT:ADD-ARG
	* control.d (constantp): accept the optional environment arg
	* subr.d (constantp): ditto

2001-05-09  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (ARM): Recognize __arm__ as CPU indicator on Linux

2001-05-09  Sam Steingold  <sds@gnu.org>

	ANSI CL compiler macros are implemented
	* cmacros.lisp: new file
	* makemake.in (LPARTS): added cmacros
	* compiler.lisp (env, mac-exp): new aux inline functions
	(macroexpand-1, c-form, compile-toplevel-form &c): use them
	(macroexpand-form): call COMPILER-MACRO-FUNCTION
	(inline-callable-function-lambda-p, inline-callable-lambdabody-p):
	 use FUNCTION-FORM-FUNFORM
	(c-FUNCTION-CALL, c-APPLY): use SIMPLE-FUNCTION-FORM-P
	* init.lisp: load cmacros; export COMPILER-MACRO,
	 COMPILER-MACRO-FUNCTION DEFINE-COMPILER-MACRO
	* defmacro.lisp (make-macro-expansion): accept an optional
	 PRE-PROCESS argument

2001-05-06  Bruno Haible  <haible@clisp.cons.org>

	* configure: Configure and build libiconv before configuring gettext.
	While configuring gettext, add the build directory to the CPPFLAGS and
	LDFLAGS, so that HAVE_ICONV gets defined to 1.

2001-05-07  Sam Steingold  <sds@gnu.org>

	* hashtabl.d (sxhash): return a fixnum, as per ANSI CL

2001-05-06  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in: Move USE_GETTEXT treatment after USE_LIBICONV treatment,
	so that $LIBS contains libintl.a before libiconv.a.

2001-05-06  Sam Steingold  <sds@gnu.org>

	* eval.d (check_for_illegal_keywords): look only at the first
	:allow-other-keys keyword

2001-05-05  Sam Steingold  <sds@gnu.org>

	handle devices in hostname translation correctly
	* pathname.d (device_diff): push_solution_with(S(Kdevice))
	(translate_device): pop (S(Kdevice))

2001-05-05  Sam Steingold  <sds@gnu.org>

	* type.lisp (subtypep): COMPILED-FUNCTION is a subtype of FUNCTION

2001-05-05  Sam Steingold  <sds@gnu.org>

	* clos.lisp (function-keywords): return 2 values: list of keywords
	and allow-other-keys-flag, as per ANSI CL

2001-05-05  Sam Steingold  <sds@gnu.org>

	Made the compiler a little less vociferous
	* clos.lisp (check-signature-congruence): extracted from
	STD-ADD-METHOD
	(std-add-method): use CHECK-SIGNATURE-CONGRUENCE

	* compiler.lisp (c-DEFUN): do not check signature for generic
	functions since this is better done at load time

2001-05-04  Sam Steingold  <sds@gnu.org>

	ANSI CL compliance: CHAR does not check for FILL-POINTER, ELT does.
	* sequence.d (seq_check_index): new function
	(elt, setelt): use it
	* charstrg.d (unpack_string): new function
	(unpack_string_rw, unpack_string_ro): use it
	(char, store_char): call unpack_string() directly
	instead of unpack_string_r[ow]

2001-05-04  Sam Steingold  <sds@gnu.org>

	Added compile-time signature checking in function calls
	* compiler.lisp (c-source-location): 2 optional arguments
	(c-source-point, c-source-point-location, current-function,
	get-signature, sig-to-list, inline-lambdabody,
	inline-callable-lambdabody-p, lambda-list-to-signature,
	match-known-unknown-functions, in-defun-p): new functions
	(c-warn): use C-COMMENT and CURRENT-FUNCTION
	(c-error): use CURRENT-FUNCTION
	(signature): new defstruct
	(function-signature, signature-to-list): moved here from
	 describe.lisp
	(test-argument-syntax): reindented
	(c-DIRECT-FUNCTION-CALL, pass2): translated the comments
	(c-GLOBAL-FUNCTION-CALL, C-APPLY): always check the signature
	 always call NOTE-FUNCTION-USED, not just when compiling a file;
	 use INLINE-CALLABLE-LAMBDABODY-P and INLINE-LAMBDABODY
	(note-function-used): keep the arguments too
	(c-DEFUN): check the signature using *KNOWN-FUNCTIONS*
	(inline-callable-function-p): use INLINE-CALLABLE-LAMBDABODY-P
	(c-FUNCTION): always call NOTE-FUNCTION-USED
	(c-report-problems): use MATCH-KNOWN-UNKNOWN-FUNCTIONS
	(compile-file): call C-REPORT-PROBLEMS before reporting
	 *ERROR-COUNT* and *WARNING-COUNT*
	(c-form): use IN-DEFUN-P
	* clos.lisp: import SIGNATURE structure from COMPILER and use
	 them instead of simple lists throughout the file
	* constobj.d (version): bumped (generic functions use SIGNATUREs
	 instead of lists to store their signatures)
	* describe.lisp (function-signature, signature-to-list):
	 moved to compiler.lisp
	(arglist): use SIG-TO-LIST and GET-SIGNATURE to accommodate
	 possible future modifications
	* foreign1.lisp (DEF-CALL-OUT, DEF-LIB-CALL-OUT):
	 pass signature to C-DEFUN
	(argvector-to-signature, count-inarguments): new functions
	(foreign-function-signature): renamed to
	 FOREIGN-FUNCTION-IN-ARG-COUNT
	* init.lisp (defun): pass signature to C-DEFUN

2001-05-01  Sam Steingold  <sds@gnu.org>

	* type.lisp (subtypep): handle types NIL and T specially
	[bugfix: (subtypep 'EXTENDED-CHAR 'CHARACTER) returned (NO)]

2001-05-01  Sam Steingold  <sds@gnu.org>

	* format.lisp: pass width to ~a when a non-number is
	given to a numeric format instruction

2001-05-01  Sam Steingold  <sds@gnu.org>

	* spvw.d (main): added "-traditional" command line
	option to override "-ansi" ("-a" deprecated)

2001-05-01  Sam Steingold  <sds@gnu.org>

	* condition.lisp (handler-case): accept :NO-ERROR clause in any
	position, not just the last one

2001-04-30  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (test-argument-syntax): call C-WARN and return NIL
	on WRONG-KEY, instead of calling C-ERROR
	(*deprecated-functions-list*): added GET-SETF-METHOD-MULTIPLE-VALUE

2001-04-25  Sam Steingold  <sds@gnu.org>

	* runprog.lisp (run-shell-command, run-program): accept :wait
	parameter (defaults to T)
	* clhs.lisp (clhs): pass :wait nil to RUN-PROGRAM

2001-04-25  Sam Steingold  <sds@gnu.org>

	* eval.d (invoke_handlers): fixed the 2001-04-18 patch for Linux

2001-04-24  Sam Steingold  <sds@gnu.org>

	* intgcd.d (I_I_xgcd_I_I_I): do not use bit operations for logical
	variables sA and sB (this caused incorrect results on alpha-tru64)

2001-04-24  Sam Steingold  <sds@gnu.org>

	* bindings/linuxlibc5/linux.lisp, bindings/linuxlibc6/linux.lisp:
	added package prefix to IN-PACKAGE and DELETE-PACKAGE

2001-04-23  Sam Steingold  <sds@gnu.org>

	* makemake.in (linkkit): rm-r it before creating links

2001-04-23  Sam Steingold  <sds@gnu.org>

	* affi1.lisp: use DEFPACKAGE to define package AFFI

2001-04-22  Sam Steingold  <sds@gnu.org>

	Finished re-packaging in the modules directory
	* bindings/amigaos/asl-load.lisp, bindings/amigaos/window.lisp,
	bindings/linuxlibc5/linux.lisp, bindings/linuxlibc6/linux.lisp,
	clx/mit-clx/package.lisp, modules/postgresql642/postgresql.
	modules/postgresql632/postgresql.lisp, modules/wildcard/wildcard.lisp:
	use DEFPACKAGE, not CLtL1 IN-PACKAGE
	* new-clx/demos/clx-demos.lisp: getenv is in EXT, not SYS now,
	use strings, not symbols in DEFPACKAGE

2001-04-20  Sam Steingold  <sds@gnu.org>

	* constobj.d (version): bump the bytecode version due to repackaging

2001-04-19  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (clhs): BROWSER defaults to *BROWSER*, not :netscape

2001-04-18  Sam Steingold  <sds@gnu.org>

	* spvw.d (main): quote load_extra_file_types for `clisp file`

2001-04-18  Sam Steingold  <sds@gnu.org>

	Move EXECUTE from COMMON-LISP to EXT
	* constsym.d (EXECUTE): in EXT, not LISP
	* init.lisp (export): export EXECUTE from EXT

2001-04-18  Sam Steingold  <sds@gnu.org>

	ANSI CL compliance: HANDLER-BIND uses multiple handlers
	for the a single error
	* compiler.lisp (c-HANDLER-BIND): collect all handlers, even for
	duplicate types
	* eval.d (invoke_handlers): go over the whole list of handlers,
	not stopping after the first match has been found.

2001-04-18  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (stream-tab): new function
	(disassemble-closure): use it

2001-04-16  Sam Steingold  <sds@gnu.org>

	* io.d (CHECK_READTABLE): new macro
	(unread-char, write-char): use fehler_char()

2001-04-16  Sam Steingold  <sds@gnu.org>

	* sequence.d (valid_type): CONS and NULL are sequences of type LIST

2001-04-11  Sam Steingold  <sds@gnu.org>

	* socket.d: made compilable with SAFETY=3
	(SERVENT_TO_STACK): turned into a local function servent_to_stack()
	(ADDR_TO_STRING): return NIL, not NULL, as the failure value
	(HOSTENT_TO_STACK): turned into a local function hostent_to_stack()

2001-04-11  Sam Steingold  <sds@gnu.org>

	Merged FLET with SYS::%FLET (same for LABELS & MACROLET)
	* init.lisp (flet, labels, macrolet): removed
	(%expand-form): removed flet, labels and macrolet
	do not load "defs3"
	* defs3.lisp: removed
	* compiler.lisp (skip-declarations): new function
	(c-flet, c-labels, c-macrolet): use it
	* constsym.d (pflet, plabels, pmacrolet): removed
	* control.d (skip_declarations): new function

2001-04-10  Bruno Haible  <haible@clisp.cons.org>

	Support for MacOS X.
	* lispbibl.d (RS6000): Define if __ppc__ is defined.
	(TIME_ABSOLUTE, TIME_RELATIVE): Undefine after pulling in the system
	headers.
	* socket.d (in6_u, u6_addr16) [UNIX_DARWIN]: Define as aliases.
	Thanks to Daniel Buenzli and Sunil Mishra for feedback.

2001-04-09  Sam Steingold  <sds@gnu.org>

	* spvw.d (*features*): added :LISP=CL to denote the re-packaging

2001-04-09  Sam Steingold  <sds@gnu.org>

	* type.lisp (upgraded-complex-part-type): ANSI CL compliance -
	trivial function, always returns T
	* init.lisp (upgraded-complex-part-type): exported

2001-04-09  Sam Steingold  <sds@gnu.org>

	* init.lisp (sys::*home-package*): set to NIL at the end

2001-04-06  Sam Steingold  <sds@gnu.org>

	The grand repackaging: USER+CL-USER; LISP+CL
	* amigasock.lisp, beossock.lisp: no export (done in init.lisp)
	* cfgacorn.lisp, cfgamiga.lisp, cfgdos.lisp, cfgsunux.lisp,
	cfgunix.lisp, cfgwin32.lisp, clhs.lisp: (in-package "EXT")
	* clos.lisp: use I18N temporarily (for ENGLISH)
	* compiler.lisp (c-form-table): treat sys::%flet and friends just
	like cl:flet and friends
	* condition.lisp: moved CLISP extensions, like `muffle-cerrors',
	to the EXT package
	* constobj.d (use_default): set to COMMON-LISP
	* constpack.d: added EXT, I18N, GRAY and CUSTOM,
	and, conditionally, LDAP, SOCKET and GSTREAM
	* constsym.d: moved CLISP extensions to EXT or a more specific
	package, if appropriate
	* control.d, fsubr.d:
	renamed flet->%flet; labels->%labels; macrolet->%macrolet
	* defs1.lisp (doseq, dohash): export from EXT
	(fbound-string): moved to init.lisp
	* defs2.lisp (use-default): COMMON-LISP now
	* defs3.lisp: removed everything except for flet and friends
	* dirkey.d, lisparit.d: fixed comments
	* dirkey.lisp: export everything from LDAP and re-export from EXT
	* dutch.lisp, french.lisp, german.lisp, spanish.lisp: moved to I18N
	* edit.lisp, runprog.lisp, savemem.lisp: export from EXT, not LISP
	* eval.d (FUNTAB): removed `in_package',
	added `pfind_package' and `reexport'
	* foreign1.lisp: use COMMON-LISP and EXT in FFI
	* gray.lisp: extracted from gstream.lisp
	* gstream.lisp: moved to GSTREAM package
	* init.lisp: separated LISP exported symbols into COMMON-LISP and
	EXT (and friends);
	(in-package): define here
	(flet, labels, macrolet): added temporary definitions
	* inspect.lisp: export use variables from CUSTOM
	* keyboard.lisp (with-keyboard, *keyboard-input*): export from EXT
	* loop.lisp: in COMMON-LISP
	* macros1.lisp (mapcap, maplap): export from EXT
	* macros2.lisp (without-floating-point-underflow, space,
	with-output-to-printer): export from EXT
	(deflanguage, definternational, deflocalized, localized):
	 export from I18N
	* macros3.lisp (ethe, letf, letf*, with-collect): export from EXT
	* makemake.in (LPARTS): added gray
	* misc.d (set_ansi): do not bother with *features*
	* package.d (in_package): removed
	(reexport): new function
	(init_packages): COMMON-LISP (= LISP, CL); COMMON-LISP-USER (=
	USER, CL-USER)
	* places.lisp (*ansi*): updated the doc string
	(dir-key-value): moved here from dirkey.lisp
	* posix.lisp: re-export from EXT exported symbols
	* reploop.lisp (*prompt*): export from CUSTOM
	(*command-index*, prompt-new-package, package-short-name): export
	from EXT
	* rexx1.lisp: defpackage REXX and export everything from it
	* screen.lisp: use COMMON-LISP and EXT in SCREEN
	* spvw.d (init_symbol_tab_2): added `enum_user_index' to the enum,
	export everything in SOCKET and CUSTOM
	(*features*): replaced :cltl2 with :ansi-cl;
	add :generic-streams when GENERIC_STREAMS is defined
	and :sockets when SOCKET_STREAMS is defined
	(main): -p: is the package does not exist, do not create it;
	-a: do not call `in-package'
	* subr.d (reexport): added
	(in_package): removed
	* subrkw.d (in_package): removed
	* trace.lisp (*trace-function*, *trace-args*, *trace-form*,
	 *trace-values*): export from EXT, not LISP
	* type.lisp (type-expand-1, type-expand): export from EXT, not LISP
	* xcharin.lisp: export from EXT, not LISP

2001-04-06  Sam Steingold  <sds@gnu.org>

	Symbols in FAS files remember their home packages and do not
	depend as much on the special treatment of the package tasks,
	which is now optional.
	* constsym.d (*print-symbols-long*): new variable
	* spvw.d (init_symbol_values): define it
	* io.d (pr_symbol): respect it
	* compiler.lisp (*package-tasks-treat-specially*): new variable
	(c-GLOBAL-FUNCTION-CALL, compile-toplevel-form): use it
	(compile-toplevel-form): bind *print-symbols-long* to t
	 when writing to *fasoutput-stream*

2001-03-23  Sam Steingold  <sds@gnu.org>

	Removed the obsolete `COMMON' type (not in ANSI)
	* constsym.d (commonp): removed
	* eval.d (FUNTAB): removed `commonp'
	* predtype.d (commonp): removed
	* subr.d (commonp): removed
	* compiler.lisp (subrinfo, c-DIRECT-FUNCTION-CALL): removed `commonp'
	(*declaration-types*): removed `common'
	* init.lisp (commonp, common): removed
	* type.lisp (common): removed
	(canonicalize-type): removed `common'

2001-04-06  Sam Steingold  <sds@gnu.org>

	* version.h: 2.25.1 is released

2001-04-06  Sam Steingold  <sds@gnu.org>

	fixed the --without-unicode build
	* makemake.in (NLS_INCLUDES): always has `nls_ascii'
	* encoding.d: include "nls_ascii.c" and define `nls_tables'
	even without unicode
	* pseudofun.d: define `nls_ascii_table' even without unicode

2001-04-05  Sam Steingold  <sds@gnu.org>

	* clos.lisp (initialize-instance): [ANSI] added &key and
	&allow-other-keys to the lambda-list

2001-03-28  Sam Steingold  <sds@gnu.org>

	* condition.lisp (simple-type-error): [ANSI]
	inherit from `simple-condition', not `simple-error'

2001-03-28  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (translate_pathname): Fix invalid use of ## in GET_ITEM_S.

2001-03-27  Sam Steingold  <sds@gnu.org>

	fixed a bug: macros were reported as special forms by funcall &Co
	* eval.d (fehler_specialform): report special operators as such,
	not as special forms
	(coerce_function, funcall, apply): not all orecords are
	special operators
	* control.d (FMAKUNBOUND): error message spelling
	* trace.lisp (trace1): ditto
	* init.lisp (defun): ditto
	* defs1.lisp (fbound-string): ditto

2001-03-27  Sam Steingold  <sds@gnu.org>

	* package.d (symtab_lookup, shadowing_lookup):
	check sym_ for being non-NULL
	(inherited_lookup, inherited_find): new local functions
	(accessiblep, find_symbol, import, unexport, export): use them

2001-03-27  Bruno Haible  <haible@clisp.cons.org>

	* package.d (SYSTEM::PACKAGE-ITERATE): When looking for inherited
	symbols, ignore symbols that are simultaneously exported from the
	used package and present in the main package.
	Reported by Sam Steingold.

2001-03-22  Sam Steingold  <sds@gnu.org>

	fixed a bug: a single value was sometimes returned by `read-line'
	* io.d (eof_handling): mv_count argument added
	(read_w, READ-CHAR, PEEK-CHAR, READ-CHAR-NO-HANG): respect that
	(READ-LINE): always return 2 values

2001-03-22  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (sstring_normal_p): Fix typo.

2001-03-21  Bruno Haible  <haible@clisp.cons.org>

	Make it possible to compile gstream.lisp with interpreted.mem.
	* compiler.lisp: Compile #'venv-search.

2001-03-21  Bruno Haible  <haible@clisp.cons.org>

	* misc.d: Include <stdio.h>.

2001-03-21  Bruno Haible  <haible@clisp.cons.org>

	Make --without-unicode work again.
	* error.d (write_errorasciz_substring): Fix typo.
	* init.lisp: Load "spanish" only if UNICODE.
	* makemake.in (LPARTS): Add "spanish" only if UNICODE is enabled.
	* type.lisp (charset-subtypep): Avoid warning.
	* stream.d (test_external_format_arg) [!UNICODE]: Accept and ignore
	any symbols in the CHARSET package.

2001-03-20  Bruno Haible  <haible@clisp.cons.org>

	* configure: Add trailing slash to www.lisp.org URL.
	* cfgacorn.lisp (*clhs-root-default*): Likewise.
	* cfgamiga.lisp (*clhs-root-default*): Likewise.
	* cfgdos.lisp (*clhs-root-default*): Likewise.
	* cfgwin32.lisp (*clhs-root-default*): Likewise.
	* makemake.in (HSDEFAULT): Likewise.
	(hyperspec): Check existence of directory if it's an absolute
	directory. Remove trailing slash afterwards.
	* clhs.lisp (clhs): Accept a clhs-root with or without trailing slash.

2001-03-20  Bruno Haible  <haible@clisp.cons.org>

	* compiler.lisp (compile-file-pathname-helper): Rewritten. Obey
	output-file's directory even if it is a relative directory.

2001-03-19  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (find_executable): Use strcpy instead of sprintf.

2001-03-18  Bruno Haible  <haible@clisp.cons.org>

	* spvw_memfile.d (DUMPHOST_LEN): New macro.
	(memdump_header): Make _dumphost size OS independent.
	(savemem): Simplify filling of hostname and _dumphost. Use UTF-8
	encoding.
	(loadmem): Move extraction of _dumptime and _dumphost to the end.
	Use UTF-8 encoding.

	* socket.d (MACHINE-INSTANCE): Return hostname as returned by
	gethostbyname, i.e. including the domainname.

2001-03-18  Bruno Haible  <haible@clisp.cons.org>

	* clhs.lisp: Export CLHS-ROOT.
	* cfgunix.lisp: Export CLHS-ROOT and *CLHS-ROOT-DEFAULT*.
	* cfgacorn.lisp: Likewise.
	* cfgamiga.lisp: Likewise.
	* cfgdos.lisp: Likewise.
	* cfgsunux.lisp: Likewise.
	* cfgwin32.lisp: Likewise.

2001-03-18  Bruno Haible  <haible@clisp.cons.org>

	* clisp-link.in: Pass -B argument to all lisp.run invocations.

2001-03-18  Bruno Haible  <haible@clisp.cons.org>

	* .clisp: New file.
	* makemake.in: Link .clisp and .gdbinit into the build dir.

2001-03-18  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/aclocal.m4 (CL_CANONICAL_HOST): Cache $host_alias. Needed
	by AC_CANONICAL_BUILD. Call config.guess and config.sub via
	$CONFIG_SHELL if set.

2001-03-18  Bruno Haible  <haible@clisp.cons.org>

	* condition.lisp (interrupt-condition, simple-interrupt-condition):
	New condition classes.
	(%defclcs): Add interrupt-condition -> simple-interrupt-condition
	mapping.
	(exitunconditionally): New function.
	(exitonerror): Use it.
	(exit-on-error): Don't bind *BREAK-DRIVER*, as that impacts saved
	memory images. Instead, establish a handler for INTERRUPT-CONDITION.
	Generalize the normal handler from ERROR to SERIOUS-CONDITION.
	(batchmode-break-driver): Remove function.
	* lispbibl.d (conditiontype): Add interrupt_condition.
	* error.d (tast_break): When (and (null *error-handler*) *use-clcs*),
	signal a condition of type INTERRUPT-CONDITION.
	* spvw_sigint.d (react_on_sigint, interrupt_handler): Signal an
	INTERRUPT-CONDITION, more specific than a SERIOUS-CONDITION.
	* stream.d (fehler_interrupt): Likewise.

	* savemem.lisp (saveinitmem): Also reset SYSTEM::*ACTIVE-RESTARTS* and
	SYSTEM::*CONDITION-RESTARTS*. Reset the dynamic variables in the new
	image, not in the old.

2001-03-19  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (PARSE-NAMESTRING): Coerce string to normal-simple-string
	before calling parse_logical_host_prefix.

	* lispbibl.d (sstring_normal_p): New macro.
	* pathname.d (parse_logical_word, parse_logical_host_prefix,
	legal_logical_word, legal_name, legal_type, wildcard_match,
	wildcard_diff): assert that the simple-string is normal.

2001-03-19  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/libtool.m4: Upgrade to libtool-1.3.5.
	* autoconf/aclocal.m4 (CL_CANONICAL_HOST): Always define
	ac_config_guess and ac_config_sub. Then ignore requests for
	AC_CONFIG_AUX_DIR_DEFAULT or AC_CANONICAL_HOST.

2001-03-18  Sam Steingold  <sds@gnu.org>

	* init.lisp: do not export `interpreter' & `compiler' from LISP
	for `*features*', since they are keywords now.

2001-03-17  Sam Steingold  <sds@gnu.org>

	load-inside-load bug fix
	* pathname.d (parse_logical_word, parse_logical_host_prefix,
	legal_logical_word, legal_name, legal_type, wildcard_match,
	wildcard_diff): make sure that the `simple-string' is normal.

2001-03-16  Sam Steingold  <sds@gnu.org>

	`compile-file-pathname' bug fix
	* compiler.lisp (compile-file-pathname-helper): new function
	(compile-file-pathname, compile-file): use it

2001-03-15  Bruno Haible  <haible@clisp.cons.org>

	* Makefile.devel (all): Depend on src/VERSION instead of src/version.h.
	(ffcall-i386): New target.
	* spvw_memfile.d (savemem): Zero-fill the rest of _dumphost.
	* spvw.d (main): Do complain about missing -B in all cases.
	(usage): Internationalize.

2001-03-14  Sam Steingold  <sds@gnu.org>

	New versioning system adopted.
	* spvw.d (main): --version works without -B and -M
	  we are now GNU CLISP!
	  do not complain about missing -B when given -x
	* constobj.d (lisp_implementation_version_month_string): removed
	(lisp_implementation_version_date_string): set to VERSION_DATE
	(lisp_implementation_version_number_string): set to VERSION_NUMBER
	(lisp_implementation_version_built_string): set to __DATE__
	(memory_image_timestamp, memory_image_host): new objects
	* makemake.in: VERSION depends on version.h now
	* Makefile.devel: ditto; remove `update-version', unused for 2.5 years
	* misc.d (lisp-implementation-version): return "2.25 (2001-03-15)"
	  and then either the build date of the build host
	* spvw_memfile.d (memdump_header): added `_dumptime' and `_dumphost'
	(savemem, loadmem_from_handle): use them for
	  `memory_image_timestamp' and `memory_image_host'

2001-03-13  Sam Steingold  <sds@gnu.org>

	X3J13 vote <72> unconditionally implemented.
	* compiler.lisp (c-form): do not check (package-use-list *package*)
	* eval.d (other_self_evaluating_p): removed
	(eval1): do not call it

2001-03-09  Sam Steingold  <sds@gnu.org>

	A Logical Pathnames bug fixed.
	* pathname.d (host_diff): when HAS_HOST, push `:host' onto solutions
	(device_diff): when HAS_DEVICE, push `:device' onto solutions
	(translate_host): respect and expect `:host' in `subst'
	(translate_device): respect and expect `:device' in `subst'
	also, added a pathname translation debugging infrastructure
	also, translated some German coments

2001-03-09  Sam Steingold  <sds@gnu.org>

	* posix.lisp (sysinfo): Export structure accessors.

2001-03-07  Bruno Haible  <haible@clisp.cons.org>

	* stream.d (lisp_completion): Remove end_callback() call from last
	  patch.

2001-03-06  Sam Steingold  <sds@gnu.org>

	* stream.d (lisp_completion): [Bug #221956] check the return value
	of `sys::completion'.

2001-03-06  Bruno Haible  <haible@clisp.cons.org>

	* unix.d (EDQUOT): Undefine if it is negative.

2001-03-02  Sam Steingold  <sds@gnu.org>

	* dirkey.d: include winldap.h on WIN32_NATIVE and define LDAP there
	(LDAP_PORT): conditionally define
	(dir_key_open): early LDAP support
	do not barf on ACCESS_DENIED in search:
	(IDNE_IGNORE): new constant for `init_iteration_node'
	(open_reg_key): handle it
	(init_iteration_node): use it; return 2 values
	(state_next_key): pop stack on NULL handle
	(dkey_search_next_key): return 2 values
	Bruno's memory fixes
	(MAKE_OBJECT_LIST, dir_key_value, dkey_info): alloca may be a macro
	* constsym.d (:LDAP): define on WIN32_NATIVE
	* makemake.in (LIBS): link with wldap32 on WIN32_NATIVE
	* dirkey.lisp (dir-key-dump-tree): reflect the new iteration interface

2001-03-02  Bruno Haible  <haible@clisp.cons.org>

	* stream.d (lisp_completion_ignore): New function.
	(lisp_completion): Use CATCH and HANDLER-BIND to catch conversion
	  errors. Skip symbols that are not convertible to *terminal-encoding*.

2001-02-28  Bruno Haible  <haible@clisp.cons.org>
            Sam Steingold  <sds@gnu.org>

	* defmacro.lisp (analyze-rest): Allow destructuring for the
	  &REST/&BODY variable.

2001-02-21  Bruno Haible  <haible@clisp.cons.org>

	* places.lisp (PROGN, LOCALLY, IF): New defsetf expanders.

2001-02-17  Arseny Slobodjuck <ampy@crosswinds.net>
            Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (SCREEN): Also define on WIN32_NATIVE.
	* stream.d [WIN32_NATIVE]: Implement window streams for SCREEN package.
	(console_handle, console_size, console_cursor_pos,
	 console_needtoclose, screenattr, attr_table, attr): New variables.
	(InitConsole, DoneConsole, v_up, v_cb, v_cs, v_ce, v_cl, v_cd,
	 v_scroll, v_al, v_dl, v_su, v_move, v_put, wr_ch_window,
	 MAKE-WINDOW, close_window, WINDOW-*): New functions.

2001-02-08  Bruno Haible  <haible@clisp.cons.org>

	* cfgunix.lisp: Mark the file as being UTF-8 encoded, so it can be
	  loaded and compiled in any locale.
	* cfgacorn.lisp: Likewise.
	* cfgamiga.lisp: Likewise.
	* cfgdos.lisp: Likewise.
	* cfgsunux.lisp: Likewise.
	* cfgwin32.lisp: Likewise.
	Reported by Ulrich Drepper <drepper@redhat.com>.

2001-02-07  Sam Steingold  <sds@gnu.org>

	* inspect.lisp: Fixed bug #130567: unbound slots.
	(*inspect-unbound-value*): new internal variable
	(inspect-cllib): bind it
	(inspect-backend): use it for unbound symbols and slots
	(get-insp): call `insp-check' only when `insp' is non-NIL

2001-02-06  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (ICONV_CONST) [!UNIX]: New macro.

2001-02-04  Bruno Haible  <haible@clisp.cons.org>

	* stream.d (iconv_init): Remove macro, not needed any more since
	  libiconv-1.5.
	(iconv): Define as macro, to cast second argument.
	(iconv_mblen, iconv_mbstowcs, iconv_wcslen, iconv_wcstombs,
	 iconv_range, ChannelStream_init): Don't call iconv_init.

2001-02-04  Sam Steingold  <sds@gnu.org>
	    Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (whole_namestring): Don't set subr_self.
	(file_namestring): New function.
	(FILE-NAMESTRING): Simplification: Call file_namestring.
	(ENOUGH-NAMESTRING): Set subr_self before calling whole_namestring.
	(assure_dir_exists): Simplification: Call directory_namestring and
	  whole_namestring.
	(change_default): Simplification: Call directory_namestring.
	(NAMESTRING): Set subr_self before calling whole_namestring.
	(directory_exists): Simplification: Call directory_namestring.
	(directory_search): Simplification: Call file_namestring.

2001-02-04  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/aclocal.m4 (CL_STDBOOL_H): New macro.
	* configure.in: Invoke it.
	* unixconf.h.in (HAVE_STDBOOL_H): New macro.
	* makemake.in (EVERY_INCLUDES_H): Add stdbool.h, unless the system
	  has it.
	(stdbool.h): New rule.
	(clean4): Remove stdbool.h.
	* lispbibl.d (boolean, FALSE, TRUE): Remove definitions. Include
	  stdbool.h instead.
	* All *.d: Use bool/false/true instead of boolean/FALSE/TRUE.
	* genclisph.d (main): Include or copy stdbool.h instead of defining
	  boolean/FALSE/TRUE.

2001-02-04  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (translate_directory): Don't choke if 'subst' doesn't
	  specify any pieces for the directory.

2001-02-04  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (PARSE-NAMESTRING): Make treatment of :HOST argument CLHS
	  compliant.

2001-02-04  Bruno Haible  <haible@clisp.cons.org>

	* spvw.d (init_symbol_values): Initialize
	  SYS::*LOGICAL-PATHNAME-TRANSLATIONS* to an EQUALP hash table.

2001-02-04  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d: Back out Sam's 2001-01-03 and 2001-01-04 patches.
	(host_namestring_parts): Use "\\\\" instead of twice "\\".
	(directory_namestring): Include the host namestring parts.
	(MERGE-PATHNAMES): If pathname's host is NIL but pathname's device
	  is non-NIL, on Win32, don't take the defaults' host+device.
	(MAKE-PATHNAME): If pathname's host and device are both non-NIL on
	  Win32, signal an error.
	(use_default_dir) [OS2, WIN32]: If the pathname already has a host:
	  1. Don't insert the default drive. 2. Resolve :RELATIVE to
	  :ABSOLUTE.
	(assure_dir_exists): Include host_namestring_parts.
	(directory_exists): Likewise.
	(CD): Signal error if pathname includes a host.

2001-02-03  Bruno Haible  <haible@clisp.cons.org>

	* configure: Also copy gettext/autoconf.
	* makemake.in (libintl.h): Link to gettext/intl/libintl.h.
	* lispbibl.d (GETTEXTL): New macro.
	(clgettextl): New declaration.
	* amigaaux.d: Use GETTEXTL instead of GETTEXT for strings to be output
	  via asciz_out().
	* spvw.d: Likewise.
	* spvw_alloca.d: Likewise.
	* spvw_allocate.d: Likewise.
	* spvw_fault.d: Likewise.
	* spvw_garcol.d: Likewise.
	* spvw_memfile.d: Likewise.
	* spvw_mmap.d: Likewise.
	* spvw_multimap.d: Likewise.
	* spvw_sigsegv.d: Likewise.
	* spvw_language.d (init_language): Call bindtextdomain also for domain
	  "clisplow". Remove textdomain() call. Call bind_textdomain_codeset.
	(to_latin_table, from_latin_table, cvgettext): Remove.
	(clgettext): Call dgettext with domain "clisp".
	(clgettextl): New function.
	(localized_string): Check argument must be in ASCII. clgettext()
	  returns value in UTF-8.
	(localized_object): Likewise.
	* error.d (write_errorasciz_substring): New function.
	(write_errorasciz): Use it.
	(write_errorstring): Move into string segment after segment, not
	  byte after byte.
	* errunix.d (get_errormsg): Use GETTEXTL instead of GETTEXT, so the
	  strings end up in both clisp.mo and clisplow.mo.
	(OS_error_internal): Define 'translate' as clgettext, for UTF-8
	  converted translation.
	(errno_out): Define 'translate' as clgettextl, for locale dependent
	  encoded translation.

2001-02-01  Bruno Haible  <haible@clisp.cons.org>

	* io.d (pr_sstring_ab): Make GC safe.

2001-02-01  Bruno Haible  <haible@clisp.cons.org>

	* stream.d (read_line): When EOF was reached, always set
	  strm_rd_ch_last to eof_value.

2001-01-29  Sam Steingold  <sds@gnu.org>

	* pathname.d (PARSE-NAMESTRING): use `slashp' when parsing UNC
	pathnames, so that //host/dir/file is the same as \\host\fir\file.

2001-01-27  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d: Add IA-64 support.
	(object) [WIDE_HARD]: Use the 1-element struct or directly 'void *'.
	* spvw_mmap.d (mmap_init_pagesize): On IA-64, always use 64 KB.
	* spvw_page.d (oint_addr_relevant_len): Set to 32, to limit
	  std_page_size to 64 KB.

	* predtype.d: Include arilev0.c, needed for R_sign when TYPECODES is
	  defined.

2001-01-28  Bruno Haible  <haible@clisp.cons.org>

	* foreign.d (convert_function_to_foreign, free_foreign_callin,
	   convert_function_from_foreign, callback): Add cast, to avoid
	  warning on 64-bit machines.

2001-01-17  Bruno Haible  <haible@clisp.cons.org>

	* spvw.d (main): Restore functionality broken by last patch.

2001-01-17  Sam Steingold  <sds@gnu.org>

	* posix.lisp (sysinfo, rlimit, limits, usage): unix-specific,
	do not define on other systems

	* spvw.d (main): handle `argv_expr' ("-x") similar to
	`argv_execute_file', as if wrapped in `exit-on-error'

2001-01-15  Bruno Haible  <haible@clisp.cons.org>

	* init.lisp (load): Additional keyword argument :extra-file-types.
	* spvw.d (main) [WIN32_NATIVE]: Pass :extra-file-types '(".bat") to
	  LOAD.

2001-01-14  Bruno Haible  <haible@clisp.cons.org>

	* configure: In avcall and callback, do "make check" instead of
	  "make minicheck".
	* makemake.in: Likewise.

2001-01-04  Sam Steingold  <sds@gnu.org>

	* pathname.d (pathname_check_remote): replaced with
	(pathname_fix_remote): reset device to NIL and make the
	path :absolute
	(merge-pathnames, make-pathname): use it

2001-01-03  Sam Steingold  <sds@gnu.org>

	* pathname.d (use_default_dir win32): do not use `default_drive'
	or `default_directory_of' for UNC paths
	(pathname_check_remote, namestring_host_dir): new local functions
	(assure_dir_exists, directory_exists):
	use `namestring_host_dir' instead of `directory_namestring' and
	`whole_namestring' instead of
	`directory_namestring_parts'+`file_namestring_parts'
	(change_default): barf on remote arguments
	* inspect.lisp (inspect-frontend): bind `keep-alive'

2001-01-03  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (USER-HOMEDIR-PATHNAME): If HAS_HOST is defined but the
	host is NIL, use the homedir on the local machine.

2001-01-02  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (HAS_HOST): Set to 1 for PATHNAME_WIN32.
	* pathname.d (legal_hostchar): Add a definition for PATHNAME_WIN32.
	(PARSE-NAMESTRING): For PATHNAME_WIN32, parse hosts in \\hostname
	  syntax.
	(host_namestring_parts): For PATHNAME_WIN32, use \\hostname syntax.
	(USER-HOMEDIR-PATHNAME): Add dummy definition for PATHNAME_WIN32.

2001-01-03  Sam Steingold  <sds@gnu.org>

	* pathname.d (assure_dir_exists, change_default):
	Use `directory_namestring' instead of
	`directory_namestring_parts'+`string_concat'.

2000-12-28  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in: encoding.o depends on libcharset.h.
	(libcharset.h): New rule.
	* encoding.d: Include libcharset.h.
	(encoding_from_name): Argument is now canonicalized like
	  locale_charset(), not like X11.
	(init_dependent_encodings): Call locale_charset().
	* spvw_ctype.d (locale_charset): Remove variable.
	(init_ctype): Remove initialization of locale_charset.
	* constsym.d: Add JOHAB and AIX specific encoding.

2000-12-29  Bruno Haible  <haible@clisp.cons.org>

	* utils/gen-uninames: New file.
	* Makefile.devel (all): Depend on src/uninames.c.
	(src/uninames.c): New rule.
	* makemake.in (UNICODE_INCLUDES): Add uninames.
	* charstrg.d: Include uninames.c.
	(unicode_name_word, unicode_name_word_lookup): New functions.
	(jamo_initial_short_name, jamo_medial_short_name,
	 jamo_final_short_name): New tables.
	(char_name, name_char): Add support for Unicode character names.

2000-12-21  Sam Steingold  <sds@gnu.org>

	* dirkey.d: made the second half of the file GC safe
	(registry_value_to_object): Fixed the bugs introduced yesterday:
	extra "" at the end of a REG_MULTI_SZ and a += instead of =.
	(scope_error): Replaced with `parse_scope'.

2000-12-20  Bruno Haible  <haible@clisp.cons.org>

	* dirkey.d (registry_value_to_object): Make GC safe. Fix possible
	  buffer overrun.
	(struct root): Add length field.
	(MKKEY): Store string length as well.
	(parse_registry_path): Use memcmp instead of strncmp.
	(DIR-KEY-OPEN): Make GC safe.
	(MAKE_OBJECT_LIST): Make GC safe.

2000-12-20  Bruno Haible  <haible@clisp.cons.org>

	* charstrg.d (nonspacing_table_data): Update to match glibc 2.2 width
	  definition.

2000-12-19  Bruno Haible  <haible@clisp.cons.org>

	* time.d (SYS::DEFAULT-TIME-ZONE) [WIN32]: Don't produce time_t values
	  >= 2^31.

2000-12-13  Sam Steingold  <sds@gnu.org>

	Remote registry access:
	* dirkey.d (test_dir_key): Return obj.
	(roots): Check whether the constants are defined.
	(parse_registry_path): new function to extract the host name and
	the top-level handle-key.
	(dir_key_open): Use it.
	(open_reg_key): Use the IDNE_* constants.
	(dir_key_subkeys): Return the list of the local top-level keys
	when the argument is :win32.
	(itst_current): Ignore zero-length names.
	(scope_error): New nonreturning_function.
	(dkey_search_iterator): Use it.
	(state_next_key): Pop the iteration stack when closing the hangle.
	(dkey_search_next_key): Rely on this change; use `scope_error'.
	* dirkey.lisp: Export `dir-key-values' and `dir-key-children'
	(with-dir-key-search): Make sure `att-iter' is a symbol.

2000-12-12  Sam Steingold  <sds@gnu.org>

	* spvw.d (init_symbol_values): Set *PRINT-RPARS* to NIL and
	*PRINT-INDENT-LISTS* to 1.

2000-12-05  Bruno Haible  <haible@clisp.cons.org>

	* io.d (JUSTIFY_START): Add argument.
	(JUSTIFY_LAST): New macro.
	(justify_start): Add traillength argument. Bind
	  SYS::*PRIN-TRAILLENGTH* and SYS::*PRIN-PREV-TRAILLENGTH*.
	(justify_end_eng): Respect SYS::*PRIN-PREV-TRAILLENGTH*.
	  Unbind SYS::*PRIN-TRAILLENGTH* and SYS::*PRIN-PREV-TRAILLENGTH*.
	(justify_end_weit): Likewise.
	(justify_last): New function.
	(pr_enter): Bind SYS::*PRIN-TRAILLENGTH* to 0.
	(pr_cons): Add argument to JUSTIFY_START. Call JUSTIFY_LAST.
	(pr_number, pr_array_nil, pr_vector, pr_array_rekursion, pr_array,
	 pr_structure_default, pr_hex6_obj, pr_readlabel, pr_record_ab,
	 pr_record_rest, pr_record_descr, pr_orecord, pr_other_obj, pr_subr,
	 pr_closure, pr_cclosure_lang, pr_cclosure_codevector, pr_stream,
	 SYSTEM::WRITE-UNREADABLE): Likewise.
	(some_printable_slots): New function.
	* spvw.d (init_symbol_values): Define SYS::*PRIN-TRAILLENGTH* and
	  SYS::*PRIN-PREV-TRAILLENGTH* as special.

2000-12-04  Sam Steingold  <sds@gnu.org>

	* misc.d (registry): do not goto outsize `with_string_0'
	* dirkey.d (dir_key_value): ditto

2000-12-04  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (dir_key_length): Set to 3.

2000-12-03  Sam Steingold  <sds@gnu.org>

	--with-export-syscalls works on win32 under MSVC5 now
	* socket.d (resolve-host-ipaddr): MSVC doesn't have `gethostent'
	* posixmath.d (erf, erfc, gamma, lgamma): MSVC doesn't have these
	* posixmisc.d: ditto
	* constsym.d, subr.d: kill the exported calls not found under MSVC

2000-12-02  Sam Steingold  <sds@gnu.org>

	Directory access (LDAP, Win32 registry, gnome config.
	Only Win32 registry works at this time.
	* lispbibl.d (FOREIGN): define when DIR_KEY is defined.
	(Dir_Key): new record type.
	* constobj.d (hs_dir_key, type_dir_key, type_scope)
	(printstring_dir_key): added.
	(slash_string): define when DIR_KEY id defined.
	* constsym.d, subr.d, subrkw.d: define the dirkey functions.
	* predtype.d: recognize the new rectype.
	* io.d: print the new rectype.
	* spvw.d: added :DIR-KEY to `*features*' when DIR_KEY is defined.
	* places.lisp (dir-key-value): new defsetf.
	* init.lisp: load dirkey.lisp.
	* dirkey.lisp, dirkey.d: new files.
	* makemake.in: added --with-dir-key.

2000-11-30  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (convert_time_to_universal): New declaration.
	* time.d (convert_time_to_universal): New function.
	* pathname.d (FILE-WRITE-DATE): Use it.

2000-11-29  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (set_start_time): Remove declaration.
	* time.d (internal_time_to_I): New function.
	(GET-INTERNAL-REAL-TIME, GET-INTERNAL-RUN-TIME): Use
	internal_time_to_I.
	(encode_universal_time): New function.
	(calc_start_UT): Remove function.
	(get_start_time): New function.
	(universal_time_sec): New function.
	(GET-UNIVERSAL-TIME): Call universal_time_sec.

2000-11-25  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (UNIX_LISP_TIME_DIFF): new macro
	* time.d (real_time_sec): use it
	* pathname.d (file_stat_): ditto

2000-11-20  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in (lisp.exe): Make the stack 3 MB large.

2000-11-16  Bruno Haible  <haible@clisp.cons.org>

	* array.d (elt_move_T): Use eq instead of ==.
	(elt_move_Char, elt_move_Bit, elt_move_2Bit, elt_move_4Bit,
	 elt_move_8Bit, elt_move_16Bit, elt_move_32Bit): Likewise.
	* sequence.d (copy_seqpart_into): Likewise.

2000-11-15  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in: If TSYS=win32msvc, introduce a Makefile variable MFLAGS.
	(lisp.exe): Don't use /MD flag; use MFLAGS instead.

2000-11-14  Bruno Haible  <haible@clisp.cons.org>

	* Makefile.devel (PERL): New macro.
	(acorn/makefile.cc, acorn/makefile.gcc): Use it.

2000-11-14  Sam Steingold  <sds@gnu.org>

	* win32msvc/makefile.msvc4, win32msvc/makefile.msvc5:
	libinconv/iconv.h and libinconv/iconv.lib are now
	in include and src respectively.

2000-11-13  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (UNIX_MACOSX): Renamed from UNIX_RHAPSODY.
	(UNIX_RHAPSODY, UNIX_DARWIN): New macros.

2000-11-12  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d: Undefine TIME_ABSOLUTE and TIME_RELATIVE first.
	* autoconf/config.guess, autoconf/config.sub: Upgrade to newest
	  version from GNU CVS.

2000-11-10  Sam Steingold  <sds@gnu.org>

	* inspect.lisp: workaround for the Linux bug.
	(crlf, flush-http): new functions.
	(with-http-output): new macro.
	(print-inspection): added &rest opts.
	(http-command): handle `keep-alive'.
	(inspect-frontend :http): ditto.

	* clhs.lisp (*browser*): the default browser.
	(browse-url): `browser' defaults to `*browser*' and can be NIL.

2000-11-10  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in: Increase optimization for SUNPRO compilers to O3.

2000-11-08  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (delete_file_if_exists) [WIN32_NATIVE]: Treat
	ERROR_BAD_NETPATH like ERROR_PATH_NOT_FOUND.
	(rename_file_to_nonexisting) [WIN32_NATIVE]: Likewise.
	(assure_dir_exists) [WIN32_NATIVE]: Likewise.
	(directory_exists) [WIN32_NATIVE]: Likewise.
	(open_input_file) [WIN32_NATIVE]: Likewise.
	(READDIR_findfirst) [WIN32_NATIVE]: Likewise.
	(check_stat_directory) [WIN32_NATIVE]: Likewise.
	(FILE-WRITE-DATE) [WIN32_NATIVE]: Likewise.

2000-11-08  Bruno Haible  <haible@clisp.cons.org>

	* aclocal.m4 (CL_SIGNAL_UNBLOCK): Enable 'volatile' for gotsig,
	wasblocked.
	(CL_SIGNAL_BLOCK_OTHERS): Enable 'volatile' for gotsig,
	somewereblocked.
	(CL_SIGACTION_UNBLOCK): Enable 'volatile' for gotsig, wasblocked.

2000-10-23  Bruno Haible  <haible@clisp.cons.org>

	* constsym.d (CHARSET:GB18030, CHARSET:BIG5HKSCS): New symbols.

2000-10-22  Bruno Haible  <haible@clisp.cons.org>

	* encoding.d (init_encodings): Set O(internal_encoding) to UTF-8.
	* makemake.in: Default file encoding for all CLISP sources is now
	UTF-8.

2000-10-22  Bruno Haible  <haible@clisp.cons.org>

	* spvw_language.d (init_language_from): Accept french and spanish
	names in both ISO-8859-1 and UTF-8.
	* spvw_ctype.d (init_ctype): Likewise.

2000-10-22  Bruno Haible  <haible@clisp.cons.org>

	* spvw.d (print_banner): Don't use non-ASCII argument of gettext.
	* spvw_global.d (check_gc_consistency): Don't use non-ASCII error
	message.

2000-10-09  Bruno Haible  <haible@clisp.cons.org>

	CPU recognition on OpenBSD.
	* lispbibl.d (VAX): Define if __vax__ is defined.
	(MC680X0): Define if __m68k__ is defined.
	(MC680Y0): Define if __mc68020__ is defined.
	(MIPS): Define if __mips__ is defined.
	(M88000): Define if __m88k__ is defined.
	* autoconf/aclocal.m4 (CL_WORDS_LITTLEENDIAN): Recognize __m68k__,
	__mc68020__, __MIPSEB__, __MIPSEL__, __m88k__ as CPU indicators.

2000-09-29  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/aclocal.m4 (CL_CANONICAL_HOST): Fix bug in 2000-05-23
	change.

2000-09-28  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in: On AIX without gcc, use gcc-cccp.
	(XCPP_POSTPROCESS): New variable.

	* autoconf/aclocal.m4 (CL_SOCKLEN_T): New macro.
	* configure.in: Call it.
	* unixconf.h.in (SOCKLEN_T): New macro.
	* win32.d (SOCKLEN_T): Define as int.
	* socket.d (socket_getlocalname_aux, socket_getpeername,
	create_server_socket, accept_connection): Use the SOCKLEN_T type.

	* stream.d (iconv_mblen): Cast to avoid warning.
	(iconv_wcstombs): Likewise.
	(rd_ch_terminal3): Likewise.

2000-09-25  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (I80386): Define if __i386__ is defined. On OpenBSD,
	i386 and __i386 are not defined, only __i386__.
	* autoconf/aclocal.m4 (CL_WORDS_LITTLEENDIAN): Recognize __i386__
	as equivalent to __i386. For OpenBSD.

2000-09-21  Martin Atzmueller  <martin@atzmueller.net>

	* reploop.lisp (debug-backtrace): cleanup of unused variable.

2000-09-12  Bruno Haible  <haible@clisp.cons.org>

	Followup to Sam's 1999-04-07 patch.
	* compiler.lisp (c-form): Accept arrays as self-evaluating forms,
	consistently with eval.d:eva11().

2000-09-12  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (listen_char): Renamed from stream_listen.
	(listen_byte): New declaration.
	* debug.d (read_form): Update.
	* io.d (LISTEN, READ-CHAR-WILL-HANG-P, READ-CHAR-NO-HANG): Update.
	* stream.d (listen_char_synonym): Renamed from listen_synonym.
	(listen_byte_synonym): New function.
	(listen_char_concat): Renamed from listen_concat.
	(listen_byte_concat): New function.
	(listen_char_twoway): Renamed from listen_twoway.
	(listen_byte_twoway): New function.
	(listen_char_str_in): Renamed from listen_str_in.
	(listen_char_buff_in): Renamed from listen_buff_in.
	(listen_char_generic): Renamed from listen_generic.
	(listen_byte_ia8_unbuffered): New function.
	(listen_char_unbuffered): Renamed from listen_unbuffered.
	(listen_char_buffered): Renamed from listen_buffered.
	(listen_byte_ia8_buffered): New function.
	(listen_char_keyboard): Renamed from listen_keyboard.
	(listen_char_terminal): Renamed from listen_terminal.
	(listen_char_terminal1): Renamed from listen_terminal1.
	(listen_char_terminal2): Renamed from listen_terminal2.
	(listen_char_terminal3): Renamed from listen_terminal3.
	(SYSTEM::LISTEN-BYTE): Remove function.
	(listen_char): Renamed from stream_listen.
	(listen_byte): New function.
	(READ-BYTE-LOOKAHEAD, READ-BYTE-WILL-HANG-P, READ-BYTE-NO-HANG): New
	functions.
	* gstream.lisp: Export STREAM-READ-BYTE-LOOKAHEAD,
	STREAM-READ-BYTE-WILL-HANG-P, STREAM-READ-BYTE-NO-HANG.
	(STREAM-READ-BYTE-LOOKAHEAD, STREAM-READ-BYTE-WILL-HANG-P,
	 STREAM-READ-BYTE-NO-HANG): New generic functions.
	* modules/clx/mit-clx/depdefs.lisp: Remove feature test for
	sys::listen-byte. Add feature test for read-byte-lookahead.
	* modules/clx/mit-clx/dependent.lisp (buffer-read-default) [CLISP]:
	Use read-byte-lookahead instead of sys::listen-byte.

2000-09-06  Sam Steingold  <sds@gnu.org>

	Followup to Sam's 1999-04-07 patch.
	* compiler.lisp (c-form): Handle simple vectors as a constant.

2000-09-02  Bruno Haible  <haible@clisp.cons.org>

	* savemem.lisp (saveinitmem): Bind *home-package* to nil while saving
	  the image. Needed because the new image may be started with -a,
	  thus with a different value of *package*.
	  Reported by Valeriy E. Ushakov <uwe@ptc.spbu.ru>.

2000-09-02  Bruno Haible  <haible@clisp.cons.org>

	* modules/clx/new-clx/configure.in: When checking for Xpm and XShape,
	  temporarily add $X_CFLAGS to the CFLAGS. Needed on FreeBSD, which
	  has X_CFLAGS=-I/usr/X11R6/include.
	  Reported by Valeriy E. Ushakov <uwe@ptc.spbu.ru>.

2000-09-01  Bruno Haible  <haible@clisp.cons.org>

	Fix line numbers in generated C code.
	* utils/varbrace.d (out_line): New function.
	(ifdef_line_repeat): New variable.
	(line_emit, line_repeat_else, line_repeat_endif): New functions.
	(next_token): Call them.
	(convert): Initialize ifdef_line_repeat. Call line_emit to emit a
	#line directive.

2000-09-01  Bruno Haible  <haible@clisp.cons.org>

	* stream.d (lisp_completion): Put end_callback() at the right place,
	and protect malloc() and free() with begin/end_system_call().
	Fixes a crash in cstombs on i386 platforms.
	Reported by Valeriy E. Ushakov <uwe@ptc.spbu.ru>.

2000-09-01  Bruno Haible  <haible@clisp.cons.org>

	* eval.d (interpret_bytecode_): Don't produce "testb %edx,%edx" or
	"testb %eax,%eax" any more.

2000-08-19  Bruno Haible  <haible@clisp.cons.org>

	* utils/ccpaux.c: main() returns int. Call fflush(stdout) before
	  testing ferror(stdout).
	* utils/deema.c: Likewise.
	* utils/txt2c.c: Call fflush(stdout) before testing ferror(stdout).
	* utils/comment5.d: Call fflush(outfile) before testing
	  ferror(outfile).

2000-08-26  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/acgeneral.m4 (AC_OUTPUT): Use braces in exec_prefix default
	  value, not parens.

2000-08-18  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (parse_logical_host_prefix): Renamed from logical_host.
	(string_logical_path_p): Remove function.
	(parse_namestring): Integrate it here. When recognizing a logical
	host, don't overwrite the :host argument.

	ANSI CL wants (PATHNAME (OPEN filename ...)) to return filename if
	filename is a logical pathname.
	* pathname.d (open_file): Expect the original filename on the stack.
	(OPEN): When the filename argument is a logical pathname, pass it
	to open_file.

2000-08-17  Sam Steingold  <sds@gnu.org>

	ANSI `parse-namestring' when LISP:*PARSE-NAMESTRING-ANSI* is non-NIL
	* pathname.d (logical_host): New function.
	(parse_logical_pathnamestring): Use it.
	(string_logical_path_p): New function.
	(parse_namestring): Use it.
	* constsym.d (parse_namestring_ansi): New variable.
	* spvw.d (init_symbol_values): Define it.
	* misc.d (set_ansi): Set it.
	* places.lisp (*ansi*): Added it to the doc.

2000-08-17  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (open_file): Pass tolerantp = TRUE to assure_dir_exists
	also if if_not_exists = 2 and direction != 0.

2000-07-27  Bruno Haible  <haible@clisp.cons.org>

	* foreign.d (walk_foreign_pointers): C-FUNCTION values can be NULL.
	(convert_to_foreign): When converting C-FUNCTION, convert NIL to
	NULL.

2000-07-27  Bruno Haible  <haible@clisp.cons.org>

	* predtype.d (eql): When comparing long-floats, also compare the sign.
	Reported by Bernard Urban <Bernard.Urban@meteo.fr>.

2000-07-26  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in (DESTDIR): Renamed from 'install_root'.

2000-07-20  Sam Steingold  <sds@gnu.org>

	* inspect.lisp (insp-check): `warn' instead of `assert'
	(*inspect-browser*): default to nil
	(inspect-frontend :http): hardcode host 127.0.0.1
	print URL when `*inspect-browser*' is nil - permits
	CLISP and browser running on different machines

2000-07-19  Sam Steingold  <sds@gnu.org>

	* socket.d (create_server_socket): use "0.0.0.0" instead of the
	current host to allow anyone to connect to our server

2000-06-23  Sam Steingold  <sds@gnu.org>

	* type.lisp (canonicalize-type, subtypep-integer):
	use (ash 1 *) instead of (expt 2 *)

2000-06-22  Sam Steingold  <sds@gnu.org>

	* stream.d (stream_element_type_eq): new function
	(built_in_stream_element_type): use it
	* constsym.d, subr.d: mention `stream_element_type_eq'

2000-06-21  Bruno Haible  <haible@clisp.cons.org>

	* stream.d (built_in_stream_element_type): Fix the last patch.

2000-06-21  Sam Steingold  <sds@gnu.org>

	* stream.d (socket_status): minor tweaks
	(built_in_stream_element_type): fixed the last patch

2000-06-21  Sam Steingold  <sds@gnu.org>

	* stream.d (built_in_stream_element_type): Special case for
	two-way and echo streams.

2000-06-16  Thomas Klausner  <wiz@danbala.ifoer.tuwien.ac.at>
            Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (unix): Define on NetBSD.
	* modules/clx/new-clx/e2d.c: Treat __MACH__, __NetBSD__, __BeOS__ as
	Unix.
	* makemake.in (fsstnd): New variant netbsd.
	(install, installdirs, uninstall): For fsstnd=netbsd, install the
	html files in $(lispdocdir), not $(htmldir), and the extra
	documentation in $(lispdocdir), not $(lispdocdir)/doc.

2000-06-12  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in (LIBGCC): Set to empty on BeOS.
	(interpreted.mem, lispinit.mem, lispinit2.mem): On BeOS, copy the
	executable before running it (workaround BeOS kernel bug).

	* unix.d (sock_read, sock_write, closesocket): Don't #define on BeOS.
	* unixaux.d (sock_read, sock_write): New functions.
	* stream.d (low_listen_unbuffered_handle): On BeOS, don't use select
	on file handles. Use O_NONBLOCK as a preferred alternative to
	O_NDELAY.
	(rd_ch_keyboard): On BeOS, don't use select on file handles.
	(low_close_socket, low_read_unbuffered_socket):
	(low_listen_unbuffered_socket, low_clear_input_unbuffered_socket):
	(low_read_array_unbuffered_socket, low_write_unbuffered_socket):
	(low_write_array_unbuffered_socket, low_fill_buffered_socket):
	(low_flush_buffered_socket): Define on BeOS, differently from the
	file handles analogs.

2000-06-11  Bruno Haible  <haible@clisp.cons.org>

	* clos.lisp (analyze-method-description): Generate code expanding into
	  SYSTEM::FUNCTION-MACRO-LET instead of MACROLET.

	* fsubr.d (system::function-macro-let): New special form.
	* control.d (system::function-macro-let): Likewise.
	* init.lisp (%expand-form): Handle SYSTEM::FUNCTION-MACRO-LET.
	(%expand-funmacdefs-1, %expand-funmacdefs-2): New functions.
	* compiler.lisp (c-form-table): Add SYSTEM::FUNCTION-MACRO-LET.
	(c-FUNCTION-MACRO-LET): New function.

	* lispbibl.d (Rectype_Macro, Rectype_FunctionMacro): New enumeration
	items.
	(Macro, FunctionMacro): New types.
	(macro_length, functionmacro_length): New macros.
	(TheMacro, TheFunctionMacro): New macros.
	(macrop, functionmacrop): New macros.
	(allocate_macro, allocate_functionmacro): New macros.
	(fehler_function): New declaration.
	* error.d (fehler_function): New function.
	* predtype.d (TYPE-OF, CLOS:CLASS-OF): Treat Rectype_Macro and
	  Rectype_FunctionMacro.
	(COERCE): When the symbol has both a function and a macro, use the
	  function.
	(enum_hs_macro, enum_hs_function_macro): New enum items.
	(heap_statistics_mapper): Update.
	* io.d (pr_orecord): Treat Rectype_Macro and Rectype_FunctionMacro.
	* record.d (SYS::MAKE-MACRO, SYS::MACROP, SYS::MACRO-EXPANDER,
	   SYS::MAKE-FUNCTION-MACRO, SYS::FUNCTION-MACRO-P,
	   SYS::FUNCTION-MACRO-FUNCTION, SYS::FUNCTION-MACRO-EXPANDER): New
	  functions.
	* eval.d (FUNTAB): Add SYS::FUNCTION-MACRO-FUNCTION.
	(macroexp): Test for Macro instead of cons with car = SYS::MACRO.
	(macroexp0): Likewise.
	(eval1): Treat Rectype_FunctionMacro.
	* control.d (FUNCTION): Treat Rectype_FunctionMacro.
	(MACRO-FUNCTION): Test for Macro instead of cons with car =
	  SYS::MACRO.
	* symbol.d (SYS::%PUTD): Test for Macro instead of cons with
	  car = SYS::MACRO.
	* defmacro.lisp (make-macro-expander): Renamed from
	  make-macro-expandercons.
	* init.lisp: Use function sys::make-macro instead of cons 'sys::macro.
	(%expand-form): Treat FunctionMacros like functions.
	  Test for Macro instead of cons with car = SYS::MACRO.
	(defmacro) : Use function sys::make-macro instead of cons
	  'sys::macro.
	* trace.lisp (trace1): Use function sys::make-macro instead of cons
	  'sys::macro.
	* places.lisp (MACRO-FUNCTION): Likewise.
	* compiler.lisp: Import sys::make-macro-expander.
	(funtab): Add SYS::FUNCTION-MACRO-FUNCTION.
	(fenv-search): Return more values, to deal with the FunctionMacro
	  case.
	(c-form, macroexpand-form): Update for changed fenv-search. Call
	  *macroexpand-hook* directly.
	(c-FUNCTION): Update for changed fenv-search.
	(c-MACROLET): Update.
	(c-APPLY): Update for changed fenv-search.
	(compile): Test for Macro instead of cons with car = SYS::MACRO.
	(compile-toplevel-form): Update for changed fenv-search.
	(disassemble): Test for Macro instead of cons with car = SYS::MACRO.
	* describe.lisp (describe-object): Treat SYS::MACRO and FUNCTION-MACRO.

	* init.lisp (MACRO-EXPANDER): Remove macro.
	* macros1.lisp (defmacro-special): New macro.
	(and, or, prog1, prog2, when, unless, psetq, multiple-value-list,
	 multiple-value-bind, multiple-value-setq, locally, case, cond):
	  Define macros using defmacro-special.

	* constobj.d (O(version)): Bump version number.
	(O(old_version)): Remove.
	* misc.d (SYSTEM::VERSION): Don't test for O(old_version) any more.
	* control.d (SYS::OLD-MACRO-FUNCTION): Remove function.
	* pathname.d (SYS::OLD-OPEN): Remove function.
	* record.d (CLOS::OLD-%ALLOCATE-INSTANCE): Remove function.
	* subrkw.d: Remove SYS::OLD-OPEN initialization.
	* eval.d (FUNTAB): Remove SYS::OLD-MACRO-FUNCTION, SYS::OLD-OPEN,
	  CLOS::OLD-%ALLOCATE-INSTANCE. Add MACRO-FUNCTION, OPEN. Move
	  SYS::%COPY-GENERIC-FUNCTION.
	(FUNTABR): Add CLOS::%ALLOCATE-INSTANCE.
	* compiler.lisp (funtab, c-DIRECT-FUNCTION-CALL): Update accordingly.

2000-05-30  Bruno Haible  <haible@clisp.cons.org>

	* pathname.d (MERGE-PATHNAMES): New variable called_from_make_pathname.
	  Accept unbound slot values in this case.
	(MAKE-PATHNAME): If a :DEFAULTS argument is given, don't fill in
	  default values. Call MERGE-PATHNAMES with magic arguments
	  :wild #'make-pathname.

2000-05-30  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in (install-bin): Use $(INSTALL_PROGRAM) or $(INSTALL_DATA)
	  instead of "cp -p".
	Reported by Thomas Klausner <wiz@danbala.ifoer.tuwien.ac.at>.

2000-05-29  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/aclocal.m4 (CL_PROG_INSTALL): Fix typo.
	Reported by Thomas Klausner <wiz@danbala.ifoer.tuwien.ac.at>.

2000-05-26  Bruno Haible  <haible@clisp.cons.org>

	* array.d (elt_move): Add "break" in switch statement.

2000-05-25  Bruno Haible  <haible@clisp.cons.org>

	* makemake.in (MSVCDIR): Change value.
	(TOUCH): On Win32, permit touch to fail.
	(iconv.h, iconv.lib): Fix win32 rules.
	(lisp${LEXE}): Depend on ${XCL_ICONVLIB}.
	(impnotes.html, clisp.html): On Win32, don't use sed.
	(distrib): On Win32, postprocess impnotes.html and clisp.html.

2000-05-23  Bruno Haible  <haible@clisp.cons.org>

	* autoconf/aclocal.m4 (CL_CANONICAL_HOST): Determine host_cpu,
	  host_vendor, host_os correctly if $host has more than two hyphens.

2000-05-21  Bruno Haible  <haible@clisp.cons.org>

	* type.lisp (canonicalize-type): Treat STREAM and subclasses like
	  CLOS classes, not like other built-in classes.
	(subtypep): Remove special code for STREAM and subclasses.

2000-05-21  Bruno Haible  <haible@clisp.cons.org>

	* init.lisp (LOAD): Add :external-format argument and conditionally
	  pass it to OPEN.

2000-05-20  Bruno Haible  <haible@clisp.cons.org>

	* type.lisp (canonicalize-type): Recognize the encodings UTF-16 and
	  UTF-7 as covering all of Unicode.

2000-05-20  Bruno Haible  <haible@clisp.cons.org>

	* type.lisp (subtype-integer): Inline the canonicalize-type call.

2000-05-20  Bruno Haible  <haible@clisp.cons.org>

	* sequence.d (SYSTEM::COERCED-SUBSEQ): New function.
	* encoding.d (CONVERT-STRING-FROM-BYTES, CONVERT-STRING-TO-BYTES): New
	  functions.

2000-05-17  Bruno Haible  <haible@clisp.cons.org>

	* reploop.lisp (break-loop): terpri to *debug-io*, not *error-output*.

2000-05-16  Sam Steingold  <sds@gnu.org>

	* reploop.lisp (break-loop): terpri *debug-io* even when it is
	not interactive.

2000-05-16  Sam Steingold  <sds@gnu.org>

	* stream.d (sec_usec, socket_connect): treat NIL as unbound

2000-05-15  Sam Steingold  <sds@gnu.org>

	* init.lisp (defun): emit `c-defun' for not inlined functions too

2000-05-15  Sam Steingold  <sds@gnu.org>

	* socket.d (H_ERRMSG): fixed duplicate test for NO_DATA.

2000-05-15  Sam Steingold  <sds@gnu.org>

	* makemake.in: fixed the previous patch.

2000-05-12  Martin Atzmueller  <marty@cs.utexas.edu>

	* makemake.in: link clhs in the build-directory to the right place.

2000-05-11  Sam Steingold  <sds@gnu.org>

	* stream.d (socket_status): use HANDLE_SET & HANDLE_ISSET macros.
	* ../doc/impext.xml: document LISP:SOCKET-STATUS.

2000-05-09  Sam Steingold  <sds@gnu.org>

	* stream.d (sec_usec): new helper function.
	(socket_wait): use it.
	(socket_status): new Lisp function: interface to select(3).
	(stream_listen): listen properly on binary streams too.
	* constsym.d, subr.d: added LISP:SOCKET-STATUS.

2000-05-09  Sam Steingold  <sds@gnu.org>

	* disassem.lisp (disassemble-machine-code): do not call
	the pager when running under Emacs.

2000-05-03  Guilherme Manika  <gwm@conectiva.com.br>

	* makemake.in (install-bin): Fix duplicate \$(install_root).

2000-04-25  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* spvw.d (print_license): Add paragraph pointing to copyright.html.

2000-04-18  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* lispbibl.d: On BeOS, define UTF8_CHS, not ISOLATIN_CHS.
	* encoding.d (encoding_from_name): If UTF8_CHS is defined, use
	  CHARSET:UTF-8.

2000-04-14  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_PROG_HLN): Redirect ln's error output.

2000-04-13  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	Support NO_TYPECODES on m68k.
	* lispbibl.d (oint_type_*, oint_data_*): Define differently on
	  m68k-linux.
	(subr_): Add a dummy field to force size a multiple of 4.
	(TheMachineCode): After shifting right, add the missing leftmost
	  bits.
	* spvw.d (main): When determining the heap bounds, compute 'end' with
	  garcol_bit set to 0, even if garcol_bit_o < oint_addr_len-1.
	* encoding.d (nls_table) [NO_TYPECODES]: Force variables of this type,
	  defined in nls_*.c, to be 4-aligned.

2000-04-04  Sam Steingold  <sds@gnu.org>

	* init.lisp (*source-file-types*): added #".cl"
	(search-file <first def>): do not call `reverse'
	(load): swap `*compiled-file-types*' and
	`*source-file-types*' accordingly.

2000-04-05  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* io.d (eof_handling): eof-value defaults to NIL.
	* stream.d (READ-BYTE, READ-INTEGER, READ-FLOAT): Likewise.

2000-04-04  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* unix.d (O_BINARY): Undefine on BeOS.

2000-04-03  Martin Atzmueller  <marty@cs.utexas.edu>

	* _impnotes.html: documented the (abbreviated) keyword-commands
	for the debugger.

	* reploop.lisp (commands1): fixed a typo

2000-04-03  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* lispbibl.d (addressbus_mask) [UNIX_OSF]: Define to
	  0xFFFFFF01FFFFFFFFUL instead of 0xFFFFFFC1FFFFFFFFUL.

2000-04-02  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* clhs.lisp (*browsers*): Add support for w3m.

2000-04-02  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* stream.d (finish_tty_output, force_tty_output): Ignore errno value
	  after calling fsync() on BeOS.

	* lispbibl.d (STACK_register): Don't define on BeOS.
	(oint_type_*, oint_data_*): Define differently on BeOS.

	* socket.d (SERVENT_TO_STACK, LISP:SOCKET-SERVICE-PORT): Don't define
	  if UNIX_BEOS. BeOS5 lacks getservent() and getservbyport().
	* spvw.d (main): On BeOS, add :BEOS to *features*.
	* beossock.lisp: New file.
	* init.lisp: On BeOS, load beossock.lisp.
	* makemake.in (LPARTS): Add beossock.
	* gettext/po/Makefile.devel (LISPSOURCES): Add beossock.

	* autoconf/aclocal.m4 (CL_GETHOSTNAME, CL_TCPCONN): For the prototypes
	  of gethostname and inet_addr, on BeOS, include <sys/socket.h> and
	  <netdb.h>.

2000-04-02  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	Allow building on filesystems lacking symlinks and hard links.
	* autoconf/acgeneral.m4 (AC_OUTPUT_LINKS): If "ln" fails, try "cp -p".
	* autoconf/aclocal.m4 (CL_PROG_CP): Renamed from CL_CP.
	(CL_PROG_LN, CL_PROG_LN_S): New macros.
	(CL_PROG_HLN): Renamed from CL_PROG_LN. Rename cache variable to
	  cl_cv_prog_hln. AC_SUBST HLN instead of LN.
	* configure.in: Update.
	* lndir (link): If "ln" fails, try "cp -p".
	* makemake.in (HLN): Renamed from LN. Use @HLN@ instead of @LN@.
	(LN_S): Renamed from LN.
	(init): Don't create linkkit.
	(linkkit): New rule.
	(modular): Depend on linkkit.
	(UnicodeData.txt): cd into directory before linking.
	(clhs.txt): Likewise. Simplify the symlink. Omit if building
	  in-place.
	* clisp-link.in (link): If "ln" fails, try "cp -p". Redirect stderr
	  to /dev/null.
	(create-module-set): If "ln" fails, try "cp -p".
	* Makefile.devel (src/gettext/configure, src/gettext/config.h.in):
	  Update dependencies.

2000-04-02  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* Makefile.devel (src--distrib): Create a single tar.gz file.
	(SOURCES): Add clisp.spec, modules, readline, sigsegv, libiconv,
	  all of doc.

2000-04-02  Bruno Haible  <haible@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_TERMCAP): When both libtermcap and
	  libncurses exist, prefer the latter.

2000-03-12  Bruno Haible  <haible@clisp.cons.org>

	Add support for S390 CPU.
	* lispbibl.d (S390): New macro.

2000-03-31  Bruno Haible  <haible@clisp.cons.org>

	Renamed all *.lsp files to *.lisp.
	* Makefile.devel, configure: Update.
	* _README.en, _README.de, _README.es: Update.
	* _clisp.1, _clisp.html, _clisp.c, _impnotes.html: Update.
	* constobj.d (O(source_file_type)): Change to #".lisp".
	* cfg*.lisp (editor-tempfile): Return "lisptemp.lisp".
	* edit.lisp (editor-tempfile): Likewise.
	* compiler.lisp (compile-file, compile-file-pathname): Use ".lisp"
	  as default pathname type.
	* defs1.lsp (default logical pathname translations): Map ".LISP" to
	  ".lisp".
	* init.lsp (*source-file-types*): Set to (#".lisp" #".lsp").
	* clisp-link.in: Update.
	* makemake.in: Update.
	* gettext/po/{Makefile.devel,clisp-xgettext}: Update.
	* acorn/swap-ext.pl: Update.
	* nextapp/Lisp/Coordinator.m: Update.
	* os2/{convert.bax,interpreted.in}: Update.
	* modules/bindings/linuxlibc5/Makefile: Update.
	* modules/bindings/linuxlibc6/Makefile: Update.
	* modules/clx/mit-clx/{Makefile*,README.CLISP,link.sh}: Update.
	* modules/clx/new-clx/{Makefile.in,README,link.sh.in,clx.f,
	  clx-ini.lisp,clx.lisp,demos/sokoban.lisp}: Update.
	* modules/regexp/{Makefile.in,README,configure.in}: Update.
	* modules/wildcard/{Makefile.in,configure.in}: Update.
	* modules/postgresql642/Makefile: update

2000-03-30  Bruno Haible  <haible@clisp.cons.org>

	* lispbibl.d (hz): Undefine.

2000-03-30  Bruno Haible  <haible@clisp.cons.org>

	* stream.d (oconv_unshift_output_unbuffered_,
	  oconv_unshift_output_buffered_): Remove junk after #undef.

2000-03-29  Sam Steingold  <sds@gnu.org>

	concatenated-stream-streams compiles with ANSI now
	* stream.d (concatenated_stream_streams): return
	`strm_concat_list', not `strm_concat_totallist'

2000-03-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d: Change distribution of *_frame_info values: merge
	  CBLOCK_frame_info and CTAGBODY_frame_info into
	  CBLOCK_CTAGBODY_frame_info. Change CALLBACK_frame_info so that it
	  has skip2_bit set to 0.
	(callback_bit_t): Change meaning and value.
	(fun_bit_t): Change value.
	(cframe_bit_t, nested_bit_t): Swap values.
	* eval.d (unwind): Update.
	* debug.d (print_stackitem): Update. For a CBLOCK_frame, print the
	  block name, not the entire block cons.

2000-03-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* clisp-link.in: Always pass "-norc" flag to lisp.run.

2000-03-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* clisp-link.in (create-module-set): Remove generation of variables
	  wfiles_o and wfile_list.

2000-03-21  Sam Steingold  <sds@gnu.org>

	* inspect.lsp: use a vector instead of a hash for inspected
	objects.
	* clhs.lsp (*browsers*): support more browsers
	* makemake.in: fixed installation of clhs.txt

2000-03-20  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/Makefile.in:
	(CLISP): call clisp with '-norc -q'
	(clx.d): `e2d' bug workaround: remove ^e_$

2000-03-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_STRERROR): New macro.
	* configure.in: Call it.
	* unixconf.h.in (HAVE_STRERROR): New macro.
	* unix.d (strerror): New declaration.
	* lispbibl.d (init_errormsg_table): Remove declaration.
	* errunix.d (sys_nerr, sys_errlist): Don't declare if HAVE_STRERROR.
	(strerror) [!HAVE_STRERROR]: New function.
	(errormsg_table): Remove variable.
	(init_errormsg_table): Remove function.
	(get_errormsg): New function.
	(OS_error_internal, errno_out): Use get_errormsg instead of
	  errormsg_table.
	* spvw.d (main): Don't call init_errormsg_table.

2000-03-14  Sam Steingold  <sds@gnu.org>

	Integrated inspect
	* inspect.lsp: new file
	* init.lsp: load inspect
	* makemake.in (LPARTS): added inspect

2000-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d: Add BeOS support.
	  Based on patch by Alexis Rivera Rios <ahrivera@yahoo.com>.
	* unix.d: Likewise.

	* autoconf/aclocal.m4 (CL_READLINK): Check the return type as well;
	  it may be 'int' or 'ssize_t'. Define RETREADLINKTYPE.
	* unixconf.h.in (RETREADLINKTYPE): New macro.
	* unix.d (readlink): Use it.

	* autoconf/aclocal.m4 (CL_GETHOSTNAME): Try 'unsigned int' as well.

	* autoconf/aclocal.m4 (RL_SELECT, CL_SELECT): Include <sys/socket.h>.
	  Try 'struct fd_set' as well.

2000-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (compile-file): Don't pass a third argument to the
	  "~%~D error~:P, ~D warning~:P" format string.

	* lisparit.d: Don't use invalid syntax "## ".
	* posixmath.d: Don't use invalid syntax "## ".
	(POSIX:BOGOMIPS): Set mv_count after computing value1, not before.

	* clhs.lsp: The code lives in package SYSTEM, not LISP.
	  Bind *package* while reading clhs.txt.
	  Verify that the COMMON-LISP symbol is an exported one.

	* lndir: Fix defaultIFS, broken by Sam's previous patch 1999-12-23.

	* nls_iso8859_8.c: Regenerate using newest unicode.org table.

	* cc_sparc.il: Remove obsolete file.

2000-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* Makefile.devel, configure, makemake.in: Drop oldoldreadline and
	  oldreadline.

2000-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw.d (main): Emit warning if run without -B command line argument.

2000-03-08  Sam Steingold  <sds@gnu.org>

	* stream.d (socket-server): treat NIL as unbound.

2000-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Remove DOS (EMUNIX && !EMUNIX_PORTABEL, DJUNIX, WATCOM) ports.
	* errdjgpp.d: Remove file.
	* lispbibl.d: Remove support for DOS ports.
	(OS2): Renamed from DOSPC.
	(EMUNIX_PORTABEL): Remove macro, assume it defined whenever EMUNIX
	  is defined.
	(DJUNIX, WATCOM): Remove macros.
	(PATHNAME_MSDOS, PATHNAME_EXT83): Remove macro.
	* msdos.d: Likewise.
	* aridecl.d, arilev0.d, arilev1.d, constobj.d, constsym.d, error.d,
	  errunix.d, genclisph.d, hashtabl.d, pathname.d, spvw.d,
	  spvw_memfile.d, spvw_sigint.d, spvw_sigwinch.d, stream.d, time.d:
	  Update.
	* cfgdos.lsp, complete.lsp, defs1.lsp, describe.lsp, edit.lsp,
	  format.lsp, init.lsp, keyboard.lsp, macros2.lsp, runprog.lsp:
	  Remove DOS feature dependencies.
	* makemake.in: Remove support for dos, dosdjgpp, doswatcom.
	(INCLUDEDIR): Remove variable.
	* gettext/po/Makefile.devel (DSOURCES): Remove errdjgpp.
	* FILES.1: Update.

2000-03-08  Martin Atzmueller  <marty@cs.utexas.edu>

	* posix.lsp (resolve-host-ipaddr):
	use :addrtype everywhere
	(hostent): define struct-slot "addrtype" instead of "addr-type"

2000-03-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* describe.lsp (describe-object) [FUNCTION]: If the function's name
	  names a macro, recommend (DISASSEMBLE (MACRO-FUNCTION 'name))
	  instead of (DISASSEMBLE #'name).
	  Reported by Tijs van Bakel <smoke@casema.net>.

2000-03-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (make_terminal_stream_, rl_memory_abort): Use
	  rl_gnu_readline_p instead of rl_present_p.
	(init_streamvars): Call _rl_enable_paren_matching.
	* noreadline.d (rl_gnu_readline_p): Renamed from rl_present_p.

2000-03-03  Sam Steingold  <sds@gnu.org>

	* clhs.lsp (browse-url): expanded error message.

2000-03-02  Sam Steingold  <sds@gnu.org>

	* clos.lsp (slot-names): new function.
	* describe.lsp (describe-slotted-object): use it.
	(list-length-dotted): new function.
	(describe-object): use it.

2000-03-01  Sam Steingold  <sds@gnu.org>

	* clhs.lsp, clhs.txt: new files.
	* init.lsp: load clhs.

2000-02-29  Sam Steingold  <sds@gnu.org>

	* loop.lsp (destructure-vars, destructure-type): use tail recursion.

2000-02-28  Martin Atzmueller  <marty@cs.utexas.edu>

	* reploop.lsp: new and shorter debugger/stepper/main commands;
	('error :e) command for printing the error-message again;
	('backtrace-l, :bl, 'frame-limit, :fl) implemented something
	similar to the "print-frame-limit"-issue in the TODO list.g
	translated the comments.

2000-02-18  Sam Steingold  <sds@gnu.org>

	Implemented the ANSI CL `with-compilation-unit' macro.
	* compiler.lsp (with-compilation-unit): new macro.
	(*c-top-call*): new variable.
	(c-report-problems, c-reset-globals): new functions.
	(compile-file): use them.
	(init.lsp, defs3.lsp): export `with-compilation-unit'.

2000-03-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* Version 2000-03-06 released.

2000-03-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* unix.d: Use clock_t instead of CLOCK_T.
	* encoding.d: Include <string.h>.
	* hashtabl.d (hashcode4_atom): Add default case to switch statement.

2000-03-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* dutch.lsp: New file, from Tijs van Bakel <smoke@casema.net>.
	* init.lsp: Load it.
	* makemake.in (LPARTS): Add dutch.
	* spvw_language.d (language_dutch): New macro.
	(init_language_from): Test for values NEDERLANDS and DUTCH.
	(init_language): Deal with language_dutch.

2000-03-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d (charset_range): Define only if #ifdef UNICODE.
	(init_encodings): Initialize O(internal_encoding) only if #ifdef
	  UNICODE.
	* stream.d (FILE-STRING-LENGTH): If UNICODE is not defined, assume
	  min_bytes_per_char and max_bytes_per_char to be 1.

2000-03-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (SOCKET-SERVER): In the error message, output the argument,
	  not the symbol STREAM.

2000-03-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* defmacro.lsp (macro-call-error): Add missing ~S to English
	translation.
	* describe.lsp (describe-object): Fix English message.
	Reported by Tijs van Bakel <smoke@casema.net>.

2000-02-29  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (sbNvector_atype, bNvector_atype, type_bits_to_atype):
	  New macros.
	* array.d (copy_sbvector, array_element_type, test_displaced): Use
	  sbNvector_atype and bNvector_atype.
	* hashtabl.d (hashcode_bvector): Use sbNvector_atype.
	* sequence.d (get_seq_type): Use sbNvector_atype and bNvector_atype.

2000-02-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Don't install emacs/*.el any more.

2000-02-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* arimips.d (subx_loop_down): If compiling for n32 ABI, the fifth
	  argument comes in a register, not from the stack.

2000-02-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (oint_symbolflags_shift): Remove obsolete definition.

2000-01-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Permit setting *terminal-encoding* to an iconv based stream.
	* lispbibl.d (set_terminalstream_external_format): New declaration.
	* stream.d (set_terminalstream_external_format): New function.
	* encoding.d (SYSTEM::SET-FOREIGN-ENCODING): Call it.

2000-01-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* errunix.d (init_errormsg_table): Add EILSEQ.

2000-01-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d (encoding_from_name): Recognize ISO-8859-3.

2000-01-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* configure: Create a libiconv subdirectory, link over the configure
	  script, and run it with --enable-static --disable-shared.
	* win32msvc/INSTALL: Must pre-build libiconv.
	* makemake.in (USE_LIBICONV, XCL_ICONVLIB): New variables.
	(FILES): On Unix, add libiconv.a.
	(LIBS): Ad $XCL_ICONVLIB.
	(EVERY_INCLUDES_H): Add iconv.h.
	(iconv.h, libiconv.a): New targets.
	(clean1): Also remove libiconv.a.
	(clean4): Also remove iconv.h.
	* lispbibl.d (GNU_LIBICONV): Define always. Include "iconv.h".
	(max_bytes_per_chart): Increase to 8, for ISO-2022-CN[-EXT].
	* stream.d: Treat GNU_LIBICONV like HAVE_ICONV.
	(CLISP_INTERNAL_CHARSET): If using GNU_LIBICONV, define to
	  "UCS-2-INTERNAL".
	(iconv_init): New macro.
	(iconv_mblen): After iconv_open, call iconv_init. Treat E2BIG
	  correctly.
	(iconv_mbstowcs): After iconv_open, call iconv_init. Eliminate gcc
	  warning.
	(iconv_wcslen): After iconv_open, call iconv_init. Treat E2BIG
	  correctly.
	(iconv_wcstombs): After iconv_open, call iconv_init.
	(iconv_range): Likewise.
	(ChannelStream_init): Likewise.
	* pseudofun.d: Treat GNU_LIBICONV like HAVE_ICONV.
	* constsym.d: Add MACINTOSH alias. Add symbols for newly imported
	  encodings from libiconv.
	* encoding.d: Treat GNU_LIBICONV like HAVE_ICONV.
	(iconv_first_sym, iconv_last_sym, iconv_num_encodings): New macros.
	(MAKE-ENCODING): For iconv-based encodings, use max_bytes_per_chart,
	  not 6.
	(init_encodings): Define CHARSET:MACINTOSH and all symbols
	  corresponding to new imported encodings from libiconv.
	(encoding_from_name): Map "eucJP" etc. to the new encodings.
	* type.lsp (table filled by get-charset-range): Avoid filling the
	  cache with large interval lists (comparatively easy to compute).
	* Makefile.devel (CONFIGURES): Add libiconv/configure.
	(libiconv/autoconf/aclocal.m4, libiconv/configure): New rules.

2000-01-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* utils/unicode/Makefile (ALL): Add nls_iso8859_16.c.
	(nls_iso8859_16.c): New rule.
	* nls_iso8859_16.c: New file.
	* encoding.d: Include nls_iso8859_16.c.
	(nls_tables): Add nls_iso8859_16.
	(encoding_from_name): Accept ISO-8859-16.
	* pseudofun.d (nls_iso8859_16_table): New entry.
	* makemake.in (NLS_INCLUDES): Add nls_iso8859_16.

2000-01-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* src/asmi386.sh: Terminate the here documents with EOF, not \EOF.

2000-01-15  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* modules/regexp/regexp.lsp (regexp-exec): Remove wrong declaration.

2000-01-12  Sam Steingold  <sds@gnu.org>

	* modules/regexp/regexp.lsp (regexp-compile): use `assert'
	(regexp-exec): `assert' that `string'  is a string

2000-01-10  Sam Steingold  <sds@gnu.org>

	* posixmisc.d: new file
	* unixaux.d (sysinfo_, resource_usage_limits_): moved to
	posixmisc.d

1999-12-31  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pathname.d (translate_version): Don't access Car(*subst) before
	  checking whether consp(*subst).

1999-12-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_ctype.d (init_ctype): Recognize more language codes:
	  "af" (afrikaans), "ca" (catalan), "eu" (basque), "fo" (faeroese),
	  "ga" (irish), "gd" (scottish), "gl" (galician), "sq" (albanian),
	  "eo" (esperanto), "mt" (maltese), "be" (byelorussian),
	  "et" (estonian), "lt" (lithuanian), "lv" (latvian), "uk" (ukrainian).
	  Recognize more aliases: "english", "slovenian", "macedonian",
	  "serbian", "arabic".
	  Change default: KOI8-R for "ru" (russian) instead of ISO-8859-5,
	  ISO-8859-5 for "sr" instead of ISO-8859-2.

1999-12-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* utils/unicode/Makefile (ALL): Add nls_koi8_u.c.
	(nls_koi8_u.c): New rule.
	* nls_koi8_u.c: New file.
	* spvw_ctype.d (init_ctype): Accept KOI8-U.
	* encoding.d: Include nls_koi8_u.c.
	(nls_tables): Add nls_koi8_u.
	(encoding_from_name): Accept KOI8-U.
	* pseudofun.d (nls_koi8_u_table): New entry.
	* makemake.in (NLS_INCLUDES): Add nls_koi8_u.

1999-12-29  Sam Steingold  <sds@gnu.org>

	* unixaux.d (sysinfo_): added _SC_THREAD_THREADS_MAX
	* posix.lsp (sysinfo): ditto

1999-12-28  Sam Steingold  <sds@gnu.org>

	* posixmath.d: redefine `floor' correctly
	(to_double, N_D): use functions instead of macros
	* posix.lsp: `print-object' for `rlimit' and `user-data'
	* init.lsp: load posix after clos
	* eval.d: removed all syscalls
	* constpack.d: added package POSIX
	* spvw.d, package.d: removed POSIX

1999-12-23  Sam Steingold  <sds@gnu.org>

	* subr.d, constsym.d: added `bogomips' and `resource_usage_limits_'
	* posix.lsp: export `bogomips' and `resource-usage-limits',
	reduce `sysinfo'
	* posixmath.d (bogomips): LISPFUNN now
	* unixaux.d (sysinfo): use uname(2) instead of sysinfo(2),
	(resource_usage_limits_): new LISPFUNN

1999-12-22  Sam Steingold  <sds@gnu.org>

	* unixaux.d (sysinfo): new function
	* subr.d, constsym.d: added `sysinfo'
	* eval.d: removed the posix functions
	* init.lsp: load the new file posix.lsp
	* posix.lsp: new file
	* makemake.in (LPARTS): added posix
	* pathname.d (user_data_): require argument
	* posixmath.d (bogomips): new function
	* socket.d (resolve_host_ipaddr_): require argument

1999-12-21  Sam Steingold  <sds@gnu.org>

	* posixmath.d: new file; erf(3m), bessel(3m) and gamma(3m)
	are now accessible in the package POSIX with --export-syscalls.
	* makemake.in, gettext/po/Makefile.devel: added `posixmath'.
	* lisparit.d: include posixmath.c.
	* subr.d, eval.d, constsym.d: added the functions.
	* constobj.d, package.d (init_packages), spvw.d
	(init_symbol_tab_2): added package POSIX.
	* socket.d (resolve_host_ipaddr): moved to POSIX.
	* pathname.d (file_stat, user_data): ditto.
	* compiler.lsp (c-DIRECT-FUNCTION-CALL): mention the arithmetic
	functions.
	(*deprecated-functions-list*): do not deprecate functions in POSIX.
	* init.lsp: export the functions from POSIX.

1999-12-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (iconv_wcslen): At the end, call iconv with NULL input.
	(iconv_wcstombs): At the end of the standalone case, call iconv with
	  NULL input.
	(oconv_unshift_output_unbuffered): New macro.
	(oconv_unshift_output_unbuffered_): New function.
	(finish_output_unbuffered, force_output_unbuffered, close_ochannel):
	  Call oconv_unshift_output_unbuffered.
	(oconv_unshift_output_buffered): New macro.
	(oconv_unshift_output_buffered_): New function.
	(finish_output_buffered, close_buffered): Call
	  oconv_unshift_output_buffered.

1999-12-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_WORDS_LITTLEENDIAN): Update for
	  autoconf-2.12. Use AC_CACHE_CHECK instead of AC_CHECK_VAL.

1999-12-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_ICONV): Check for the iconv function twice,
	  once in libc and once in libiconv, for OSF/1 and FreeBSD. Define
	  LIBICONV.
	* makemake.in: Use @LIBICONV@ like @LIBTERMCAP@ and @LIBDL@.

1999-12-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* utils/unicode/ftp.unicode.org/UnicodeData.txt: Upgrade to Unicode
	  version 3.0.

1999-12-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* utils/unicode/Makefile: Use plain-text tables instead of *.in files.
	* utils/unicode/nls_table.c: New file.
	* utils/unicode/nls_table.java, utils/unicode/nls_txt_to_in.java:
	  Remove files.
	* utils/unicode/ftp.unicode.org/*.TXT: Remove files.

1999-12-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (iconv_mbstowcs, iconv_wcstombs): When called from a
	  stream, and when valid data is followed by invalid data (EILSEQ),
	  return the converted valid data and don't signal an error yet.

1999-11-30  Sam Steingold  <sds@gnu.org>

	* spvw.d (init_object_tab): add :SYSCALLS to *FEATURES* when
	EXPORT_SYSCALLS is defined.

1999-11-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d (utf8_mblen, utf8_mbstowcs): Make the UTF-8 decoder
	  "safe": Reject overlong byte sequences.

1999-11-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (char_width): New declaration.
	* charstrg.d (non_spacing_table_data, nonspacing_table_ind): New
	  arrays.
	(char_width, CHAR-WIDTH, STRING-WIDTH): New functions.
	* stream.d (wr_ss_lpos): Call char_width instead of graphic_char_p.
	  Don't assume every character increases the line position by 1.
	(write_char): Likewise.
	* io.d (pphelp_string_width): New function.
	(justify_end_eng, justify_end_weit): Use pphelp_string_width instead
	  of the string's length.
	* compiler.lsp (subr-info): Add char-width and string-width.
	* describe.lsp (write-to-short-string): Use string-width instead of
	  the string's length.
	* format.lsp (format-padded-string, format-justified-segments):
	  Likewise.

1999-11-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (Array_type_simple_bit_vector): New macro.
	(simple_bit_vector_p, bit_vector_p): Use it.
	* spvw_typealloc.d (allocate_bit_vector): Likewise.

1999-11-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* asmi386.sh and others: Use temporary files for the sed scripts.
	  GNU sed-2.05 concatenates multiple -e options to a single script
	  with embedded newlines, GNU sed-3.02 does not.

1999-11-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* autoconf/acgeneral.m4 (AC_ARG_PROGRAM): Create `conftestsed' once
	  only.

1999-11-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pathname.d (directory_diff_ab): Set new_piece to
	(cons ':directory subdirs), not (list ':directory subdirs).

1999-11-08  Valeriy E. Ushakov  <uwe@ptc.spbu.ru>

	* lispbibl.d (NEED_temp_mv_count, NEED_temp_value1): Define if
	  SPARC && UNIX_NETBSD.

1999-11-10  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (TheSarray, TheSbvector, TheCodevec): Fix typo.

1999-11-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* modules/clx/mit-clx/clx.lsp (base-char): Don't redefine in CLISP.

1999-11-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* affi.d (affi_call_argsa): Treat simple 8/16/32-bit-vectors like
	  non-simple ones. Use array_displace_check instead of
	  iarray_displace_check.
	* stream.d (test_n_bytes_args): Use array_displace_check instead of
	  iarray_displace_check.
	* sequence.d (READ-BYTE-SEQUENCE, WRITE-BYTE-SEQUENCE): Likewise.

1999-10-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* conditio.lsp (define-condition): Accept a :DEFAULT-INITARGS option.

1999-10-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (elt_reverse, elt_nreverse): New declarations.
	* array.d (elt_reverse, elt_nreverse): New functions.
	* sequence.d (REVERSE): For vectors, use elt_reverse.
	(NREVERSE): For vectors, use elt_nreverse.

1999-10-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (uint1_p, uint2_p, uint4_p): New macros.
	(fehler_index_range, fehler_store, elt_copy, elt_move, elt_fill):
	  New declarations.
	* array.d (fehler_index_range): Make global.
	(fehler_store): New function, taken out of storagevector_store.
	(storagevector_store): Call it.
	(bit_copy, elt_copy_*_*, elt_copy): New functions.
	(elt_move_*, elt_move): New functions.
	(elt_fill): New function.
	(VECTOR-PUSH-EXTEND): Use the elt_copy_*_* functions.
	(ssbvector_push_extend): Use elt_copy_8Bit_8Bit.
	(make_storagevector): Use elt_fill.
	(reshape): Use elt_copy for speedup.
	* sequence.d (fehler_vector_index_range): New function.
	(copy_seqpart_into): For vectors, use elt_copy or elt_move.
	(MAKE-SEQUENCE, FILL): For vectors, use elt_fill.

1999-10-29  Sam Steingold  <sds@ksp.com>

	* modules/regexp/regexp.lsp (with-loop-split): New macro.
	(regexp-compile, regexp-exec, regexp-split): New functions.
	(match-once, %match): Use `regexp-compile' and `regexp-exec'.
	(regexp-compile, regexp-exec, regexp-split, with-loop-split): Export.

1999-10-22  Sam Steingold  <sds@ksp.com>

	* modules/clx/new-clx/demos/clx-demos.lsp (x-host-display):
	return 3 values (host, server, screen).
	Compile `qix' and `socoban' when compiling `clx-demos'.

1999-10-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* array.d (bit_op): Fix memory overrun bug. Require count > 0.
	(bit_up): Test for len==0 before calling bit_op.

1999-10-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* array.d (bit_compare): Fix memory overrun bug. Require count > 0.
	  Optimize the case index1 == index2 mod 8.
	* lispbibl.d (bit_compare): Require count > 0.
	* predtype.d (equal): Test for len1==0 before calling bit_compare.

1999-10-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d: Use __sun, not __sun__, as a test for Solaris.

1999-10-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* array.d (bit_compare, bit_op): Use `const'.

1999-10-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* array.d (bitpack, uint_bitpack, ...): Use 32-bit words if possible.

1999-10-18  Sam Steingold  <sds@ksp.com>

	* modules/clx/new-clx/demos/clx-demos.lsp: new file.
	define the clx-demos package and load the other demos.
	(getenv): get the environment variable.
	(x-host-display): parse $DISPLAY.
	(x-open-display): open the display according to $DISPLAY.
	* modules/clx/new-clx/demos/qix.lsp (qix): use `x-open-display'.
	* modules/clx/new-clx/demos/sokoban.lsp (init-sokoban): use
	`x-open-display'.

1999-10-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Introduce new primitive types for simple vectors with element-type
	(UNSIGNED-BYTE n), n = 2,4,8,16,32.
	* lispbibl.d (STANDARD_8BIT_TYPECODES): Define sb2vector_type etc.
	  and b2vector_type etc. Define case_sb2vector, case_ob2vector,
	  case_b2vector etc.
	(case_array): Include case_b2vector etc.
	(Rectype_b2vector, Rectype_Sb2vector, etc.): New rectype values.
	(arrayflags_notbytep_bit): Remove.
	(Array_type_b2vector, Array_type_sb2vector, etc.): New macros.
	(TheSarray, TheSbvector): Add sb2vector_type etc.
	(TheCodevec): Needs only s8bvector_type.
	(TheIarray): Add b2vector_type etc.
	(TheVarobject, ThePointer): Add sb2vector_type, b2vector_type, etc.
	(vectorp, simplep, array_simplep, simple_string_p, stringp): Update
	  for changed Rectype values.
	(simple_bit_vector_p, bit_vector_p): Take two arguments now.
	(byte_vector_p, general_byte_vector_p): Remove macros.
	(arrayp): Update for changed Rectype values.
	(cclosurep): Assume the codevector is an 8bit-vector.
	(case_Rectype_Sb2vector_above, case_Rectype_ob2vector_above,
	   case_Rectype_b2vector_above, etc.): New macros.
	(allocate_bit_vector): Take two arguments now.
	(DYNAMIC_BIT_VECTOR): Update.
	(allocate_byte_vector): Remove declaration.
	* spvw_objsize.d (size_sb2vector etc.): New macros.
	(objsize): Add cases for sb2vector, ob2vector, etc.
	(objsize_sb2vector etc.): New inline functions.
	(init_objsize_table): Add cases for sb2vector, ob2vector, etc.
	* spvw_global.d (init_mem_heaptypes): Add cases for sb2vector,
	  ob2vector, etc.
	* spvw_genera1.d (walk_area): Add cases for ob2vector etc. and
	  Rectype_b2vector, Rectype_Sb2vector etc.
	(build_old_generation_cache): Add cases for ob2vector etc. and
	  Rectype_b2vector, Rectype_Sb2vector etc.
	* spvw_update.d (update_varobject): Add cases for ob2vector etc. and
	  Rectype_b2vector, Rectype_Sb2vector etc.
	* spvw_garcol.d (gc_mark): Add cases for sb2vector, ob2vector, etc.
	  and Rectype_b2vector, Rectype_Sb2vector etc.
	* spvw_typealloc.d (allocate_bit_vector): Take two arguments now.
	(allocate_handle): Update.
	* spvw_circ.d (get_circ_mark): Add cases for b2vector etc. and
	  Rectype_b2vector etc.
	(get_circ_unmark): Likewise.
	(subst, subst_circ_mark, subst_circ_unmark): Likewise.
	* array.d (copy_sbvector): Make it work with any simple-[n]bit-vector.
	(allocate_byte_vector): Remove function.
	(iarray_displace, iarray_displace_check, array_displace_check):
	  Remove special treatment of indirect byte-arrays.
	(storagevector_aref, storagevector_store): Update: storage-vectors
	  are now always simple.
	(array_element_type): Update.
	(BIT, SBIT): Likewise.
	(bit_up): Simplify: Array_type_bvector now implies Atype_Bit. Don't
	  set arrayflags_notbytep_bit.
	(VECTOR-PUSH-EXTEND): Use allocate_bit_vector in place of
	  allocate_byte_vector.
	(allocate_bit_vector_0): Update.
	(make_ssstring): Don't set arrayflags_notbytep_bit.
	(make_ssbvector): Create an 8Bit vector.
	(ssbvector_push_extend): Update.
	(make_storagevector): Use allocate_bit_vector in place of
	  allocate_byte_vector.
	(test_displaced): Update.
	(MAKE-ARRAY): Update. Don't set arrayflags_notbytep_bit.
	(reshape): Update.
	(SYS::MAKE-BIT-VECTOR): Update.
	* eval.d (get_closure): Create an 8Bit vector.
	(eval_closure, apply_closure, funcall_closure): Assume the
	  codevector is an 8bit-vector.
	* record.d (SYS::CLOSURE-CODEVEC): Likewise.
	(SYS::MAKE-CODE-VECTOR): Create an 8bit-vector.
	(SYS::%MAKE-CLOSURE): Assume the codevector is an 8bit-vector.
	* hashtabl.d (hashcode_bvector): Remove special treatment of indirect
	  byte-arrays.
	(hashcode3_atom): Treat sb2vector_type, b2vector_type etc. and
	  Rectype_Sb2vector, Rectype_b2vector etc.
	(hashcode4_vector_2Bit etc.): Remove ->data indirection for storage
	  vectors.
	(hashcode4_vector): Update.
	(hashcode4_atom): Treat b2vector_type etc. and Rectype_b2vector etc.
	(sxhash_atom): Likewise.
	* predtype.d (equal): Simplify: Array_type_bvector now implies
	  Atype_Bit.
	(elt_compare_T_2Bit etc., elt_compare_Bit_2Bit etc. etc.): Remove
	  ->data indirection for storage vectors.
	(elt_compare): Update.
	(equalp): Treat b2vector_type etc. and Rectype_b2vector etc.
	(BIT-VECTOR-P, SIMPLE-BIT-VECTOR-P): Update.
	(TYPE-OF, CLASS-OF): Simplify: case_obvector now implies Atype_Bit.
	  Treat sb2vector etc. and ob2vector etc. and Rectype_Sb2vector etc.
	  and Rectype_ob2vector etc.
	(COERCE): Update. Optimize treatment of result-type = ARRAY/VECTOR/
	  SIMPLE-ARRAY.
	(enum_hs_simple_2bit_vector etc., enum_hs_2bit_vector): New enum
	  items.
	(enum_hs_byte_vector): Remove enum item.
	(heap_statistics_mapper): Update. Treat sb2vector etc. and ob2vector
	  etc. and Rectype_Sb2vector etc. and Rectype_ob2vector etc.
	* init.lsp: Export simple-2bit-vector etc. and 2bit-vector etc. Don't
	  export BYTE-VECTOR.
	* sequence.d (get_seq_type): Update.
	(READ-BYTE-SEQUENCE, WRITE-BYTE-SEQUENCE): Remove ->data indirection
	  for storage vectors.
	* io.d (allocate_syntax_table): Allocate an 8Bit-vector.
	(init_reader): Don't set arrayflags_notbytep_bit.
	(test_dots, read_internal, uninterned_reader): Assume an 8bit-vector.
	(bit_vector_reader, array_reader, structure_reader, closure_reader):
	  Update.
	(prin_object_dispatch): Treat b2vector like normal vector.
	(pr_orecord): Likewise.
	(pr_closure, pr_cclosure_codevector): Assume the codevector is an
	  8bit-vector.
	* encoding.d (string_to_asciz, string_to_asciz_): Create an
	  8bit-vector.
	* stream.d (make_unbuffered_stream, make_buffered_stream): Update.
	(rd_ch_terminal3): Assume ASCIZ-Strings are 8bit-vectors.
	(test_n_bytes_args): Simplify test for 8bit-vector.
	(SYS::READ-N-BYTES, SYS::WRITE-N-BYTES): Remove ->data indirection.
	(SYSTEM::BUILT-IN-STREAM-SET-ELEMENT-TYPE): Update.
	* lisparit.d (make_random_state): Update.
	* pathname.d (EXECUTE): Assume ASCIZ-Strings are 8bit-vectors.
	* foreign.d (convert_from_foreign_array_fill): Remove ->data
	  indirection.
	(convert_to_foreign): Simplify test for 8/16/32bit-vector. Remove
	  ->data indirection.
	* affi.d (affi_call_argsa, SYSTEM::MEM-READ, SYSTEM::MEM-WRITE-VECTOR):
	  Update. Simplify test for 8/16/32bit-vector.

1999-10-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make the TYPECODES model more extensible.
	* lispbibl.d (SUN4_29_1, SUN4_29_2, ACORN_1, ACORN_2, UNIX_SYSV_UHC_2):
	  Remove definitions.
	(TYPECODES): Don't define if we can force alignof(subr_) = 4.
	(oint_type_mask, oint_addr_mask): Remove most old, hand-determined
	  definitions.
	(TB7, ..., TB0): Never define TB5 to -1.
	(SUN3_TYPECODES, PACKED_TYPECODES, STANDARD_TYPECODES,
	   SIXBIT_TYPECODES, SEVENBIT_TYPECODES): Remove all. Replace with
	  STANDARD_8BIT_TYPECODES.
	(BTB7, ..., BTB0): Define.
	(addressbus_mask): Use SUN4_29 instead of SUN4_29_1.
	(subr_): Force alignment 4 if necessary.
	(vectorp, simplep, array_simplep, arrayp): Update for new typecodes.
	* genclisph.d (subr_): Force alignment 4 if necessary.
	(vectorp, arrayp): Update for new typecodes.
	* spvw.d (init_subr_tab_1): If NO_TYPECODES, verify subr_ alignment.
	* spvw_memfile.d (memflags): Update.

1999-10-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_garcol.d (update): Insert braces to avoid gcc warning.

1999-10-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* arilev0.d (sign_of_sint32): For SPARC64, define using shifts.
	(sign_of_sint16): Likewise.
	(mulu16): For SPARC64, use the builtin "umul".
	(mulu16_): Like for SPARC, also for SPARC64.
	(mulu24): For SPARC64, use the builtin "umul".
	(mulu32_): Like for SPARC, also for SPARC64.
	(divu_3216_1616, divu_3232_3232, divu_6432_3232, divu_32_rest,
	   isqrt_64_32): Like for SPARC, also for SPARC64.
	* intlog.d (integerlength8, integerlength16, integerlength32, ord2_32):
	  Don't use SPARC32 version for SPARC64.

1999-10-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* utils/unicode/Makefile: Add nls_jisx0201.c to the targets.
	  In the iso-8859-* tables, don't make 0x80..0x9F invalid.
	  Generate nls_koi8_r.c from the ftp.unicode.org table.
	* encoding.d: Include nls_jisx0201.c.
	(nls_tables): Add nls_jisx0201_table.
	(nls_last_sym, nls_num_encodings): Update.
	* pseudofun.d (nls_jisx0201_table): New entry.
	* makemake.in (NLS_INCLUDES): Add nls_jisx0201.

1999-10-15  Sam Steingold  <sds@ksp.com>

	* modules/clx/new-clx/clx.f (get_font_info_and_display): fixed a
	typo (xatom --> xatoms).

1999-10-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (low_finish_output_unbuffered_socket,
	   low_force_output_unbuffered_socket,
	   low_clear_output_unbuffered_socket): Remove functions.
	(UnbufferedSocketStream_output_init): Use the equivalent pipe
	  functions instead. Use low_write_unbuffered_pipe instead of
	  low_write_unbuffered_handle.
	(low_flush_buffered_socket): Use low_flush_buffered_pipe instead of
	  low_flush_buffered_handle.
	* errunix.d (init_errormsg_table): Change message for EPIPE.

1999-10-05  Sam Steingold  <sds@ksp.com>

	* socket.d (ADDR_TO_STRING): new macro
	(HOSTENT_TO_STACK): use it

1999-09-30  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* genclisph.d (main): Define minus_bit, needed for minus_wbit. Define
	  minus_wbit, needed for framecode. In end_callback, use `framecode'
	  instead of `mtypecode'. Define uintP, needed for framebottomword,
	  needed for finish_frame, needed for begin_callback.

1999-09-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (c-GLOBAL-FUNCTION-CALL): When pushing forms onto
	  *package-tasks*, quote the arguments only when necessary.

1999-09-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* io.d (SET-DISPATCH-MACRO-CHARACTER): Call up_case on sub_char.
	(GET-DISPATCH-MACRO-CHARACTER): Likewise.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (UnbufferedStreamLow_pushfront_byte): Increment status
	  by 1, not by 2.
	(rd_ch_terminal3): Before calling readline(), stuff the pre-read
	  byte into readline's input buffer.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_CONNECT): For namelen, also try the type `socklen_t'.
	  Needed on 64-bit Solaris.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (iconv_wcslen, iconv_wcstombs): Call end_system_call()
	  before signalling an error.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (fehler_uint8): Declare always, not only ifdef HAVE_FFI.
	* error.d (fehler_uint8): Define always, not only ifdef HAVE_FFI.

	* intelem.d (Q_to_I): Define if defined(intQsize), not only if
	  defined(HAVE_FFI) && defined(intQsize). It's needed by DF_to_I.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* io.d (klammer_auf, klammer_zu, justify_start, justify_space,
	   justify_end_eng, justify_end_weit, indent_start, indent_end,
	   indentprep_start, indentprep_end, pr_enter1): Test for
	  builtin_stream_p before accessing ->strmtype.
	* encoding.d (SYSTEM::SET-TERMINAL-ENCODING): Likewise.
	* stream.d (CONCATENATED-STREAM-STREAMS, TWO-WAY-STREAM-INPUT-STREAM,
	   TWO-WAY-STREAM-OUTPUT-STREAM, ECHO-STREAM-INPUT-STREAM,
	   ECHO-STREAM-OUTPUT-STREAM): Likewise.
	(SYSTEM::BUILT-IN-STREAM-SET-ELEMENT-TYPE): If the synonym stream's
	  target is a Gray stream, recurse through (SETF STREAM-ELEMENT-TYPE).

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_language.d (init_language): Use `ascii_alphanumericp' instead
	  of `alphanumericp'.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_module.d (main_module): Fix type of declaration. Declare extern,
	  to avoid a warning.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* arisparc64.d: Take advantage of the brz and brnz instructions.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* arisparc.d (orc2_loop_up): Use the `orn' instruction.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_CANONICAL_HOST_CPU, CL_CANONICAL_HOST_CPU_FOR_FFCALL):
	  Tweak test for 64-bit sparc: cc defines `__sparcv9', whereas gcc
	  defines `__arch64__'.
	* lispbibl.d (SPARC64): Likewise.

1999-09-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_memfile.d (loadmem): Before quitting, close handle if needed.
	(loadmem_from_handle): Before quitting, always close handle.

1999-08-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_SIGNAL_REINSTALL, CL_SIGACTION_REINSTALL): Enable
	  `volatile' for gotsig.

1999-08-15  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* utils/varbrace.d: New file.
	* makemake.in (NEED_ANSIDECL): Remove variable.
	(VARBRACE): New Makefile variable.
	(UTILS, XDECL_FILTER, XDECL_DEPENDENCIES): Add `varbrace'.
	* spvw_memfile.d (loadmem_from_handle): Define this function always,
	  not only on UNIX.
	* spvw_sigint.d (react_on_sigint): New function.
	(interrupt_handler, alarm_handler): Use it. Remove #if across
	  function bodies.

	* utils/modprep.d (is_if): Check for "#ifndef" as well.

1999-08-15  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* ansidecl.d (char_out, next_token, handle_closing_token): Turn
	  macros into inline function definitions. Speed doesn't matter here.

1999-08-14  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Assume size_t, pid_t, uid_t, gid_t, off_t are defined.
	* aclocal.m4 (CL_GETPWUID): Don't depend on AC_TYPE_UID_T.
	(CL_MMAP): Don't depend on AC_TYPE_SIZE_T, AC_TYPE_OFF_T.
	* configure.in: Don't call AC_TYPE_SIZE_T, AC_TYPE_PID_T,
	  AC_TYPE_UID_T, AC_TYPE_OFF_T.
	* unixconf.h.in: Don't define size_t, pid_t, uid_t, off_t.

	No compiler expands __builtin_strcmp inline.
	* aclocal.m4 (CL_BUILTIN_STRCMP): Remove.
	* configure.in: Don't call CL_BUILTIN_STRCMP.
	* unixconf.h.in: Don't define HAVE_BUILTIN_STRCMP.
	* lispbibl.d (asciz_equal): Don't define as a macro.
	* spvw.d (asciz_equal): Define as a function always.

	Assume clock_t is defined.
	* aclocal.m4 (CL_CLOCK_T): Remove.
	* configure.in: Don't call CL_CLOCK_T.
	* unixconf.h.in: Don't define CLOCK_T.
	* acorn.d: Likewise.
	* time.d (get_run_time): Use clock_t instead of CLOCK_T.

	Assume mode_t is defined.
	* aclocal.m4 (CL_MKDIR): Don't determine MODE_T, use mode_t instead.
	(CL_OPEN): Use mode_t instead of MODE_T. Don't depend on CL_MKDIR.
	* unixconf.h.in: Don't define MODE_T.
	* unix.d: Use mode_t instead of MODE_T.
	* unixaux.d (nonintr_open): Likewise.

	Assume ISC and Minix are dead.
	* configure.in: Don't call AC_ISC_POSIX and AC_MINIX.
	* unixconf.h.in: Don't define _POSIX_SOURCE, _POSIX_1_SOURCE, _MINIX.

	Assume rename() is available.
	* aclocal.m4 (CL_RENAME): Don't test for rename.
	* unixconf.h.in: Don't define HAVE_RENAME.
	* unix.d: Assume rename exists.
	* unixaux.d (rename): Remove function.

	Assume <stdlib.h> exists.
	* aclocal.m4 (CL_ACCESSFLAGS, CL_OPENFLAGS, RL_TERM, CL_MEMSET,
	   CL_MALLOC, CL_FREE, CL_SIGPROCMASK, CL_SIGNAL_REINSTALL,
	   CL_SIGNAL_UNBLOCK, CL_SIGNAL_BLOCK_OTHERS, CL_SIGACTION_REINSTALL,
	   CL_SIGACTION_UNBLOCK, CL_ABORT, CL_GETENV, CL_PUTENV, CL_SETLOCALE,
	   CL_RLIMIT, CL_VFORK, CL_EXECV, CL_EXECL, CL_WAITPID, CL_RUSAGE,
	   CL_GETCWD, CL_CHDIR, CL_MKDIR, CL_RMDIR, CL_FSTAT, CL_STAT,
	   CL_LSTAT, CL_READLINK, CL_ELOOP, CL_OPENDIR, CL_CLOSEDIR, CL_OPEN,
	   CL_READ_WRITE, CL_WRITE, CL_CHMOD, CL_RENAME, CL_UNLINK, CL_IOCTL,
	   CL_SELECT, CL_SETITIMER, CL_LOCALTIME, CL_GETPWNAM, CL_GETPWUID,
	   CL_GETHOSTNAME, CL_GETHOSTBYNAME, CL_ADDRESS_RANGE, CL_MMAP,
	   CL_MPROTECT, CL_CODEEXEC, CL_SHMGET, CL_SHMAT, CL_SHMCTL,
	   CL_SHM_RMID, CL_DYNLOAD, CL_ICONV, CL_FILECHARSET):
	  Assume <stdlib.h> exists.
	(CL_STDLIB_H): Remove.
	* configure.in: Don't call CL_STDLIB_H.
	* unixconf.h.in: Don't define HAVE_STDLIB_H.

	Assume <stddef.h> exists.
	* aclocal.m4 (CL_STDDEF_H): Remove.
	* configure.in: Don't call CL_STDDEF_H.
	* unixconf.h.in: Don't define HAVE_STDDEF_H.

	Assume waitpid() is available.
	* aclocal.m4 (CL_WAITPID): Don't test for waitpid or <sys/wait.h>.
	* unix.d: Assume waitpid exists.
	* unixaux.d (wait2): Likewise.
	* sigcld.d (end_want_sigcld): Likewise.
	* unixconf.h.in: Don't define HAVE_WAITPID and HAVE_SYS_WAIT_H.

	Assume memset() is available.
	* aclocal.m4 (CL_MEMSET): Don't test for memset.
	(CL_SIGACTION_REINSTALL, CL_SIGACTION_UNBLOCK): Assume memset exists.
	* spvw.d: Likewise.
	* unix.d: Likewise.
	* unixaux.d (install_signal_handler): Likewise.
	* unixconf.h.in: Don't define HAVE_MEMSET.
	* win32.d: Likewise.

	* configure.in: Remove AC_C_CONST call.
	* unixconf.h.in (const): Don't define.

	* aclocal.m4 (CL_RAISE): Fix harmless typo.

	* aclocal.m4 (CL_RLIMIT): Prefer RLIMIT_RESOURCE_T="int" to
	  RLIMIT_RESOURCE_T="enum __rlimit_resource".

1999-08-14  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (check_float_eltype, READ-FLOAT, WRITE-FLOAT): New
	  functions.
	* lispbibl.d (c_float_to_FF, FF_to_c_float, c_double_to_DF,
	   DF_to_c_double): Declare always, not only if HAVE_FFI.
	* flo_konv.d (c_float_to_FF, FF_to_c_float, c_double_to_DF,
	   DF_to_c_double): Define always, not only if HAVE_FFI.
	* floatpri.lsp (write-float-decimal): Renamed from write-float.
	* lisparit.d (print_float): Call sys::write-float-decimal instead of
	  sys::write-float.

	* type.lsp (canonicalize-type): Call typespec-error if the argument is
	  not a valid typespec.

1999-08-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aridecl.d (FF_exp_low, FF_exp_mid, FF_exp_high): Always choose the
	  IEEE values.
	(DF_exp_low, DF_exp_mid, DF_exp_high): Likewise.

1999-08-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* modules/clx/new-clx/demos/qix.lsp (draw-qix): Don't ignore nlines.
	  Improve herald message.

1999-08-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pathname.d (PARSE-NAMESTRING): Don't make strong assumptions about
	  the algorithm employed by nreconc. Fixes a bug parsing "~/foo/".

1999-08-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (install_root): New variable.
	(installdirs, install-bin, install-man, install-doc, uninstall-bin,
	   uninstall-man,): Prepend $(install_root) to every installation
	  directory.

1999-07-31  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_ctype.d (init_ctype): Accept "he" as a new name for "iw".

1999-07-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (BINARY_DISTRIB): Also define on HP-UX 10.

1999-07-26  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pathname.d (init_pathnames) [WIN32_NATIVE]: Follow documented
	  calling convention for GetVersionInfoEx.
	* misc.d (MACHINE-VERSION) [WIN32_NATIVE]: Likewise.

1999-07-26  Jörg Höhle  <hoehle@tzd.telekom.de>

	* screen.lsp (generic-stream-read-char-will-hang-p,
	   generic-stream-clear-input): Define the methods on
	  keyboard-controller, not screen-controller.

1999-07-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* Version 1999-07-22 released.

1999-07-21  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* eval.d (interpret_bytecode_) [MC680X0]: Fix syntax error in
	  S_operand_ignore_ macro.

	* charstrg.d (stringof): Change dotimesC into dotimesL.

1999-07-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* init.lsp (load): Put back the call to ENGLISH. Necessary for
	  internationalization.

1999-07-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_RAISE): New macro.
	* unixconf.h.in (HAVE_RAISE): New macro.
	* configure.in: Call it.
	* unix.d (raise): Declare only if HAVE_RAISE is defined.
	* spvw_sigpipe.d (sigpipe_handler): Use kill(getpid(),...) if
	  HAVE_RAISE is not defined.

1999-07-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (distrib): If BINARY_DISTRIB is defined, distribute
	  clisp-link, linkkit, lisp.a etc. nevertheless, because we don't know
	  whether the user has a C compiler or not.

1999-07-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* record.d (CLOS::%ALLOCATE-INSTANCE): Fix typo in error message.

1999-07-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* asmi386.sh: New optional argument -no-C.
	* Makefile.devel (src/ari80386.msvc.c, src/sp80386.msvc.c): Pass
	  option -no-C to asmi386.sh.

1999-07-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (clisp.html): Substitute CLHSROOT, like in impnotes.html.

1999-07-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (wr_ch_unbuffered_dos, wr_ch_buffered_dos): Output crlf
	  only when obj is #\Newline.

1999-07-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* misc.d (MACHINE-VERSION) [WIN32]: On Win95, use info.dwProcessorType.

1999-07-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (XCFLAGS): Add "-fno-gcse" when using gcc-2.95 on Sparc.

1999-07-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw.d (usage): Reorder command line options. Split into groups.

1999-07-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (SPARC64): New macro.
	  Treat SPARC64 mostly like DECALPHA and MIPS64.
	* arisparc64.d: New file.
	* spsparc64.d: New file.
	* arilev0.d (mulu16, mulu32, mulu32_unchecked, divu_3216_1616,
	   divu_3216_3216, divu_3232_3232, divu_6432_3232): Provide
	  implementations for SPARC64, consistently with arisparc64.d.
	* arilev1.d [SPARC64]: Include arisparc64 instead of arisparc.
	* makemake.in (cpu): Possibly set to sparc64.
	(ARI_ASMD, ARI_ASMS): Possibly add arisparc64.
	(SP_ASMD, SP_ASMS): Possibly add spsparc64.
	* FILES.1: Mention arisparc64, spsparc64, arimips64.

1999-07-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Remove support for K&R Sparc cc.
	* makemake.in: If TSYS = sun4 and not compiling with GNU C, assume
	  SunPRO C. Drop dependencies and rules for cc_sparc.il.
	* cc_sparc.il: Remove file.
	* FILES.1: Don't mention cc_sparc.il.

1999-07-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_WORDS_LITTLEENDIAN): Test for `__sparc__',
	  because gcc-2.95 on SparcLinux defines only `__sparc__', not `sparc'.
	* lispbibl.d: Likewise.

1999-07-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_CANONICAL_HOST_CPU,
	   CL_CANONICAL_HOST_CPU_FOR_FFCALL): Distinguish "sparc" and
	  "sparc64" according to the C compiler, not the uname result.

1999-07-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Treat gcc version 3.* like gcc version 2.95.

1999-07-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* arisparc.d (compare_loop_up) [COUNTER_LOOPS]: Bug fix.
	(shiftright_loop_up): Save 1 cycle if count==0.

1999-07-15  Jörg Höhle  <Joerg.Hoehle@gmd.de>

	* affi.d (SYSTEM::MEM-WRITE): No need to check for integerp(wert),
	  it is done later during conversion.

	* socket.d (socket_getpeername): Fix the length argument to
	  gethostbyaddr.

1999-07-15  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* record.d (FINALIZE): Call coerce_function.

1999-07-09  Jörg Höhle  <hoehle@tzd.telekom.de>

	* stream.d (SOCKET-STREAM-HANDLE): Use TheSocket(), not TheHandle().

1999-07-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (low_clear_input_unbuffered_handle) [WIN32]: Set the
	  ignore_next_LF flag after eating a CR.
	(clear_input_unbuffered) [WIN32]: Don't reset the ignore_next_LF
	  flag.

1999-07-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* win32aux.d (interruptible_active): New variable.
	(temp_interrupt_handler): Query it and set it to FALSE.
	(DoInterruptible): Set it to TRUE only while the thread is running.

1999-07-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* misc.d (MACHINE-VERSION) [WIN32]: Use the info.wProcessorLevel field
	  only on WinNT.

1999-07-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Don't access objects in memory through `oint*' pointers.
	* spvw_mark.d (mark, unmark, marked): Use as_object/as_oint
	  conversions instead of oint* memory access.
	* spvw_update.d (update_STACKs): Use as_oint conversion instead of
	  oint* memory access.
	* spvw_garcol.d (gc_mark): Change type of `dies_' to `object*'.
	(gc_mark_stack, alive): Use as_oint conversion instead of oint*
	  memory access.
	(gc_morris3, update, update_stackobj): Use as_object/as_oint
	  conversions instead of oint* memory access.
	* spvw_memfile.d (update, loadmem_update): Likewise.
	* eval.d (nest_var, funcall_iclosure): Likewise.
	* control.d (make_variable_frame, LET, LET*, SYMBOL-MACROLET,
	   MULTIPLE-VALUE-BIND): Likewise.

1999-07-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* utils/gcc-cccp/cccp.c (output_line_command): In the filename
	  being output, convert backslashes to double backslashes.

1999-07-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make sure the default-file-encoding is set to ISO-8859-1 during
	building, even if the user has set a different LC_CTYPE variable.
	* spvw.d (usage): Add -E option.
	(argv_encoding_file, argv_encoding_pathname, argv_encoding_terminal,
	   argv_encoding_foreign, argv_encoding_misc): New variables.
	(main): Add -E option.
	* _clisp.c (main): Handle -E option.
	* makemake.in (interpreted.mem, *.fas, lispinit.mem, lispinit2.mem,
	   testsuite, $(MODULES)): Together with option "-norc", pass
	  "-Efile ISO-8859-1".
	* encoding.d (encoding_from_name): New function, extracted from
	  init_dependent_encodings. Also accept ISO-8859-10/13/14/15.
	(init_dependent_encodings): Call it. Respect the values of
	  argv_encoding_file, argv_encoding_pathname, argv_encoding_terminal,
	  argv_encoding_foreign, argv_encoding_misc.

1999-07-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Fix interpretation of LC_* and LANG environment variables.
	* spvw_ctype.d (init_ctype): Treat empty environment values like
	  unset environment variables. LANG is not supposed to contain colons.
	  The encoding can be followed by other suffixes.

1999-07-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (GENERATIONAL_GC): Don't define on IRIX.

1999-07-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (NLS_INCLUDES): Add nls_iso8859_10, nls_iso8859_13.
	* encoding.d: Include them.
	(nls_tables): Refer to them.
	* pseudofun.d: Likewise.

1999-06-25  Sam Steingold  <sds@goems.com>

	* describe.lsp (apropos): print the macro for symbol-macro, no
	evaluation.
	(describe-object): ditto.
	Also, describe CAR & CDR for a simple cons.

1999-06-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Don't use Unicode API on Win32. It does not work on Win95.
	* lispbibl.d, win32.d, spvw.d, spvw_debug.d, spvw_language.d,
	  spvw_memfile.d, encoding.d, charstrg.d, pathname.d, stream.d,
	  misc.d, error.d, errwin32.d, win32aux.d: Revert most of 1999-06-20
	  patch.

1999-06-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pathname.d (asciz_dir_to_pathname_): Change declaration of pathbuf.
	* errwin32.d (OS_error_internal_body): Fix compilation error.

1999-06-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Try to solve startup problems on Win95.
	* spvw.d (main) [TRIVIALMAP_MEMORY]: Call prepare_zeromap with
	  shrinkp=FALSE.

1999-06-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Determine the initial encoding by examining the user's locale.
	* lispbibl.d (init_dependent_encodings): New declaration.
	* spvw_ctype.d: New file.
	* spvw.d: Include <string.h> always.
	  Include spvw_ctype.d.
	(main): Remove LC_CTYPE code, instead call `init_ctype'. Later, call
	  `init_dependent_encodings'.
	* encoding.d (init_dependent_encodings): New function, moved out of
	  init_encodings. default-file-encoding and the others depend on
	  locale_charset.
	(init_encodings): Call init_dependent_encodings.
	* makemake.in (SPVW_INCLUDES): Add spvw_ctype.
	* gettext/po/Makefile.devel (DSOURCES): Add spvw_ctype.

1999-06-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Use Unicode API on Win32.
	* lispbibl.d (wchar, WLITERAL): New macros.
	(wgetenv): New macro.
	(wasciz_out, wasciz_length): New declaration.
	(wasciz_equal, wwasciz_equal): New declaration.
	(n_char_to_string): Renamed from make_string.
	(n_wchar_to_string): New declaration.
	(wasciz_to_string): New declaration.
	(with_string_w0, with_sstring_w0): New macros.
	(n_chart_to_wchar): New declaration.
	* win32.d (wgetenv): New macro.
	* spvw.d (wasciz_length, wasciz_equal, wwasciz_equal): New functions.
	(program_name): Change type to `wchar*'.
	(loadmem): Change declaration.
	(usage): Call wasciz_out instead of asciz_out.
	(main): On Win32 with UNICODE, rename to `wmain'. Change type of
	  argv to `wchar* []'. Change types of argv_lisplibdir, argv_memfile,
	  argv_init_files, argv_compile_files, argv_package, argv_expr,
	  argv_execute_file, argv_execute_args, argv_language, argv_localedir,
	  argv_init_files, argv_compile_files to use `wchar' instead of `char'.
	  Use wasciz_equal, wasciz_to_string, wasciz_out and WLITERAL where
	  appropriate.
	* spvw_debug.d (wasciz_out): New function.
	* spvw_language.d (init_language, init_language_from): Change
	  declarations.
	(init_language_from): Use wasciz_equal instead of asciz_equal.
	(init_language): Use wgetenv instead of getenv where appropriate.
	* spvw_memfile.d (loadmem): Change declaration. Use wasciz_equal
	  instead of asciz_equal where appropriate.
	* encoding.d (n_char_to_string): Renamed from make_string.
	(n_char_to_string_): Renamed from make_string_.
	(n_wchar_to_string_): New function.
	(asciz_to_string, asciz_to_string_): Update.
	(wasciz_to_string_): New function.
	* charstrg.d (n_chart_to_wchar): New function.
	* pathname.d (make_directory, delete_directory,
	   change_current_directory, delete_existing_file,
	   delete_file_if_exists, delete_file_before_rename,
	   rename_existing_file, rename_file_to_nonexisting): Change
	  declaration.
	(asciz_dir_to_pathname): Change declaration. Use n_wchar_to_string
	  instead of make_string.
	(good_drive): Use wchar instead of char.
	(default_drive): Return wchar instead of uintB. Use wchar instead
	  of char.
	(default_directory_of): Use wchar instead of char.
	(assure_dir_exists): Likewise. Use n_wchar_to_string instead of
	  make_string.
	(change_default): Use wchar instead of char.
	(access0): Change declaration.
	(file_exists): Use wchar instead of char.
	(directory_exists, DELETE-FILE, rename_file): Likewise.
	(create_new_file, open_input_file, open_output_file): Change
	  declaration.
	(create_backup_file): Change declaration. Use wchar instead of char.
	(open_file): Use wchar instead of char.
	(extract): Use n_char_to_string instead of make_string.
	(directory_search_1subdir): Use wchar instead of char.
	(directory_search_scandir): Use n_char_to_string instead of
	  make_string. Use wchar instead of char. Use wasciz_to_string instead
	  of asciz_to_string.
	(DIRECTORY): Use n_char_to_string instead of make_string.
	(MAKE-DIR, DELETE-DIR, ENSURE-DIRECTORIES-EXIST): Use wchar instead
	  of char.
	(init_pathnames): Use n_char_to_string instead of make_string.
	  Use wchar instead of char. Use wgetenv instead of getenv.
	(FILE-WRITE-DATE, SHELL): Use wchar instead of char.
	(argv_lisplibdir): Change declaration.
	* stream.d (make_keyboard_stream): Use wchar instead of char.
	(create_input_pipe): Change declaration.
	(MAKE-PIPE-INPUT-STREAM): Update.
	(create_output_pipe): Change declaration.
	(MAKE-PIPE-OUTPUT-STREAM): Update.
	(create_io_pipe): Change declaration.
	(MAKE-PIPE-IO-STREAM): Update.
	* misc.d (SYS::GETENV): Use wchar instead of char. On Win32 with
	  UNICODE, use _wgetenv. Use wasciz_to_string instead of
	  asciz_to_string.
	(SYS::REGISTRY): Use wchar instead of char.
	* error.d (write_errorasciz, write_errorwasciz): New functions.
	* erramiga.d (OS_error_internal): Use write_errorasciz instead of
	  write_errorstring.
	* errdjgpp.d (OS_error_internal): Likewise.
	* errunix.d (OS_error_internal): Likewise.
	* errwin32.d (OS_error_info): Remove type.
	(OS_error_info_callback): New type.
	(get_OS_error_info): Take a callback and call it, instead of
	  returning the result in a structure. Use wchar instead of char.
	(OS_error_internal_body): New function, split out of
	  OS_error_internal. Call write_errorasciz and write_errorwasciz
	  instead of write_errorstring.
	(SOCK_error): Call write_errorasciz instead of write_errorstring.
	(errno_out_body): New function, split out of errno_out. Call
	  wasciz_out.
	* rexx.d (rexx_getmsg): Use n_char_to_string instead of make_string.
	* win32aux.d (init_win32): Call non-Unicode versions of OemToChar and
	  CharToOem.
	* genclisph.d (n_char_to_string): Renamed from make_string.

1999-06-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Don't force building clisp.dvi on non-Unix OSes.
	* makemake.in (MANUALS): Remove clisp.dvi.
	(manual): Add it, on Unix only.
	(manualx): Add it, on non-Unix only.
	(install-doc, uninstall-man): Treat it like $(MANUALS).

1999-06-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* cfgacorn.lsp, cfgamiga.lsp, cfgdos.lsp, cfgwin32.lsp
	(*clhs-root-default*): Assign default value.
	* makemake.in (config.lsp): Emit "echo ... >> config.lsp" only for
	  Unix.

1999-06-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (low_flush_buffered_socket): Call sock_write, not
	  full_write.

1999-06-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (create_input_pipe): New function.
	(MAKE-PIPE-INPUT-STREAM): Call it.
	(create_output_pipe): New function.
	(MAKE-PIPE-OUTPUT-STREAM): Call it.
	(create_io_pipe): New function.
	(MAKE-PIPE-IO-STREAM): Call it.

1999-06-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* socket.d (inet_addr): Don't declare on WIN32.
	(setsockopt): Remove second declaration.
	(SOCKET-SERVICE-PORT): On WIN32, use a replacement for getservent().

1999-06-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (callback.h): Copy also vacall_r.h and trampoline_r.h.

1999-06-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (GETTEXT): Define also if not using GNU_GETTEXT.

1999-06-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* places.lsp (MACRO-FUNCTION): Ignore `env'.

1999-06-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (strm_keyboard_len): Define as strm_len, not 0.
	(make_keyboard_stream): Don't add strm_len to strm_keyboard_len, it
	  is already included.

1999-06-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (malloc, free): Remove declarations.
	(malloca, freea): Move declarations.
	(DRIVER_frame_data): Remove type.
	* spvw_alloca.d (malloc, free): New declarations.
	* aridecl.d (HAVE_NUM_STACK, NUM_STACK, NUM_STACK_bound,
	   NUM_STACK_normal): Remove declarations.
	(num_stack_need, num_stack_need_1): Remove obsolete code. Add
	  `unused' to avoid gcc warnings.
	(NUM_STACK_normal, arith_ueberlauf, compare_NUM_STACK_bound): Remove.
	(SAVE_NUM_STACK, RESTORE_NUM_STACK. num_stack_need,
	   num_stack_need_1): New definitions, using malloca/freea.
	* intlog.d (I_I_logior_I, I_I_logxor_I, I_I_logand_I, I_I_logeqv_I,
	   I_I_lognand_I, I_I_lognor_I, I_I_logandc2_I, I_I_logorc2_I,
	   I_lognot_I): Defer RESTORE_NUM_STACK until done with the temporary
	  digit sequence.
	(I_I_ash_I): Do RESTORE_NUM_STACK before error.
	* intplus.d (DS_1_plus, DS_minus1_plus): Do RESTORE_NUM_STACK before
	  error.
	(I_1_plus_I, I_minus1_plus_I): Defer RESTORE_NUM_STACK until done
	  with the temporary digit sequence.
	(I_I_plus_I, I_minus_I, I_I_minus_I): Likewise. Do RESTORE_NUM_STACK
	  before error.
	* intbyte.d (lb_extract): Move SAVE_NUM_STACK and defer
	  RESTORE_NUM_STACK until done with the temporary digit sequence.
	(mkf_extract): Likewise.
	* intmal.d (UDS_square_UDS): Do RESTORE_NUM_STACK before error.
	(I_square_I): Move SAVE_NUM_STACK and defer RESTORE_NUM_STACK until
	  done with the temporary digit sequence.
	(UDS_UDS_mal_UDS): Do RESTORE_NUM_STACK before error.
	(I_I_mal_I): Move SAVE_NUM_STACK and defer RESTORE_NUM_STACK until
	  done with the temporary digit sequence.
	* intdiv.d (UDS_divide_): Move SAVE_NUM_STACK and defer
	  RESTORE_NUM_STACK until done with the temporary digit sequence.
	(I_I_divide_I_I): Defer SAVE_NUM_STACK until needed. Defer
	  RESTORE_NUM_STACK until done with the temporary digit sequence.
	* intgcd.d (I_I_gcd_I) [1]: Defer RESTORE_NUM_STACK until done with
	  the temporary digit sequence.
	(I_I_gcd_I) [3]: Likewise.
	(I_I_xgcd_I_I_I) [3]: Do RESTORE_NUM_STACK before side return.
	* intsqrt.d (UDS_sqrt_): Defer RESTORE_NUM_STACK until done with the
	  temporary digit sequence.
	(I_isqrt_I, I_sqrtp):  Move SAVE_NUM_STACK and defer
	  RESTORE_NUM_STACK until done with the temporary digit sequence.
	(I_rootp): Defer RESTORE_NUM_STACK until done with the temporary
	  digit sequence.
	* intread.d (DIGITS_to_I): Defer RESTORE_NUM_STACK until done with the
	  temporary digit sequence.
	* dfloat.d (DF_DF_durch_DF): Defer RESTORE_NUM_STACK until done with
	  the temporary digit sequence.
	(DF_sqrt_DF): Likewise.
	* lfloat.d (LF_ftruncate_LF, LF_futruncate_LF, LF_fround_LF): Defer
	  RESTORE_NUM_STACK until done with the temporary digit sequence.
	(LF_LF_plus_LF): Do RESTORE_NUM_STACK before error or return.
	(LF_square_LF): Move SAVE_NUM_STACK and defer RESTORE_NUM_STACK
	  until done with the temporary digit sequence. Do RESTORE_NUM_STACK
	  before error or return.
	(LF_LF_mal_LF): Likewise.
	(LF_LF_durch_LF): Likewise.
	(LF_sqrt_LF): Likewise.
	(LF_to_I): Move SAVE_NUM_STACK.
	* realrand.d (I_random_I): Move SAVE_NUM_STACK and defer
	  RESTORE_NUM_STACK until done with the temporary digit sequence.
	* lisparit.d (mal_10_plus_x): Defer RESTORE_NUM_STACK until done with
	  the temporary digit sequence. Do RESTORE_NUM_STACK before error.
	(decimal_string): Defer RESTORE_NUM_STACK until done with the
	  temporary digit sequence.
	* eval.d (unwind): No need to reset NUM_STACK when reaching a
	  DRIVER_frame.
	* debug.d (driver): No need to save current NUM_STACK in the frame.
	(break_driver): No need to save and restore NUM_STACK.
	* control.d (SYS::DRIVER): No need to save current NUM_STACK in the
	  frame.
	* spvw.d: No need any more for include "aridecl.c".
	(main): Remove teile_NUM_STACK, assume it is 0.

1999-06-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* intlog.d (I_I_ash_I): Restrict begin/end_arith_call() to the case
	  where it is needed.
	* intbyte.d (lb_extract): Restrict begin/end_arith_call() to the case
	  where it is needed.
	* intmal.d (I_square_I): Move begin_arith_call() until after
	  num_stack_need.
	* intgcd.d (I_I_gcd_I) [3]: Move begin_arith_call() until after
	  num_stack_need.
	(I_I_xgcd_I_I_I) [3]: Likewise.
	* intsqrt.d (UDS_sqrt_): Move begin_arith_call() until after
	  num_stack_need.
	(I_rootp): Likewise.
	* lfloat.d (LF_LF_plus_LF): Move begin_arith_call() until after
	  num_stack_need.
	(LF_sqrt_LF): Restrict begin/end_arith_call() to the case where it
	  is needed.
	* realelem.d (R_R_gleich): Restrict begin/end_arith_call() to the case
	  where it is needed.
	* lisparit.d (mal_10_plus_x): Restrict begin/end_arith_call().

1999-06-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* intelem.d (FN_to_NDS_nocopy, I_to_NDS_nocopy): Expand into more
	  efficient code.
	(FN_to_NDS_nocopy_): New macro.
	(BN_to_NDS_nocopy): Add `unused' to avoid gcc warnings.
	* intmal.d (I_I_mal_I): Put brace around I_to_NDS_nocopy.
	* intdiv.d (I_I_divide_I_I): Put brace around I_to_NDS_nocopy.
	* intsqrt.d (I_rootp): Put brace around I_to_NDS_nocopy.

1999-06-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_sigsegv.d (stackoverflow_handler): Restore the STACK on Solaris
	  and OSF/1 as well.
	* lispbibl.d: After sigsegv.h is included, undefine DS, SP, EAX.

1999-06-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (UNIX_OPENBSD): New macro.
	* eval.d (interpret_bytecode_): Use hairy gas assembler syntax only
	  on Linux and *BSD, never on other OSes.

1999-06-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* eval.d (interpret_bytecode_): Use "\n\t" as assembler statement
	  separator instead of ";".

1999-06-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* describe.lsp (describe-object): Put back i18n call around
	  punctuation strings.
	* socket.d (resolve_host_ipaddr): Likewise.

1999-06-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d, genclisph.d: Prepare for __GNUC__ == 3.

1999-06-15  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (macroexpand-1): Do not pass ENV to `macro-function'.
	(c-form): Do not pass ENV to `macro-function'.

	* places.lsp (MACRO-FUNCTION): Add optional, ignored env argument.

	* control.d (SYSTEM::OLD-MACRO-FUNCTION): New function.
	* eval.d (FUNTAB): Use it instead of MACRO-FUNCTION.
	* compiler.lsp (funtab): Likewise.

	* sequence.d (test_count_arg): Simplify.

1999-06-10  Sam Steingold  <sds@goems.com>

	* describe.lsp (describe-object): dump `ENGLISH' before ".".

	* socket.d (resolve_host_ipaddr): correct the order of arguments
	in the `fehler' call.

	* init.lsp (*load-level*): new variable.
	(load): use it to indent the verbose printout nicely.

1999-06-10  Sam Steingold  <sds@goems.com>

	* list.d (nreconc): be as smart about `nreconc' as we are about
	`nreverse'.

1999-06-09  Sam Steingold  <sds@goems.com>

	* misc.d (set-ansi): set `*coerce-fixnum-char-ansi*',
	`*sequence-count-ansi*', and `*print-pathnames-ansi*'.
	* constsym.d: added `*coerce-fixnum-char-ansi*',
	`*sequence-count-ansi*', and `*print-pathnames-ansi*'.
	* spvw.d: added `*coerce-fixnum-char-ansi*',
	`*sequence-count-ansi*', and `*print-pathnames-ansi*'.
	* sequence.d (test_count_arg): check `*sequence-count-ansi*'.
	* io.d (pr_orecord): check `*print-pathnames-ansi*'.
	* charstrg.d (coerce_char): check `*coerce-fixnum-char-ansi*'.
	* places.lsp: added documentation for `*ansi*'.

1999-06-09  Sam Steingold  <sds@goems.com>

	Implemented the ANSI CL Issue MACRO-FUNCTION-ENVIRONMENT:YES
	* control.d (macro_function): optional second argument.
	* subr.d (macro_function): ditto.
	* compiler.lsp (macroexpand-1): pass ENV to `macro-function'
	(subr-info): optional second argument of `macro-function'.
	(c-form): pass ENV to `macro-function'.

1999-06-08  Sam Steingold  <sds@goems.com>

	* describe.lsp (apropos-do-more): new function.
	(apropos): use it.
	(describe-object package): `*describe-nesting*' should be checked
	for being 0, not 1.

1999-06-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (*toplevel-environment*, *toplevel-denv*): Move
	  variables...
	* init.lsp (*toplevel-environment*, *toplevel-denv*): ... to here.

1999-06-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* intparam.d (printf_underscored): Change argument type to
	  `const char*'.

1999-06-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* init.lsp (defun): Don't use get-funname-symbol, to avoid
	  bootstrapping problems.

1999-06-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	SOCK_error() generates an error of type `os-error'.
	* errwin32.d (SOCK_error): use `simple_os_error'.

1999-06-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make DEFUN behave the same way w.r.t. inlining, whether executing
	compiled or interpreted.
	* compiler.lsp (compile-form-in-toplevel-environment): New function.
	* init.lsp (load): Call it, don't pass nil as %denv% to compile-form.
	(defun): Save the lambdabody for inline compilation also when
	  running interpreted.

1999-06-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	New command-line option "-w".
	* spvw.d (usage): Mention "-w".
	(argv_wait_keypress): New variable.
	(main): Set it if option "-w" is given.
	(quit): If argv_wait_keypress, emit a message and call WAIT-KEYPRESS.
	* _clisp.c (main): Accept "-w".
	* keyboard.lsp (wait-keypress): New function.

1999-06-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* describe.lsp (describe-object): Treat FOREIGN-FUNCTION, SYMBOL-MACRO,
	  ENCODING.

1999-06-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make DESCRIBE more robust against interruptions.
	* describe.lsp (describe-stream): New stream class.
	(stream-*): New methods on describe-stream.
	(describe-slotted-object): Omit all *describe-nesting* indentations.
	  Add *print-indent-lists* to tabpos. Call describe with stream, not
	  *standard-output*.
	(describe-object): Omit all *describe-nesting* indentations.
	  Call describe with stream, not *standard-output*.
	(describe-object) [PACKAGE]: Tweak spacing.
	(describe1): New function.
	(describe): Bind *describe-nesting* and *describe-done* instead of
	  setting them. In top-level calls, create a describe-stream.
	(describe-signature): Omit all *describe-nesting* indentations.

1999-06-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* room.lsp (room, space-tabulate): Use *print-right-margin* instead of
	  sys::*prin-linelength* when it is non-NIL.
	* describe.lsp (describe): Likewise.
	* compiler.lsp (compile-file): Likewise.

1999-06-06  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* describe.lsp (describe-slotted-object, describe-object, describe,
	   describe-signature): Fix amount of indentation white space.
	(describe): Bind *describe-nesting* instead of setting it. This
	  ensures it goes back to 0 after describe signalled an error.

1999-06-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* io.d (READ-CHAR-STATUS): Remove function.
	(READ-CHAR-WILL-HANG-P): New function.
	* stream.d (listen_generic): Call GENERIC-STREAM-READ-CHAR-WILL-HANG-P
	  instead of GENERIC-STREAM-READ-CHAR-STATUS.
	(stream_listen): Call STREAM-READ-CHAR-WILL-HANG-P instead of
	  STREAM-READ-CHAR-STATUS.
	* gstream.lsp (stream-read-char-status): Remove function.
	(stream-read-char-will-hang-p): New function.
	(generic-stream-read-char-status): Remove function.
	(generic-stream-read-char-will-hang-p): New function.
	* screen.lsp (generic-stream-read-char-status@screen-controller):
	  Remove method.
	(generic-stream-read-char-will-hang-p@screen-controller): New method.

1999-06-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* describe.lsp (apropos-list, *apropos-do-more*, apropos): Move.

1999-06-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* cfgwin32.lsp (clhs-root): Don't signal an error if value not defined
	  in registry.

1999-06-04  Sam Steingold  <sds@goems.com>

	* makemake.in: setq `*clhs-root-default*' in config.lsp.
	* cfgunix.lsp (clhs-root): new function.
	(*clhs-root-default*): new variable.
	* cfgacorn.lsp, cfgamiga.lsp, cfgdos.lsp, cfgsunux.lsp, cfgwin32.lsp:
	Likewise.

1999-06-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* trace.lsp (untrace1): Don't use replace-in-fenv here either.

1999-06-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (READLINELIB): Don't pass option "-r" to $(MAKE) for
	  building in subdirectory. It doesn't work with Irix 6.5 `make'
	  because readline/Makefile.in uses implicit rules.

1999-06-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (Encoding): Add enc_towcs_error, enc_tombs_error slots.
	(encoding_length): Update.
	* encoding.d (uni32_mblen, uni32be_mbstowcs, uni32le_mbstowcs,
	   utf8_mblen, utf8_mbstowcs): Error handling respects enc_towcs_error.
	(nls_asciiext_mblen, nls_asciiext_wcslen): New functions.
	(nls_mblen, nls_mbstowcs, nls_asciiext_mbstowcs): Error handling
	  respects enc_towcs_error.
	(nls_wcslen, nls_wcstombs, nls_asciiext_wcstombs): Error handling
	  respects enc_tombs_error.
	(MAKE-ENCODING): Two new keyword arguments. Fully initialize newly
	  allocated encoding.
	(init_encodings): Fully initialize newly allocated encodings.
	  Stuff in nls_asciiext_mblen, nls_asciiext_wcslen where appropriate.
	  Pass two more unbounds to C_make_encoding.
	* stream.d (test_external_format_arg): Pass two more unbounds to
	  C_make_encoding.
	(iconv_mblen, iconv_mbstowcs): EILSEQ treatment respects
	  enc_towcs_error.
	(iconv_wcslen, iconv_wcstombs): EILSEQ treatment respects
	  enc_tombs_error.
	* pseudofun.d: Add nls_asciiext_mblen, nls_asciiext_wcslen.
	* type.lsp (canonicalize-type, encoding-charset): Update
	  sys::%record-ref argument.

1999-06-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_CANONICAL_HOST_CPU, CL_CANONICAL_HOST_CPU_FOR_FFCALL):
	  Canonicalize alpha variants to alpha.

1999-05-30  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (CFILES): Don't include $UNICODE_INCLUDES $NLS_INCLUDES.
	(init): Instead, add them to the `init' target.

1999-05-30  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Libtoolify avcall and callback.
	* foreign.d: Include avcall.h and callback.h.
	* makemake.in (foreign): Depend on avcall.h and callback.h.
	(avcall.h, libavcall.a, callback.h, libcallback.a): Create by
	  doing "make install-lib" in the subdirectory.
	(clean1): Remove libavcall.* and libcallback.*.
	(clean4): Remove avcall.h and callback.h.

1999-05-30  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* asmi386.hh (DECLARE_FUNCTION): New macro.
	(INSN2MOVX): Fix bug with ANSI C preprocessors.
	(ALIGN): Don't put parentheses. For Solaris/x86.
	* asmi386.sh: Introduce C(...) macro calls. Recognize more jumps.
	  Introduce DECLARE_FUNCTION(...) macro calls.

1999-05-30  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (sigsegv.h, libsigsegv.a): Do "make install-lib" instead
	  of "make install".
	(clean1): On Win32, remove sigsegv.lib, not libsigsegv.*.

1999-05-30  Sam Steingold  <sds@goems.com>
	    Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Implement ALLOCATE-INSTANCE.
	* record.d (clos::old-%allocate-instance): Renamed from
	  clos::%allocate-instance.
	(clos::%allocate-instance): New function, with &rest arguments.
	(do_allocate_instance): New function. Remove unneeded if_classp
	  check.
	(clos::%initialize-instance): Adapt to new format of
	  *make-instance-table* entries.
	(clos::%make-instance): Likewise. Call do_allocate_instance, or
	  the effective method for allocate-instance if it is not the default
	  one.
	* eval.d (FUNTAB): clos::old-%allocate-instance replaces
	  clos::%allocate-instance.
	* compiler.lsp (funtab, c-DIRECT-FUNCTION-CALL): Likewise.
	* init.lsp: Export allocate-instance.
	* defs3.lsp: Likewise.
	* clos.lsp: Likewise.
	(*dynamically-modifiable-generic-function-names*): Add
	  `allocate-instance'.
	(|#'allocate-instance|): New variable.
	(std-add-method, std-remove-method): When changing allocate-instance,
	  call note-ai-change.
	(note-i-meta-change, note-ai-change): New functions.
	(valid-make-instance-keywords): Add the ALLOCATE-INSTANCE keywords.
	(make-instance-table-entry1): New function.
	(make-instance-table-entry2): Return 2 values.
	(initialize-instance@standard-object): Adapt to new format of
	  *make-instance-table* entries.
	(initial-initialize-instance): Create new-style *make-instance-table*
	  entry.
	(allocate-instance): New generic function.
	(initial-make-instance): Call the effective method for
	  allocate-instance. Create new-style *make-instance-table* entry.

1999-05-29  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Change a few occurrences of ${NEXT_M} to ${NEXT_}.

1999-05-29  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make --with-unicode the default.
	* makemake.in (info_help): Mention --without-unicode instead of
	  --with-unicode.
	(XCFLAGS, UNICODE_INCLUDES, NLS_INCLUDES): Test $with_nounicode
	  instead of $with_unicode.
	* configure: Don't pass --with-unicode to makemake.
	* Makefile.devel (*/makefile*): Create without --with-unicode.

1999-05-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* type.lsp: (def-atomic-type, def-compound-type): New macros.
	(c-typep-alist1, c-typep-alist2, c-typep-alist3): Fill here.
	* compiler.lsp: Not here.

1999-05-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (clean1): Remove libsigsegv.la.
	(clean4): Remove libintl.h, sigsegv.h.
	(clean5): Remove ANNOUNCE, GNU-GPL, SUMMARY, version.h, NEWS,
	  clisp.gif, MAGIC.add, ccmp2c, modprep.

1999-05-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (clean1, clean2): Don't remove wlisp* and wsuite*.

1999-05-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (sigsegv.h, libsigsegv.a): Generate by calling
	  "make install" in the subdirectory, not through symlinks.

1999-05-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* configure.in: Add check for groff.
	* makemake.in (GROFF): New variable.
	(htmldir, dvidir): New Makefile variables.
	(ROFF_MAN, ROFF_DVI): Set if $GROFF is nonempty.
	(ROFF_DVI): Don't define if $GROFF is empty.
	(clisp.dvi): Create if and only if $GROFF is nonempty.
	(MANUALS): Include clisp.dvi if and only if $GROFF is nonempty.
	(installdirs): Create $(htmldir) and $(dvidir) instead of
	  $(mandir)/html.
	(install-man): Clean up dependencies.
	  Use $(htmldir) and $(dvidir) instead of $(mandir)/html.
	  Install clisp.dvi and clreadline.dvi if appropriate.
	(uninstall-man): Use $(htmldir) and $(dvidir) instead of
	  $(mandir)/html. Also remove clisp.dvi and clreadline.dvi.
	(distrib): Distribute clisp.dvi if and only if $GROFF is nonempty.
	(clean1): Also remove clisp.dvi.
	* _distmakefile (htmldir, dvidir): New variables.
	(install-man): Install clisp.1 without modifications.
	  Also install clisp.html, clisp.dvi, clreadline.html, clreadline.dvi.

1999-05-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* configure: In avcall and callback, do "make minicheck" instead of
	  "make check".

1999-05-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* macros2.lsp (check-type): Don't quote the string argument.
	* conditio.lsp (check-type): Likewise.

1999-05-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (distrib): Reorganize. Distribute the data/ directory
	  and its contents. Distribute the `full' linking set also if
	  BINARY_DISTRIB is set.

1999-05-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make `clisp' an executable, also in the case of UNIX_BINARY_DISTRIB.
	* _clisp.c [UNIX_BINARY_DISTRIB]
	(room_for_lisplibdir, room_for_localedir): New arrays.
	(LISPLIBDIR, LOCALEDIR): New definitions, pointing into the arrays.
	* utils/hardcode.c: New file.
	* _distmakefile: Treat UNIX_BINARY_DISTRIB like other UNIX platforms.
	(install): Create `clisp' as an executable, using `hardcode', not as
	  a shell script.
	* makemake.in (BINARY_DISTRIB): Also define on HP-UX 11.
	(GOOD_SH): Remove definition.
	(distrib): Distribute `clisp' and `hardcode'.
	* spvw.d (main, usage): Option -K is now available on all Unix
	  platforms.
	* configure.in: Remove call to CL_SHELLARGS.
	* unixconf.h.in (UNIX_USE_KSH, UNIX_BROKEN_SH): Remove definitions.

1999-05-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (install-bin): Copy base/ and full/ using cp, not tar,
	  because they contain symbolic links.

1999-05-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make modules.o part of every linking set, including `base'.
	* makemake.in (lisp.a): Don't include modules.o.
	(modular): Depend on modules.o.
	(base): Link over modules.o.
	(distmakefile): Add modules.o to the BASE_LIBS and BASE_FILES
	  substitution.
	(distrib): Link over modules.o into $(TOPDIR)/base.
	* clisp-link.in (add-module-set): Check that the linking set contains
	  a file `modules.o'.
	(add-module-sets): Likewise. When no new modules, copy modules.o
	  in any case.
	(run): Check that the linking set contains a file `modules.o'.

1999-05-23  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (distmakefile): Don't set $wlibs, not needed any more.

1999-05-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw.d (initmem): Don't call SYS::SET-ANSI (no need, doesn't work).

1999-05-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* intlog.d (integerlength32) [RS6000]: Use new or old mnemonics
	  depending on OS.

1999-05-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Libtoolify sigsegv.
	* autoconf/libtool.m4: New file, from libtool-1.2.

1999-05-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	For Linux 2.0.x with glibc2.0.
	* aclocal.m4 (CL_SIGALTSTACK): Define HAVE_SIGALTSTACK only if the
	  sigaction flags macro SA_ONSTACK is also defined.

1999-05-13  Gilbert Baumann  <unk6@rz.uni-karlsruhe.de>

	* sequence.d (READ-CHAR-SEQUENCE): Changed calls to
	  `iarray_displace_check' to `array_displace_check'. Adjusted return
	  value: The first position not written is returned.
	(WRITE-CHAR-SEQUENCE): Likewise, uses `array_displace_check' now.
	(WRITE-BYTE-SEQUENCE): In case of (VECTOR (UNSIGNED-BYTE 8)) use
	  another indirection via '->data' before calling 'read_byte_array'.
	(READ-BYTE-SEQUENCE): Likewise. Additionally the first position not
	  written is returned.

1999-05-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw.d (init_symbol_values): Don't call a function here, too early.
	(initmem): Call SYS::SET-ANSI here.

1999-05-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	 * lispbibl.d (stream_fd): Move declaration.
	 * stream.d (stream_fd): Move function.

1999-05-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Followup to Sam's 1999-04-07 patch.
	* eval.d (check_for_illegal_keywords): Remove misplaced symbolp test.
	* defmacro.lsp (analyze-key): Use symbolp instead of keywordp.
	* compiler.lsp (test-argument-syntax): Likewise.
	(kvalue-form-index): Likewise.
	* conditio.lsp (expand-restart-case): Likewise.
	* error.d (SYSTEM::CERROR-OF-TYPE, SYSTEM::ERROR-OF-TYPE): Likewise.

1999-05-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Followup to Sam's 1999-04-07 patch.
	* eval.d (eval1): Treat arrays as self-evaluating in all cases.
	* compiler.lsp (l-constantp, c-constantp, c-constant-value): Treat
	  arrays as constants.

1999-05-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* trace.lsp (trace1): No need to use replace-in-fenv.
	(replace-in-fenv): Remove function.

1999-05-12  Sam Steingold  <sds@goems.com>

	* format.lsp (format-integer): (format nil "~@d" 0) => "+0"

1999-05-12  Sam Steingold  <sds@goems.com>

	* loop.lsp (expand-loop): put `then-form' into `stepafter' even
	when it's the same constant as `first-form'.

1999-05-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_SIGNAL_UNBLOCK, CL_SIGNAL_BLOCK_OTHERS,
	   CL_SIGACTION_UNBLOCK): Perform the test if either POSIX or BSD
	  signal mask primitives are available. Otherwise,
	  SIGACTION_NEED_UNBLOCK would not be defined on Solaris.

1999-05-07  Sam Steingold  <sds@goems.com>

	* describe.lsp (*apropos-do-more*): new variable.
	(apropos): use it.

1999-05-07  Sam Steingold  <sds@goems.com>

	* spvw.d (usage): mention -K regardless of "UNIX_BINARY_DISTRIB".

1999-05-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Support for Apple's MacOS X Server.
	* aclocal.m4 (CL_RLIMIT): Include <sys/time.h> before
	  <sys/resource.h>.
	* lispbibl.d (unix): Define if __MACH__ is defined.
	(RS6000): Define if __ppc is defined.
	(UNIX_RHAPSODY): New macro.
	(__const): Define as const, not empty.
	* unix.d: Include <sys/time.h> before <sys/resource.h>. Treat
	  UNIX_RHAPSODY like UNIX_NEXTSTEP.
	* intlog.d (integerlength32): Don't use the cntlz instruction on
	  UNIX_RHAPSODY.

1999-05-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* clos.lsp (same-specializers-p): New function.
	(specializers-agree-p): Use it.
	(dispatching-arg-p, single-dispatching-arg, dispatching-arg-type):
	  New functions.
	(no-applicable-method, no-primary-method): Signal a type-error if
	  there is only one dispatching argument.

1999-05-03  Sam Steingold  <sds@goems.com>

	* pathname.d (file_stat): use `built_in_stream_open_p' instead of
	`open_stream_p'.

1999-05-02  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_SIGALTSTACK): New macro.
	* lispbibl.d (NOCOST_SP_CHECK): Define whenever sigsegv.h defines
	  HAVE_STACK_OVERFLOW_RECOVERY, not only on WIN32_NATIVE.
	(near_SP_overflow) [UNIX]: New declaration.
	* spvw.d (near_SP_overflow): New function.
	* spvw_fault.d (handle_fault): Add `verbose' argument. If it is 1,
	  don't print error messages.
	* spvw_sigsegv.d (sigsegv_handler): Add `serious' argument.
	(stackoverflow_handler): Add `scp' argument. Bring back STACK to
	  a sane value.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make SYS::%GENERIC-FUNCTION-LAMBDA self-contained.
	* misc.d (SYS::VERSION), constobj.d: Bump version number.
	* record.d (SYS::%COPY-GENERIC-FUNCTION): New function.
	* eval.d (FUNTAB): Add it.
	* compiler.lsp (funtab): Likewise.
	(subr-info): Likewise.
	(c-FNODE-FUNCTION): Generate different code for generic functions.
	(create-fun-obj): The venv of generic functions is now inside
	  consts[0], from the beginning.
	* clos.lsp (install-dispatch): Simplify.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* conditio.lsp: Add SYS::PRINT-CONDITION to
	  clos::*dynamically-modifiable-generic-function-names*.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (get_synonym_stream): Argument must be a variable.
	(rd_by_array_synonym, wr_by_array_synonym, rd_ch_array_synonym,
	   wr_ch_array_synonym, close_synonym, read_line_synonym): Update.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (stream_get_read_eval, stream_set_read_eval): New
	  declarations.
	* stream.d (read_byte, read_byte_array, write_byte, write_byte_array,
	   read_char, unread_char, peek_char, read_char_array, write_char,
	   write_char_array, var_stream): Treat instances of
	  FUNDAMENTAL-STREAM correctly.
	(listen_generic): Change error message.
	(terminal_raw, STREAM-EXTERNAL-FORMAT,
	   SYSTEM::SET-STREAM-EXTERNAL-FORMAT, interactive_stream_p,
	   read_line, stream_listen, clear_input, finish_output, force_output,
	   clear_output, get_line_position, stream_line_number): Treat
	  instances of FUNDAMENTAL-STREAM correctly.
	(stream_get_read_eval, stream_set_read_eval): New functions.
	(SYS::ALLOW-READ-EVAL): Use them.
	* io.d (read_eval_reader, load_eval_reader): Use stream_get_read_eval.
	(READ-CHAR-NO-HANG): Treat instances of FUNDAMENTAL-STREAM
	  correctly.
	(pr_enter_1, pr_orecord, pr_subr): Use stream_get_read_eval.
	* compiler.lsp (c-DIRECT-FUNCTION-CALL): Remove SYSTEM::LINE-POSITION
	  from list of side-effect-free functions.
	* gstream.lsp (fundamental-stream): Add a slot.
	(fundamental-character-stream, fundamental-binary-stream,
	   fundamental-character-input-stream,
	   fundamental-character-output-stream,
	   fundamental-binary-input-stream, fundamental-binary-output-stream):
	  New classes.
	(stream-element-type): Add method on fundamental-character-stream.
	(stream-read-char, stream-unread-char, stream-read-char-no-hang,
	   stream-peek-char, stream-listen, stream-read-char-status,
	   stream-read-char-sequence, stream-read-line, stream-clear-input,
	   stream-write-char, stream-line-column, stream-start-line-p,
	   stream-write-char-sequence, stream-write-string, stream-terpri,
	   stream-fresh-line, stream-finish-output, stream-force-output,
	   stream-clear-output, stream-advance-to-column, stream-read-byte,
	   stream-read-byte-sequence, stream-write-byte,
	   stream-write-byte-sequence): New generic functions.
	* describe.lsp (describe-object): Call open-stream-p, since
	  input-stream-p and output-stream-p don't tell whether a stream is
	  open.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Allows streams to have an unknown line position.
	* lispbibl.d (get_line_position): Can trigger GC. Can return NIL.
	* stream.d (get_line_position): Likewise.
	(MAKE-STRING-OUTPUT-STREAM): Allow LINE-POSITION argument to be NIL.
	* io.d (pr_enter_1): Update.
	* format.lsp (format-tabulate): If the stream's line position is
	  unknown, output 2 spaces.
	(do-format-justification): If the stream's line position is unknown,
	  assume it is 0.
	* compiler.lsp (disassemble-closure): If the stream's line position is
	  unknown, output 2 spaces.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (stream_line_number): Can trigger GC.
	* stream.d (stream_line_number): Likewise.
	* io.d (read_delimited_list: Update.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* clos.lsp (install-dispatch): Don't assume the preliminary function
	  has a VENV. Generic functions without any method don't have one.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* init.lsp (cerror): Don't go into an interactive reploop if
	  *break-driver* is not yet set. This permits typing (load "init.lsp")
	  in an interactive lisp.run.

1999-05-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* config.guess, config.sub: Upgrade to newest version from GNU CVS.

1999-04-29  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* gstream.lsp (fundamental-stream, fundamental-input-stream,
	   fundamental-output-stream): New classes.
	(close, open-stream-p, stream-element-type,
	(setf stream-element-type)): Add methods on fundamental-stream.
	* lispbibl.d (instanceof): New macro.
	(streamp): Use it.
	* stream.d (input_stream_p, output_stream_p): New macros.
	(test_input_stream, test_output_stream): Use them.
	(INPUT-STREAM-P, OUTPUT-STREAM-P): Likewise.
	(SYS::%DEFGRAY): New function.

1999-04-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (builtin_stream_close): Renamed from stream_close.
	* stream.d (close_synonym): Call CLOSE instead of stream_close.
	(low_flush_buffered_handle, make_file_stream): Update.
	(SYSTEM::BUILT-IN-STREAM-OPEN-P): Renamed from OPEN-STREAM-P.
	  Stricter argument check.
	(SYSTEM::BUILT-IN-STREAM-ELEMENT-TYPE): Renamed from
	  STREAM-ELEMENT-TYPE. Stricter argument check.
	(SYSTEM::BUILT-IN-STREAM-SET-ELEMENT-TYPE): Renamed from
	  SYSTEM::SET-STREAM-ELEMENT-TYPE. Stricter argument check.
	(builtin_stream_close): Renamed from stream_close.
	(close_some_files): Update.
	(SYSTEM::BUILT-IN-STREAM-CLOSE): Renamed from CLOSE. Stricter
	  argument check.
	* debug.d (LOAD): Update.
	* misc.d (MACHINE-TYPE, MACHINE-VERSION): Update.
	* pathname.d (DELETE-FILE): Update.
	* spvw_memfile.d (WRITE, savemem): Update.
	* eval.d (FUNTAB): Update.
	* compiler.lsp (funtab, subr-info, c-DIRECT-FUNCTION-CALL): Likewise.
	* init.lsp (load): Call sys::built-in-stream-close instead of close.
	* gstream.lsp: Exports symbols from the Gray proposal.
	(close, open-stream-p, stream-element-type,
	(setf stream-element-type)): New generic functions.
	* places.lsp (stream-element-type): Remove defsetf.

	Distinguish built-in and other streams.
	* lispbibl.d (builtin_stream_p): Renamed from streamp.
	(streamp): New macro.
	(socket_stream-p): Use builtin_stream_p instead of streamp.
	* pathname.d (as_file_stream, PARSE-NAMESTRING, TRUENAME,
	   PROBE-FILE, DELETE-FILE, RENAME-FILE, OPEN, FILE-WRITE-DATE,
	   FILE-AUTHOR, FILE-STAT): Use builtin_stream_p instead of streamp.
	* stream.d (SYS::SYNONYM-STREAM-P, SYS::BROADCAST-STREAM-P,
	   SYS::CONCATENATED-STREAM-P, SYS::TWO-WAY-STREAM-P,
	   SYS::ECHO-STREAM-P, SYSTEM::STRING-INPUT-STREAM-INDEX,
	   GET-OUTPUT-STREAM-STRING, SYS::STRING-STREAM-P,
	   SYSTEM::BUFFERED-INPUT-STREAM-INDEX, SYS::FILE-STREAM-P,
	   check_window_stream, low_close_pipe, SOCKET-SERVER,
	   test_socket_stream, check_open_file_stream): Use builtin_stream_p
	  instead of streamp.
	(SYNONYM-STREAM-SYMBOL, BROADCAST-STREAM-STREAMS,
	   CONCATENATED-STREAM-STREAMS, TWO-WAY-STREAM-INPUT-STREAM,
	   TWO-WAY-STREAM-OUTPUT-STREAM, ECHO-STREAM-INPUT-STREAM,
	   ECHO-STREAM-OUTPUT-STREAM, GENERIC-STREAM-CONTROLLER,
	   SYS::LISTEN-BYTE, test_n_bytes_args): Use builtin_stream_p in the
	  first place, and streamp only for the error message.
	(GENERIC-STREAM-P, SYS::TERMINAL-RAW): Use builtin_stream_p.
	* predtype.d (SYS::BUILT-IN-STREAM-P): New function.

1999-04-29  Wolfgang Jenkner  <wolfgang@mat.univie.ac.at>

	* control.d (make_variable_frame): Treat special-declared variables
	  like special-proclaimed ones.

1999-04-29  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (TCPCONN): Always include <sys/types.h> before
	  <sys/socket.h>.

1999-04-26  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Fix a jmp_buf alignment problem on Irix 6.5.
	* foreign.d (alignof): Remove macro.
	* lispbibl.d (alignof): Move to here.
	(sp_jmp_buf_incr, sp_jmp_buf_to_jmp_buf, setjmpspl, longjmpspl): New
	  macros.
	(jmpbufsize): Add sp_jmp_buf_incr.
	(sp_jmp_buf): New type.
	(finish_entry_frame): Use setjmpspl.
	(enter_frame_at_STACK): Use longjmpsl.
	(DRIVER_frame_data): Use sp_jmp_buf instead of jmp_buf.
	* control.d (BLOCK, TAGBODY, CATCH, UNWIND-PROTECT): Use sp_jmp_buf
	  instead of jmp_buf.
	* eval.d (invoke_handlers, funcall_iclosure, eval, eval_no_hooks,
	   JMPBUF_on_SP): Use sp_jmp_buf instead of jmp_buf.

1999-04-26  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* clos.lsp (*allow-mixing-metaclasses*): New variable.
	(initialize-instance-standard-class, make-instance-built-in-class,
	   initialize-instance-structure-class): Don't check the metaclass
	  of the direct superclasses if *allow-mixing-metaclasses* is true.

1999-04-26  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* reploop.lsp: Set *use-clcs* to t here.
	* conditio.lsp: Not here.

1999-04-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (listen_generic): Make an error message
	  internationalizable.

1999-04-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* conditio.lsp (break): Use ANSI CL `:format-control' initarg.

1999-04-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make read_line recurse through some kinds of streams.
	* lispbibl.d (read_line): New declaration.
	* stream.d (read_line_synonym, read_line_twoway, read_line): New
	  functions.
	* io.d (READ-LINE): Call read_line. Put back the buffer after
	  copying it, not before.

1999-04-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (wr_ch_terminal2, wr_ch_array_terminal2) [MSDOS]: Define
	  as the _unbuffered_dos variant.

1999-04-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Remove obsolete stream primitive `wr_ss'.
	* lispbibl.d (Stream): Remove strm_wr_ss field.
	* io.d (write_sstring_ab): New function, remove macro.
	* stream.d (wr_ss_Pseudofun): Remove type definition.
	(wr_ss): Remove macro.
	(wr_ss_dummy, wr_ss_dummy_nogc): Remove functions.
	(close_dummys): Don't set strm_wr_ss field.
	(wr_ss_synonym): Remove function.
	(make_synonym_stream): Don't set strm_wr_ss field.
	(wr_ch_array_broad): Optimize.
	(wr_ss_broad): Remove function.
	(make_broadcast_stream): Don't set strm_wr_ss field.
	(make_concatenated_stream): Likewise.
	(wr_ss_twoway): Remove function.
	(make_twoway_stream, make_echo_stream): Don't set strm_wr_ss field.
	(MAKE-STRING-INPUT-STREAM): Likewise.
	(wr_ss_str_out): Remove function.
	(make_string_output_stream): Don't set strm_wr_ss field.
	(SYSTEM::MAKE-STRING-PUSH-STREAM): Likewise.
	(wr_ss_pphelp): Remove function.
	(make_pphelp_stream): Don't set strm_wr_ss field.
	(MAKE-BUFFERED-INPUT-STREAM, MAKE-BUFFERED-OUTPUT-STREAM): Likewise.
	(wr_ch_array_generic): Renamed from wr_ss_generic.
	(MAKE-GENERIC-STREAM): Don't set strm_wr_ss field.
	(wr_ss_unbuffered_unix, wr_ss_unbuffered_mac, wr_ss_unbuffered_dos):
	  Remove functions.
	(fill_pseudofuns_unbuffered): Don't set strm_wr_ss field.
	(wr_ss_buffered_unix, wr_ss_buffered_mac, wr_ss_buffered_dos):
	  Remove functions.
	(fill_pseudofuns_buffered): Don't set strm_wr_ss field.
	(make_keyboard_stream, make_terminal_stream_): Likewise.
	(wr_ch_array_terminal1): Renamed from wr_ss_terminal1.
	(wr_ch_array_terminal2): Renamed from wr_ss_terminal2.
	(wr_ch_array_terminal3): Renamed from wr_ss_terminal3
	(make_terminal_stream_): Don't set strm_wr_ss field.
	(MAKE-WINDOW, make_printer_stream, make_socket_stream): Likewise.
	* pseudofun.d: Update.

1999-04-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make write_char_array recurse through any kind of stream.
	* lispbibl.d (write_char_array): Change calling convention.
	* stream.d (wr_ch_array_Pseudofun): Change type definition.
	(wr_ch_array_error): Change calling convention.
	(wr_ch_array_dummy): Likewise. Loop, calling write_char.
	(write_char_array): Change calling convention.
	(wr_ch_array_synonym): Likewise.
	(wr_ch_array_broad0, wr_ch_array_broad1): Remove functions.
	(wr_ch_array_broad): New function.
	(make_broadcast_stream): Use it.
	(wr_ch_array_twoway): Change calling convention.
	(rd_ch_array_echo): Update.
	(wr_ch_array_str_out): New function.
	(make_string_output_stream): Use it.
	(wr_ch_array_pphelp): New function.
	(make_pphelp_stream): Use it.
	(wr_ch_array_unbuffered_unix): Change calling convention.
	(wr_ss_unbuffered_unix): Update.
	(wr_ch_array_unbuffered_mac): Change calling convention.
	(wr_ss_unbuffered_mac): Update.
	(wr_ch_array_unbuffered_dos): Change calling convention.
	(wr_ss_unbuffered_dos): Update.
	(wr_ch_array_buffered_unix): Change calling convention.
	(wr_ss_buffered_unix): Update.
	(wr_ch_array_buffered_mac): Change calling convention.
	(wr_ss_buffered_mac): Update.
	(wr_ch_array_buffered_dos): Change calling convention.
	(wr_ss_buffered_dos): Update.
	(wr_ss_terminal3): Update.
	* sequence.d (WRITE-CHAR-SEQUENCE): Update.
	* lisparit.d (print_integer): Update. Use DYNAMIC_STRING macro.
	* pseudofun.d: Update.

	Make read_char_array recurse through any kind of stream.
	* lispbibl.d (read_char_array): Change calling convention.
	* stream.d (rd_ch_array_Pseudofun): Change type definition.
	(rd_ch_array_error): Change calling convention.
	(rd_ch_array_dummy): Likewise. Loop, calling read_char.
	(read_char_array): Change calling convention.
	(rd_ch_array_synonym): Likewise.
	(rd_ch_array_concat): Likewise. Treat general case.
	(rd_ch_array_twoway): Change calling convention.
	(rd_ch_array_echo): New function.
	(make_echo_stream): Use it.
	(rd_ch_array_str_in): Change calling convention.
	(rd_ch_array_unbuffered, rd_ch_array_buffered): Likewise.
	* sequence.d (READ-CHAR-SEQUENCE): Update.
	* pseudofun.d: Update.

	Make write_byte_array recurse through any kind of stream.
	* lispbibl.d (write_byte_array): Change calling convention.
	* stream.d (wr_by_array_Pseudofun): Change type definition.
	(wr_by_array_error): Change calling convention.
	(wr_by_array_dummy): Likewise. Loop, calling write_byte.
	(write_byte_array): Change calling convention.
	(wr_by_array_synonym): Likewise.
	(wr_by_array_broad0, wr_by_array_broad1): Remove functions.
	(wr_by_array_broad): New function.
	(make_broadcast_stream): Use it.
	(wr_by_array_twoway): Change calling convention.
	(rd_by_array_echo): Update.
	(wr_by_array_iau8_unbuffered, wr_by_array_iau8_buffered): Change
	  calling convention.
	(SYS::WRITE-N-BYTES): Update.
	(WRITE-INTEGER): Use DYNAMIC_BIT_VECTOR. Update.
	* sequence.d (WRITE-BYTE-SEQUENCE): Update.
	* pseudofun.d: Update.

	Make read_byte_array recurse through any kind of stream.
	* lispbibl.d (read_byte_array): Change calling convention.
	* stream.d (rd_by_array_Pseudofun): Change type definition.
	(rd_by_array_error): Change calling convention.
	(rd_by_array_dummy): Likewise. Loop, calling read_byte.
	(read_byte_array): Change calling convention.
	(rd_by_array_synonym): Likewise.
	(rd_by_array_concat): Likewise. Treat general case.
	(rd_by_array_twoway): Change calling convention.
	(rd_by_array_echo): New function.
	(make_echo_stream): Use it.
	(rd_by_array_iau8_unbuffered, rd_by_array_iau8_buffered): Change
	  calling convention.
	(SYS::READ-N-BYTES): Update.
	(READ-INTEGER): Use DYNAMIC_BIT_VECTOR. Update.
	* sequence.d (READ-BYTE-SEQUENCE): Update.
	* pseudofun.d: Update.

1999-04-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_ADDRESS_RANGE): Also determine the stack address
	  range.
	* unixconf.h.in (STACK_ADDRESS_RANGE): New macro.
	* lispbibl.d (STACK_ADDRESS_RANGE): Provide a default value.
	(bias_type_pointer_object): New macro, moved here from
	  spvw_allocate.d.
	(DYNAMIC_BIT_VECTOR, FREE_DYNAMIC_BIT_VECTOR, DYNAMIC_STRING,
	   FREE_DYNAMIC_STRING): New macros.
	* spvw_allocate.d (bias_type_pointer_object): Remove macro.

1999-04-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (c-form-table): Tread LDB, LDB-TEST, MASK-FIELD, DPB,
	  DEPOSIT-FIELD.
	(c-constant-byte-p, c-LDB, c-LDB-TEST, c-MASK-FIELD, c-DPB,
	   c-DEPOSIT-FIELD): New functions.

	* compiler.lsp (c-FORMAT): Only insert a FORMATTER call if FORMATTER
	  is not defined locally.

1999-04-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* describe.lsp (describe-object): `type-of' does not need `sys::'.

1999-04-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* intlog.d (I_I_logand_I): Optimize the case when either operand is a
	  positive fixnum, O(1) instead of O(N).
	(I_I_lognand_I): Likewise.
	(I_I_logandc2_I): Likewise for the first operand.

1999-04-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (make_HANDLER_frame): Fix compilation problem.

1999-04-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* io.d (READ-CHAR-STATUS): Renamed from SYS::REAL-LISTEN.
	* stream.d (listen_generic): Call GENERIC-STREAM-READ-CHAR-STATUS
	  instead of GENERIC-STREAM-LISTEN. Remove backward compatibility
	  hack.
	* gstream.lsp (generic-stream-read-char-status): Renamed from
	  generic-stream-listen.
	* screen.lsp: Likewise.

1999-04-24  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (ssstring_append_extend): New declaration.
	* array.d (ssstring_append_extend): New function.
	* stream.d (wr_ss_str_out, wr_ss_pphelp): Use it.

1999-04-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* array.d (iarray_displace): Renamed from notsimple_displace.
	(storagevector_aref): Renamed from datenvektor_aref.
	(storagevector_store): Renamed from datenvektor_store.
	(iarray_dims_sizes): Renamed from array_dims_sizes.
	(make_storagevector): Renamed from make_datenvektor.
	* io.d (pr_vector, pr_array_elt_t, pr_array): Update.

1999-04-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* macros2.lsp (space): Also print timing data, like TIME does.

1999-04-27  Sam Steingold  <sds@goems.com>

	* describe.lsp (describe): wrap `describe-object' in `unwind-protect'.
	(describe-object): fixed printing indentation.

1999-04-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d: Port to m68k-linux with ELF.

1999-04-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* defs2.lsp (defpackage): Allow duplicates in each of the
	  export/import/... lists, but still require these lists to be
	  disjoint.

1999-04-18  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* places.lsp (push, pushnew): Evaluate the item form before the
	  place's subforms.

1999-04-14  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* autoconf/aclocal.m4 (CL_GLOBAL_CONSTRUCTORS): Add check whether
	  ctor/dtor needs to be exported.

1999-04-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (rd_ch_array_buffered): Increment the stream's index and
	  position appropriately.

1999-04-13  Sam Steingold  <sds@goems.com>

	* modules/postgresql642/link.sh (have_libcrypt): do not quote ${CC}.

1999-04-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (data, UnicodeData.txt): New rules.
	(lisp${LEXE}): Depend on it.
	(installdirs): Create $(lisplibdir)/data.
	(install-bin): Install [data/]UnicodeData.txt.
	(uninstall-bin): Remove it.
	* _distmakefile (install-bin): Install data/UnicodeData.txt.
	* describe.lsp (describe-object) (character): Call unicode-attributes.
	(unicode-data-file, unicode-attributes-line, unicode-attributes):
	  New functions.

1999-04-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Add command-line option specifying $(lisplibdir).
	* _clisp.c (main): New option "-B".
	* spvw.d (main, usage): Likewise.
	* pathname.d (argv_lisplibdir): New variable.
	(SYS::LIB-DIRECTORY): New function.
	* makemake.in: Pass "-B" option to all invocations of lisp.run.

1999-04-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (installdirs): Create $(lisplibdir)/linkkit.
	(install-bin): Fix syntax error introduced on 1999-04-04.

1999-04-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (init_streamvars): Set _rl_comment_begin.

1999-04-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (c-FORMAT): Use c-constantp, not constantp, and
	  c-constant-value.

1999-04-12  Sam Steingold  <sds@goems.com>

	* macros3.lsp (with-collect): new macro.

1999-04-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* type.lsp (type-expand): Fix the second return value.

1999-04-08  Sam Steingold  <sds@goems.com>

	* compiler.lsp (c-FORMAT): check for a constant, not just a string.

1999-04-07  Sam Steingold  <sds@goems.com>

	* control.d (constantp): arrays are constants too.

1999-04-07  Sam Steingold  <sds@goems.com>

	Implemented ANSI CL issue KEYWORD-ARGUMENT-NAME-PACKAGE:ANY.
	* eval.d (get_closure, check_for_illegal_keywords): accept symbols
	as keywords.
	* compiler.lsp (analyze-lambdalist): accept symbols as keywords.

1999-04-07  Sam Steingold  <sds@goems.com>

	* compiler.lsp (c-FORMAT): signal an error when the stream
	argument is missing.
	* describe.lsp (describe-object): call `documentation'.

1999-04-06  Sam Steingold  <sds@goems.com>

	--- *ANSI* is a symbol macro now.
	* constsym.d: added `:ansi-cl', `ansi' and `set_ansi'.
	* subr.d: added `ansi' and `set_ansi'.
	* constobj.d: added `ansi'.
	* places.lsp: define *ANSI*.
	* init.lsp: export *ANSI*.
	* spvw.d: call `set_ansi' instead of setting *ANSI*.
	* misc.d (ansi, set_ansi): new LISPFUNNs.
	--- Fix `export-syscalls' damaged by recent patches.
	* socket.d (resolve_host_ipaddr): replaced `fehler_string_int'
	with `fehler_string_integer'.
	* pathname.d (user_data): ditto.  Also,
	`fehler_pathname_descriptor' --> `fehler_pathname_designator'.
	(file_stat): use `stream_fd' instead of `strm_ochannel'.
	* stream.d (file_stat): removed.
	(stream_fd): added.
	* lispbibl.d: declare `stream_fd'.
	--- fix `describe'
	* describe.lsp (describe): set `*describe-done*' and
	`*describe-nesting*' instead of binding.  Print empty arglist as
	(), not NIL.

1999-04-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Stop storing german and french translations in the source files.
	* german.lsp, french.lsp: New files.
	* makemake.in (LPARTS): Add them.
	* init.lsp: Load them.
	* *.d, *.lsp: Remove german and french translations.
	* compiler.lsp: Define macro ENGLISH instead of DEUTSCH.
	* lispbibl.d (DEUTSCH, FRANCAIS): Remove macros.
	(ENGLISH): Simplify.
	(language_deutsch, language_francais): Remove macros.
	(GETTEXT): New macro.
	* genclisph.d (main): Update.
	* constobj.d (LISPOBJ_L, LISPOBJ_LS): Simplify.
	* erramiga.d (lang3, lang1): Simplify.
	* errdjgpp.d (lang3, lang1): Likewise.
	* spvw_language.d (language_deutsch, language_francais): Define only
	  if GNU_GETTEXT.
	(init_languages_from): Treat de and fr only if GNU_GETTEXT.
	(init_language) [!GNU_GETTEXT]: Don't treat de and fr.

1999-04-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* io.d (right_margin): Update translations.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* foreign1.lsp (DEF-C-CALL-OUT, DEF-C-CALL-IN): Use language :STDC,
	  not old :C any more.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Changes to the distribution structure on Unix:
	- The default linking set is moved into subdirectory `base'.
	- Both `base' and `full' are installed.
	- All the documentation is installed.
	* _clisp.c (main): New option "-K". Drop option "-F".
	* _clisp.1: Document option "-K".
	* _clisp.html: Likewise.
	* spvw.d (usage): Mention "-K".
	(main): Accept and ignore "-K".
	* _distmakefile (fromdir): Remove variable.
	(linkingsets): New variable.
	(docdir, lispdocdir): New variables.
	(all): Depend on all lisp.runs.
	(install): Depend on install-doc.
	(install-bin): Copy all linking sets entirely. Copy clisp-link and
	  linkkit as well.
	(install-doc): New target.
	* makemake.in: $(lispdocdir) replaces $(docdir). Define $(docdir) and
	  $(lispdocdir) in all cases. Make `base' a directory containing
	  symlinks, not a symlink. `full' depends on `base'. `install' depends
	  on `install-doc'. New target `install-doc'. `installdirs' creates
	  the `base' directory and the doc directories. `install-bin' copies
	  the linking sets `base' and `full', and clisp-link and linkkit as
	  well. `install-man' installs all readmes and manual files.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* modules/clx/new-clx/link.sh: Add -L/usr/X11R6/lib -lX11 to
	  NEW_LIBS. Necessary since 1999-03-08 change.
	* modules/clx/new-clx/clx.f (pathname_encoding, misc_encoding): New
	  macros.
	(with_stringable_0): Add an encoding argument.
	(get_font, get_xatom_general, enum_error, make_xatom,
	   XLIB:OPEN-DISPLAY): Use misc_encoding.
	(XLIB:DISPLAY-AUTHORIZATION-DATA, XLIB:DISPLAY-AUTHORIZATION-NAME):
	  Allocate empty string via allocate_string.
	(XLIB:DISPLAY-VENDOR, XLIB:DISPLAY-HOST): Use misc_encoding.
	(general_draw_text): If UNICODE, use the -16 variant functions.
	(XLIB:OPEN-FONT, XLIB:FONT-PATH, XLIB:FONT-PATH-SETTER,
	   XLIB:LIST-FONT-NAMES, XLIB:LIST-FONTS, XLIB:FONT-PROPERTIES): Use
	  misc_encoding.
	(XLIB:TEXT-EXTENTS, XLIB:TEXT-WIDTH): If UNICODE, use the -16
	  variant functions.
	(XLIB:ALLOC-COLOR, XLIB:LOOKUP-COLOR, XLIB:ATOM-NAME,
	   XLIB:GET-PROPERTY, XLIB:LIST-PROPERTIES, XLIB:LIST-EXTENSIONS,
	   XLIB:QUERY-EXTENSION): Use misc_encoding.
	(XPM:READ-FILE-TO-PIXMAP): Use pathname_encoding.
	* modules/postgresql642/postgresql.lsp: Comments.
	Don't need to include <stdio.h>.
	(PGnotify): Use foreign type ffi:character, not ffi:char.
	(pqbool): Use foreign type ffi:char, not ffi:character.
	* modules/postgresql642sql.lsp (sql-error): Condition type is
	SQL-ERROR, not SQL.
	* modules/postgresql642/link.sh: Link with -lcrypt only
	if this library exists.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* _README: Refer to _README.en unconditionally.
	* makemake.in: Don't refer to `README.en'. `README' is enough.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Since make_machine and make_machine_code are different on some
	platforms...
	* pseudofun.d (LPSEUDOCODE): New macro, replaces PSEUDOFUN.
	(XPSEUDOCODE, XPSEUDODATA): New macros, replace XPSEUDO.
	(LCODE_PSEUDO_*, XCODE_PSEUDO_*, XDATA_PSEUDO_*): New macros.
	* lispbibl.d (pseudofun_tab): Remove.
	(pseudocode_tab, pseudodata_tab): New variables.
	* spvw.d (pseudocode_anz, pseudodata_anz): New macros.
	(pseudofun_anz): Change definition.
	(pseudofun_tab): Define as local variable.
	(main): Initialize pseudofun_tab from pseudocode_anz, pseudodata_anz.
	* spvw_memfile.d (loadmem_update): Compare objects, not Pseudofuns.
	* stream.d (pseudofun_tab): Remove.
	(pseudocode_tab, pseudodata_tab): New variables.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* control.d (test_env): Accept NIL, denoting the global environment.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (installdirs, install-bin, install-man): Make sure
	  the directories $(prefix) and $(exec_prefix) exist.
	* _distmakefile (install-bin, install-man): Likewise.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (make_file_stream): Fix the STACK offsets used to fill in
	  truename and pathname of unbuffered streams.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (SYS::MAKE-SOCKET-STREAM, init_streamvars): Pass a proper
	  encoding to make_unbuffered_stream, not the symbol :UNIX.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* conditio.lsp: Export simple-condition-format-control.
	(coerce-to-condition): Use :format-control.
	(simple-condition): Use $format-control.
	* defs3.lsp: Export simple-condition-format-control, not
	  simple-condition-format-string.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (make_pipe_output_stream, make_pipe_input_stream,
	   make_pipe_stream): Revert 1999-03-26 patch.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* socket.d (atoi): Remove declaration.
	(SERVENT_TO_STACK): Add `tmp' local variable.
	(SOCKET-SERVICE-PORT): Don't accept symbols, only strings and
	  integers, as service-name. Don't call fehler_string_integer for
	  non-fixnums. Use with_string_0 instead of TheAsciz(string_to_asciz(.
	  Fix placement of begin_system_call()/end_system_call().
	* subr.d: Keep in sync.
	* constsym.d: Likewise.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (FILE-STAT): Move to pathname.d.
	* pathname.d (fehler_pathname_designator): Renamed from
	  fehler_pathname_descriptor.
	(as_file_stream): global -> local. Update.
	(fehler_file_stream_unnamed): global -> local.
	(PARSE-NAMESTRING): Update.
	(unix_user_pwd): Fix treatment of error in getpwuid call.
	(init_pathnames): Restore comments.
	(USER-DATA, FILE-DATA): Move here, before the EMX "#undef stat".
	* subr.d: Keep in sync.
	* constsym.d: Likewise.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* constobj.d (O(type_string_integer)): Renamed from O(type_gensym_arg).
	* symbol.d (GENSYM): Update.
	* lispbibl.d (fehler_string_integer): Renamed from fehler_string_int.
	* error.d (fehler_string_integer): Renamed from fehler_string_int.
	  Use O(type_string_integer). Fix error message. Update translations.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* describe.lsp (describe-slotted-object): Define code in package
	  SYSTEM, not package CLOS.
	(describe-object): Likewise. Reindent.
	(describe-object T): Treat FSUBR here.
	(describe-object FUNCTION): Not here.
	(describe-object CONS): De-obfuscate list-length determination.
	(describe-object SYMBOL): Bind *print-escape* and *print-readably*
	  only around the necessary code. Update translations. Terminate
	  sentence with a dot.
	(describe-object PACKAGE): Keep "." internationalizable. Update
	  translations. Don't sort L if all we need is its length.
	(describe): Update translations.
	(apropos-list): Reindent.

1999-04-04  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Change the type of FSUBRs (were COMPILED-FUNCTION, but ANSI CL
	specifies that COMPILED-FUNCTION is a subtype of FUNCTION).
	* predtype.d (COMPILED-FUNCTION-P): For FSUBRs, return NIL.
	(TYPE-OF): For FSUBRs, return SPECIAL-OPERATOR.
	(CLASS-OF): Undo 1999-03-18 patch.
	(enum_hs_special_operator): Renamed from enum_hs_special_oper.
	(heap_statistics_mapper): Update.
	* defs2.lsp (function-lambda-expression): No need to call functionp.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* conditio.lsp (export): Mention `os-error' right after `file-error'.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* init.lsp (export): Mention `with-package-iterator' right after
	  `do-all-symbols', because that's where it is located in CLtL2.
	* defs3.lsp (export): Likewise.
	* defs1.lsp (with-package-iterator): Check all the symboltypes. Remove
	  duplicates among them.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* savemem.lsp (saveinitmem): Reindent. Declare *command-index* special,
	  because it is not defvar'ed at this point.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* loop.lsp (expand-loop) (collect/append/nconc): Generate forward-
	  consing code only for named accumulation variables. Revert to the
	  old backward-consing code for unnamed accumulation variables.
	(expand-loop) (accu-vars-nil, accu-vars-0): Kill use of `pushnew',
	  `push' and `delete-duplicates' is more efficient.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* constsym.d (*merge-pathnames-ansi*): New variable.
	* spvw.d (init_symbol_values): Initialize it to NIL.
	(main): Set it to T, if option -a given.
	* pathname.d (MERGE-PATHNAMES): If *merge-pathnames-ansi*,
	  concatenate two relative directories. Ignore *ansi*.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (impnotes.html): Only replace <HS> followed by a slash.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Accept option --with-export-syscalls, instead of
	  --export-syscalls.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Undo hack for missing rluserman.dvi.

1999-04-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* clisp.spec: Remove the "--with-unicode=no" hint. It is a bad idea.

1999-03-30  Jörg Höhle  <hoehle@tzd.telekom.de>

	* rexx.d (rexx_getmsg): return (handle command :RESULT)
	  if ARexx OPTIONS RESULTS requested on incoming command.

1999-04-01  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Improve handling of /proc/self/fd/* files on Linux.
	* pathname.d (possible_symlink, my_readlink): New functions.
	(realpath): Call possible_symlink before readlink.
	(if_HAVE_LSTAT): New macro.
	(assure_dir_exists) [UNIX]: Use it. Convert namestring to asciz once
	  only. Call possible_symlink before S_ISLNK and readlink.

1999-03-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* Makefile.devel: Add rules for three files in the
	  ffcall/callback/vacall_r/ directory.

1999-03-26  Sam Steingold  <sds@goems.com>

	* stream.d (make_pipe_stream): new function: merged
	make_pipe_input_stream and make_pipe_output_stream.
	(make_pipe_output_stream, make_pipe_input_stream): use it.

1999-03-22  Sam Steingold  <sds@goems.com>

	* pathname.d (merge-pathnames): be ANSI CL compliant when
	lisp:*ansi* is non-nil.
	(unix_user_pwd): extracted from init_pathnames().
	(init_pathnames): use unix_user_pwd().
	(user_data): moved here from stream.d; use unix_user_pwd().

1999-03-20  Sam Steingold  <sds@gnu.org>

	Added PostgreSQL interface.  New module: postgresql.
	* modules/postgresql/postgresql.lsp: bindings.
	* modules/postgresql/sql.lsp: example of use.
	* makemake.in: added postgresql.

1999-03-20  Sam Steingold  <sds@gnu.org>

	* describe.lsp (describe-object): handle foreign functions correctly.

1999-03-19  Sam Steingold  <sds@gnu.org>

	* savemem.lsp (saveinitmem): bind +/-/* to nil instead of setting
	them to nil.  Also, bind sys::*command-index* to 0.

1999-03-18  Sam Steingold  <sds@gnu.org>

	* compiler.lsp (*deprecated-functions-list*): new variable.
	(note-function-used): use it.
	* describe.lsp (describe-object): warn about deprecated functions.
	* predtype.d (class-of): fsubr is a function, not T.
	* constobj.d: print SPECIAL-OPERATOR instead of SPECIAL-FORM.
	* io.d (pr_fsubr): comment fix.
	* ../modules/clx/new-clx/clx.lsp: push keyword :clx-ansi-common-lisp
	into `*features*' instead of the symbol.

1999-03-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_ICONV): Add check for iconv prototype.
	* unixconf.h.in (ICONV_CONST): New macro.
	* unix.d (iconv): Use ICONV_CONST.

1999-03-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (CLISP_INTERNAL_CHARSET): For HP-UX, set it to "ucs2".

1999-03-17  Sam Steingold  <sds@gnu.org>

	* describe.lsp (describe-object): handle CLOS classes in a
	`standard-object' method.  Describe the value of the `weak-pointer'.
	* stream.d (file_stat): fixed time handling.

1999-03-16  Sam Steingold  <sds@gnu.org>

	* describe.lsp (describe-object): replaced `standard-object' with T.

1999-03-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* defs1.lsp (package-iterator-function): New function, taken out of
	  with-package-iterator.
	(with-package-iterator): Adjust, add error message.

1999-03-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d (nls_mbstowcs, nls_asciiext_mbstowcs, nls_wcstombs,
	   nls_asciiext_wcstombs, nls_range): Use TheMachine, not ThePseudofun.
	  Vital for hppa.
	(init_encodings): Use make_machine, not P. Vital for hppa.
	  Initialize O(internal_encoding) always to ISO-8859-1, independently
	  of the platform. If HPROMAN8_CHS is defined, use it for the other
	  encodings, instead of ASCII.

1999-03-16  Sam Steingold  <sds@gnu.org>

	implement `with-package-iterator'.
	* defs1.lsp (with-package-iterator): new ANSI CL macro.
	* defs3.lsp, init.lsp: export it.

1999-03-16  Sam Steingold  <sds@gnu.org>

	* socket.d (is_number): removed.
	(resolve_host_ipaddr): return all hosts on NIL arg.
	* stream.d (user_data): return the current user with no args.
	* _impnotes.html: document this.

1999-03-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (rd_ch_terminal2): Restructure this function. Call
	  rd_ch_unbuffered, in order to respect the stream's encoding.
	  When EOF has been reached, no need to set strm_rd_ch_last,
	  the caller already does this.
	(lisp_completion_matches): Do filename completion also after #P".
	(rd_ch_terminal3): Restructure this function. Respect the stream's
	  encoding. When EOF has been reached, no need to set strm_rd_ch_last,
	  the caller already does this.

1999-03-15  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d: Test for `__linux__', not `linux', so that even when
	  compiling with "-ansi -pedantic" the incompatible _setjmp/_longjmp
	  functions are avoided.

1999-03-15  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make it possible again to compile with "gcc -x c++".
	* aclocal.m4 (CL_CC_GCC): Define GCC_X_NONE.
	* intparam.d (main7): Use %lX instead of %X for a `long'.
	(main8): Adapt for C++.

	* configure: Don't configure in readline subdir if compiling
	  in C++ mode.

	* utils/modprep.d: Define `inline' to empty when compiling with
	  "gcc -ansi -pedantic".
	(String_equalsIgnoreCase): Don't use `isascii', it is not portable.

	* io.d (unicode_attribute, graphic_char_p): Remove the macros. The
	  global definition in charstrg.d is sufficient.
	(syntax_table_put): Cast one branch of the conditional expression
	  to void, to make this valid C++.

	* stream.d (host_data_fetcher): New type.
	(publish_host_data): Adjust declaration, for increased type safety.

	* charstrg.d (string_search): Change for being valid C++.

	* foreign.d (alignof): Provide alternate definition, valid C++.
	(convert_to_foreign): Cast converter_malloc result to char*.

	* avl.d (AVL(AVLID,least), AVL(AVLID,move)): Change K&R C declaration
	  into ANSI C declaration.

1999-03-14  Sam Steingold  <sds@gnu.org>

	* stream.d: removed `stream_fd';
	moved `file_stat' and `user_data' here.
	* pathname.d: renamed `fehler_thing' to `fehler_pathname_descriptor'.
	export it, `as_file_stream', `fehler_file_stream_unnamed'.
	* socket.d (resolve_host_ipaddr): handle IPv6 addresses.

1999-03-14  Sam Steingold  <sds@gnu.org>

	OS_error() generates an error of type `os-error'.
	* erramiga.d, errdjgpp.d, errunix.d, errwin32.d (OS_error): use
	`simple_os_error'.
	* lispbibl.d (conditiontype): added `os_error'.
	* constsym.d: added `simple_os_error' symbol.
	* error.d: handle `simple_os_error'.
	* conditio.lsp: added `os-error' and `simple-os-error'.

1999-03-14  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (strm_encoding): New macro.
	* stream.d (strm_encoding): Comment out.
	* encoding.d (SYS::[SET-]DEFAULT-FILE-ENCODING,
	   SYS::[SET-]PATHNAME-ENCODING, SYS::[SET-]TERMINAL-ENCODING,
	   SYS::[SET-]FOREIGN-ENCODING, SYS::[SET-]MISC-ENCODING): New
	  functions.
	* init.lsp: Export *default-file-encoding*, *pathname-encoding*,
	  *terminal-encoding*, *misc-encoding*.
	* places.lsp (*default-file-encoding*, *pathname-encoding*,
	   *terminal-encoding*, *misc-encoding*): New settable symbol-macros.
	* foreign1.lsp (ffi:*foreign-encoding*): New settable symbol-macro.
	* affi1.lsp (affi:*foreign-encoding*): New settable symbol-macro.

1999-03-14  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* defs2.lsp (define-symbol-macro, check-not-special-variable-p): Move
	  to macros2.lsp.
	* macros2.lsp (define-symbol-macro, check-not-special-variable-p):
	  Moved here from defs2.lsp.

1999-03-14  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (test_socket_server): New argument check_open. When it is
	  TRUE, check that the handle is non-NIL.
	(SOCKET-SERVER-CLOSE): After closing, set the handle to NIL. When
	  the handle is NIL, do nothing.
	(SOCKET-SERVER-PORT, SOCKET-SERVER-HOST): Update.
	(SOCKET-ACCEPT, SOCKET-WAIT): Call test_socket_server with
	  check_open=TRUE.
	* io.d (pr_orecord): For closed socket-servers, print a "CLOSED "
	  prefix.

1999-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d (init_encodings): Define some more aliases.

1999-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d (fehler_uni32_invalid, uni32_mblen, uni32be_mbstowcs,
	   uni32le_mbstowcs, uni32_wcslen, uni32be_wcstombs, uni32le_wcstombs):
	  New functions.
	(init_encodings): Initialize the Unicode-32 encodings.
	* pseudofun.d: Update.
	* type.lsp (canonicalize-type): Add charset:unicode-32-big-endian and
	  charset:unicode-32-little-endian to the list of types equivalent to
	  CHARACTER.

1999-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (conditiontype): Add charset_type_error.
	* conditio.lsp (charset-type-error, simple-charset-type-error): New
	  condition types.
	(%defclcs call): Add simple-charset-type-error.
	* constsym.d (simple_*_error): Add simple_charset_type_error.
	* error.d (end_error): Treat simple_charset_type_error like
	  simple_type_error.
	* encoding.d (fehler_unencodable): Signal an error of type
	  charset_type_error.

1999-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Integrate types and encodings.
	* lispbibl.d (Encoding): Add enc_range field.
	(encoding_length): Increment by 1.
	(Encoding_range): New macro.
	(stringof): New declaration.
	* charstrg.d (stringof): New function.
	* encoding.d (all_range, nls_range): New functions.
	(iconv_range): Declare.
	(MAKE-ENCODING): Initialize the enc_range field.
	(fehler_encoding, SYS::CHARSET-TYPEP, SYS::CHARSET-RANGE): New
	  functions.
	(init_encodings): Initialize the enc_range field.
	* stream.d (iconv_mblen): Optimize and make consistent with
	  iconv_mbstowcs.
	(iconv_wcslen): Optimize and make consistent with iconv_wcstombs.
	(iconv_wcstombs): Don't loop until outsize==0. The caller may have
	  given a larger buffer than necessary.
	(iconv_range): New function.
	* pseudofun.d: Update.
	* type.lsp (typep): Accept an encoding as a type.
	(canonicalize-type, subtypep): Likewise.
	(charset-subtypep): New function.

1999-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d (SYS::ENCODINGP): New function.
	* type.lsp: Implement typep for type ENCODING.
	(subtypep): Treat ENCODING as an elementary type.
	* compiler.lsp (c-typep-alist1): Implement typep for type ENCODING.

1999-03-13  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* spvw_genera2.d (gc_mark_old_generation): Add braces, to avoid egcs
	  warning.
	* spvw_genera3.d (update_old_generation): Likewise.

1999-03-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (conditiontype): Add reader_error.
	* conditio.lsp (simple-reader-error): New condition type.
	(%defclcs call): Add simple-reader-error.
	* constsym.d (simple_*_error): Add simple_reader_error.
	* io.d (signal_reader_error): New function.
	(read_internal): Protect calls to read_rational and read_float with
	  a handler for ARITHMETIC-ERROR.

1999-03-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (make_HANDLER_frame, make_HANDLER_entry_frame,
	   unwind_HANDLER_frame): New macros.
	* eval.d (invoke_handlers): Distinguish handler frames with a
	  bytecoded handler and handler frames with a C function as handler.

1999-03-12  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* format.lsp (format-character): Don't print the name of printable
	  characters.

1999-03-12  Sam Steingold  <sds@gnu.org>

	* subr.d: arglists for `socket_service_port' and `resolve_host_ipaddr'.
	* stream.d (socket_service_port): moved from here to socket.d
	* pathname.d (user_data): use `fehler_string_int'.
	* socket.d (resolve_service): removed.
	(socket_service_port): moved here.  optional second arg - protocol.
	return all services as a list when called with no arguments.
	(resolve_host_ipaddr): when called with no args, localhost is returned.
	* error.d (fehler_string_int): new function.
	* lispbibl.d (fehler_string_int): declare.

1999-03-11  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d: Make UNICODE-16 an alias for UNICODE-16-BIG-ENDIAN.
	* constsym.d: Rename the CPxxx-MS symbols to CPxxx.

1999-03-11  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* encoding.d: Add the HP-ROMAN8 character set.

1999-03-11  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (FILE-STRING-LENGTH): Depend on the stream's encoding.
	  Don't look at the strm_wr_ch pointer.

1999-03-11  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pathname.d (directory_search_scandir): Avoid calling stat() if
	  the given wildcard mask excludes a given directory entry.

1999-03-10  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Fix a bug: clear-input did not kill the EOF condition in terminal2
	and terminal3 streams.
	* stream.d (clear_input_keyboard): Use ls_avail_p.
	(clear_input_terminal2): Call clear_input_unbuffered, don't call
	  clear_tty_input directly. Use ls_avail_p.
	(clear_input_terminal3): Likewise.

1999-03-10  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Finish implementing the iconv-based encodings.
	* lispbibl.d (Encoding): Add a stream argument to the enc_mbstowcs and
	  enc_wcstombs fields.
	(Encoding_mbstowcs, Encoding_wcstombs): Update.
	(cstombs): Pass nullobj as stream.
	* error.d (write_errorstring): Likewise.
	* foreign.d (convert_from_foreign_array_fill, convert_from_foreign):
	  Likewise.
	* affi.d (SYSTEM::MEM-READ): Likewise.
	* encoding.d (MAKE-ENCODING, make_string, asciz_to_string,
	   string_to_asciz): Move to the end of the file.
	(fehler_unencodable): Declare as global.
	(uni16be_mbstowcs, uni16le_mbstowcs, uni16be_wcstombs,
	   uni16le_wcstombs, utf8_mbstowcs, utf8_wcstombs, java_mbstowcs,
	   java_wcstombs, nls_mbstowcs, nls_asciiext_mbstowcs, nls_wcstombs,
	   nls_asciiext_wcstombs): Add an unused stream argument.
	(iconv_mblen, iconv_mbstowcs, iconv_wcslen, iconv_wcstombs,
	   fehler_iconv_invalid_charset): Move to stream.d.
	* stream.d (strm_channel_extrafields_struct): Add iconvdesc, oconvdesc
	  fields.
	(ChannelStream_iconvdesc, ChannelStream_oconvdesc): New macros.
	(CLISP_INTERNAL_CHARSET): New macro.
	(fehler_iconv_invalid_charset, iconv_mblen, iconv_mbstowcs,
	   iconv_wcslen, iconv_wcstombs): New functions, moved to here from
	  encoding.d. If the stream is passed, use the iconvdesc, oconvdesc
	  fields.
	(ChannelStream_init, ChannelStream_fini): New functions.
	(rd_ch_unbuffered, listen_unbuffered, rd_ch_array_unbuffered): Pass
	  the stream to the mbstowcs function.
	(close_ichannel): Call ChannelStream_fini.
	(wr_ch_unbuffered_unix, wr_ch_array_unbuffered_unix,
	   wr_ch_unbuffered_mac, wr_ch_array_unbuffered_mac,
	   wr_ch_unbuffered_dos, wr_ch_array_unbuffered_dos): Pass the stream
	  to the wcstombs function.
	(close_ochannel): Call ChannelStream_fini.
	(make_unbuffered_stream): Call ChannelStream_init.
	(rd_ch_buffered, rd_ch_array_buffered): Pass the stream to the
	  mbstowcs function.
	(wr_ch_buffered_unix, wr_ch_array_buffered_unix, wr_ch_buffered_mac,
	   wr_ch_array_buffered_mac, wr_ch_buffered_dos,
	   wr_ch_array_buffered_dos): Pass the stream to the wcstombs function.
	(make_buffered_stream): Call ChannelStream_init.
	(closed_buffered): Erase the old iconv descriptors.
	(close_buffered): Call ChannelStream_fini.
	(make_keyboard_stream): Add O(terminal_encoding), and call
	  ChannelStream_init.
	(make_terminal_stream_): Call ChannelStream_init.
	(SYSTEM::SET-STREAM-EXTERNAL-FORMAT): Call ChannelStream_fini and
	  ChannelStream_init.
	* pseudofun.d: Update.

1999-03-10  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Support for IPv6 sockets.
	* aclocal.m4 (CL_TCPCONN): Add checks for IPv4 and IPv6 facilities.
	  Add checks for `inet_pton' and `inet_ntop' functions.
	* unixconf.h.in (CL_TCPCONN): Conditionally define HAVE_IPV4,
	  HAVE_IPV6, IPV6_NEED_LINUX_IN6_H, HAVE_INET_PTON, HAVE_INET_NTOP.
	* lispbibl.d (UNIXCONN, TCPCONN): Define here, not in socket.d.
	  Make SOCKET_STREAMS depend on TCPCONN.
	(host_data): Remove the `host' field. Make the `hostname' field
	  large enough for IPv6. Change the `truename' field into an array,
	  so it does not need to point to static or temporary data.
	(MAXHOSTNAMELEN): Define.
	* win32.d: Define HAVE_IPV4, don't define HAVE_IPV6.
	* stream.d (publish_host_data): Test hd.truename for being "", not
	  NULL. Allocate the temporary string on the stack, instead of malloc.
	* misc.d (MACHINE-INSTANCE): Moved to socket.d.
	* socket.d: Don't define UNIXCONN, TCPCONN, SOCKET_STREAMS here.
	  Don't define MAXHOSTNAMELEN here.
	(get_hostname): New macro.
	(ipv4_ntop, ipv6_ntop): New macros.
	(MACHINE-INSTANCE): Moved here from socket.d. Consider h->h_addrtype
	  instead of blindly assuming it's AF_INET. Use ipv4_ntop macro
	  for building the dotted address string, instead of doing it by hand.
	(CLOSESOCKET): Only define if UNIXCONN || TCPCONN.
	(saving_sock_errno): New macro.
	(all_digits_dots): New function, for distinguishing IPv4 addresses
	  and FQDNs. The old method of looking at the first character is no
	  longer valid.
	(with_hostname): New function, taken out of connect_to_x_server.
	  Support IPv6. Compare the inet_addr() return value with (uint32)(-1),
	  not (unsigned long)(-1) [matters for 64-bit platforms].
	(connect_to_x_via_ip): New function, taken out of
	  connect_to_x_server.
	(connect_to_x_server): Use with_hostname and connect_to_x_via_ip.
	  Use get_hostname.
	(memset, bzero, bcopy): Remove declarations.
	(fill_hostname): Remove function, obsoleted by ipv4_ntop.
	(sockaddr_max): New type.
	(socket_getlocalname_aux): New function, taken out of
	  socket_getlocalname. Don't need to bzero() the result. Support IPv6.
	(socket_getlocalname): Use socket_getlocalname_aux. Return the true
	  host name instead of "localhost".
	(socket_getpeername): Don't need to bzero() the result. Support IPv6.
	  If truename unknown, return it as "" instead of NULL.
	(bindlisten_via_ip): New function, taken out of create_server_socket.
	  Close the socket in case of failure.
	(create_server_socket): Use with_hostname and bindlisten_via_ip.
	  Don't need to bzero() the addr. Use the true host name instead of
	  "localhost". After calling getsockname(), support IPv6. Make the
	  final getsockname() after listen(), not before. Don't need to
	  bzero() the result.
	(accept_connection): Support IPv6.
	(connect_via_ip): New function, taken out of create_client_socket.
	  If connect() fails, save errno during closesocket.
	(create_client_socket): Don't need to bzero() the sockaddr. Use
	  with_hostname and connect_via_ip.

1999-03-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in (XCFLAGS): When compiling for sparc, use
	  -fno-schedule-insns, in order to avoid egcs-1.1.1 bug which
	  miscompiles the division routine and causes an XGCD test failure.

1999-03-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_TERM): When `struct winsize' is not defined in
	  <termios.h>, check whether it is defined in <sys/ioctl.h>.
	* unixconf.h.in (WINSIZE_NEED_SYS_PTEM_H): Renamed from
	  NEED_SYS_PTEM_H.
	(WINSIZE_NEED_SYS_IOCTL_H): New macro.
	* unix.d: Use both.

1999-03-10  Sam Steingold  <sds@gnu.org>

	* ../configure: new option --export-syscalls.
	* makemake.in: ditto.
	* constsym.d, subr.d: added `RESOLVE-HOST-IPADDR', `FILE-STAT'
	and `USER-DATA'.
	* pathname.d: added `file_stat' and `user_data'.
	* socket.d: added `resolve_host_ipaddr'.
	* stream.d: added `stream_fd'.

1999-03-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make it possible to build clisp when neither libtermcap nor libncurses
	is available.
	* configure: Optionally pass/recommend --with-no-termcap-ncurses for
	  makemake.
	* makemake.in (XCFLAGS): Optionally add -DNO_TERMCAP_NCURSES.
	* lispbibl.d: If NO_TERMCAP_NCURSES is defined, don't define KEYBOARD
	  and SCREEN.
	* spvw_sigwinch.d (update_linelength): Respect NO_TERMCAP_NCURSES.

1999-03-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d: Include <string.h> also in the case of NO_READLINE,
	  in order to declare `strcpy' and `strcat'.

1999-03-11  Sam Steingold  <sds@goems.com>

	* loop.lsp (expand-loop): do not nreverse for collect/nconc/append.

1999-03-09  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Remove the graphics stuff.
	* graph.d: Remove file.
	* gettext/po/Makefile.devel (DSOURCES): Remove graph.
	* unix.d (geteuid, setreuid): Remove declarations.
	* makemake.in (LIBS): Don't add -lgraph and -lvideo on EMX.
	(CPARTS): Remove graph.
	(lisp.exe rule): Don't use emx options -aim or -acmi.
	* lispbibl.d (GRAPHICS, GRAPHICS_SWITCH): Remove definitions.
	(switch_text_mode): Remove declaration.
	* spvw.d (main): Don't drop setuid-root privilege. Don't call
	  switch_text_mode.
	* stream.d (low_read_unbuffered_handle, low_listen_unbuffered_handle,
	   low_read_array_unbuffered_handle, low_write_unbuffered_handle,
	   low_write_array_unbuffered_handle, rd_ch_terminal2,
	   rd_ch_terminal3, out_char): Don't call switch_text_mode.

1999-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* configure: Don't tell the user to do "cd .".

1999-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* graph.d (GRAPHICS_X, GRAPHICS_SUN): Remove unfinished code.
	* makemake.in: Don't link with ${X_LIBS}, but keep the Makefile
	  variable for possible future use.
	* clisp-link.in: Likewise.

1999-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pathname.d: Include <stdio.h>.

1999-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_FPU_CONTROL): Fix the "checking for" messages.

1999-03-08  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* aclocal.m4 (CL_MEMSET): Undefine memset, so we get correct types
	  with glibc-2.1.

1999-03-10  Sam Steingold  <sds@gnu.org>

	* clos.lsp: moved `describe-slotted-object' and `describe-object'
	from here to describe.lsp.
	* describe.lsp: moved the bulk from `describe' to `describe-object'.
	added variables `*describe-nesting*' and `*describe-done*'.
	`describe' now calls `describe-object' and is ANSI compliant.

1999-03-07  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* readline/: Upgrade to readline-4.0.
	* configure: Also copy readline/shlib/.

1999-03-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* genclisph.d (main): Modify immediate_number_p, charp, integerp,
	  fixnump, posfixnump, floatp, short_float_p according to 1999-02-02
	  lispbibl.d patch.

1999-03-05  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* Renamed newnewreadline to readline, newreadline to oldreadline,
	  readline to oldoldreadline.
	* Makefile.devel, configure, makemake.in: Update.

1999-03-03  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (SOCKET-SERVICE-PORT): When not found, return NIL instead
	  of -1.

1999-03-02  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Handle SIGPIPE on Unix.
	* spvw_sigpipe.d: New file.
	* spvw.d: Include it.
	(main): Call install_sigpipe_handler.
	* makemake.in (SPVW_INCLUDES): Add spvw_sigpipe.
	* gettext/po/Makefile.devel (DSOURCES): Add spvw_sigpipe. Split line
	  into multiple pieces, to avoid 1023 character line length limit of
	  patch-2.1.
	* lispbibl.d (writing_to_subprocess): New declaration.
	* stream.d (low_flush_buffered_pipe): New function.
	(BufferedPipeStreamInit): New macro.
	(MAKE-PIPE-INPUT-STREAM, MAKE-PIPE-OUTPUT-STREAM,
	   MAKE-PIPE-IO-STREAM): Use it.
	(low_write_unbuffered_pipe, low_write_array_unbuffered_pipe): New
	  functions.
	(UnbufferedPipeStream_output_init): Use them.
	* error.d (begin_error, tast_break): Set writing_to_subprocess=FALSE.
	* unix.d (raise): New declaration.
	* msdos.d (raise): Likewise.
	* acorn.d (raise): Likewise.
	* errunix.d (EPIPE): Improve error messages.

1999-03-01  Sam Steingold  <sds@goems.com>

	* spvw.d: removed :IEEE-FLOATING-POINT from *features*.  Use
	`pushnew' instead of `nconc'.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* lispbibl.d (subr_argtype_t): New enumeration items subr_argtype_1_3,
	  subr_argtype_2_3.
	* spvw.d (subr_argtype): Use them.
	* eval.d (eval_subr, apply_subr, funcall_subr): Treat them.
	* stream.d (SYSTEM::SET-STREAM-ELEMENT-TYPE): Stricter restrictions.
	(check_multiple8_eltype, test_endianness_arg): New functions.
	(READ-INTEGER, WRITE-INTEGER): New functions.
	* compiler.lsp (subr-info): Add them.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Allow #0Y to occur on standard input.
	* stream.d (SYSTEM::SET-STREAM-EXTERNAL-FORMAT): Accept an optional
	  direction argument. If it is given, recurse properly.
	* io.d (closure_reader): Call it with direction :INPUT.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* io.d (syntax_table_get_notinline): Swap arguments to gethash().

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (compile-file): Create the .fas and .lib files in UTF-8.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Reader macro for switching the stream's encoding.
	* constobj.d (O(charset_package)): New variable.
	* package.d (init_packages): Create #<PACKAGE CHARSET> and initialize
	  O(charset_package).
	* constpack.d: Remove #<PACKAGE CHARSET> here.
	* spvw.d (init_symbol_tab_2): New enum item enum_charset_index.
	* io.d (closure_reader): Accept "#0Y charset" syntax.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* charstrg.d (char_name): Return #\Uxxxx as a name for every Unicode
	  character.
	(name_char): Accept #\Uxxxx as a name for any Unicode character.
	* io.d (char_reader): Remove #\Uxxxx recognition code, now done by
	  `name_char'.
	(pr_character): For graphic standard characters, don't look up the
	  name.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Improve error checking in parse-namestring.
	* pathname.d (legal_namechar): Don't accept Unicode characters which
	  are not 1 byte in the pathname_encoding.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Use the system's iconv() function if available.
	* aclocal.m4 (CL_ICONV): New macro.
	* configure.in: Call it.
	* unixconf.h.in (HAVE_ICONV): New macro.
	* unix.d: Declare iconv_open, iconv, iconv_close.
	* encoding.d (MAKE-ENCODING): Accept strings as well.
	(iconv_mblen, iconv_mbstowcs, iconv_wcslen, iconv_wcstombs): New
	  functions.
	* pseudofun.d: Add them.
	* stream.d (test_external_format_arg): Accept strings as well.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* configure: Recommend --with-unicode.
	* makemake.in (*/makefile*): Pass --with-unicode to makemake.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* macros2.lsp (with-output-to-printer): Declare arg as IGNORE.

1999-02-28  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Introduce space-efficient immutable strings.
	* lispbibl.d (Rectype_Imm_SmallSstring): New enumeration item.
	(Rectype_mdarray, Rectype_Sbvector, Rectype_bvector, Rectype_Svector,
	   Rectype_vector, Rectype_Sstring, Rectype_string,
	   Rectype_Imm_Sstring):
	  Rearrange and define rectype_unused1 so as to get fast type checks.
	(HAVE_SMALL_SSTRING): New macro.
	(small_sstring_, SmallSstring): New types.
	(Array_type_sstring): Treat Rectype_Imm_SmallSstring like
	  Rectype_Imm_Sstring.
	(TheSmallSstring): New macro.
	(vectorp, simplep, array_simplep, general_vector_p, simple_string_p,
	   stringp, byte_vector_p, arrayp): Update and optimize.
	(if_recordp): Treat Rectype_Imm_SmallSstring like
	  Rectype_Imm_Sstring.
	(case_Rectype_Sstring_above, case_Rectype_string_above,
	   case_Rectype_array_above): Likewise.
	(allocate_imm_small_string): New declaration.
	(with_string_0, with_sstring_0, with_string, with_sstring): Update
	  for unpack_string_ro change. Use unpack_sstring_alloca.
	(chartcopy, scintcopy): New declarations.
	(SstringDispatch): New macro.
	(unpack_sstring_alloca): New macro.
	(unpack_string_ro): One more argument, change return type.
	(coerce_normal_ss, coerce_imm_normal_ss): New declarations.
	(test_string_limits_rw): Remove declaration.
	(stringarg): New structure type.
	(test_string_limits_ro): Change calling convention.
	(string_eqcomp, string_eqcomp_ci): New declarations.
	* genclisph.d (main): Update vectorp, general_vector_p,
	  simple_string_p, stringp, byte_vector_p, arrayp.
	* spvw_objsize.d (size_small_sstring): New macro.
	(objsize): Treat Rectype_Imm_SmallSstring.
	* spvw_update.d (update_varobject): Treat Rectype_Imm_SmallSstring
	  like Rectype_Imm_Sstring.
	* spvw_genera1.d (walk_area, build_old_generation_cache): Likewise.
	* spvw_garcol.d (gc_mark): Likewise.
	* spvw_typealloc.d (allocate_imm_small_string): New function.
	* charstrg.d (chartcopy, scintcopy): New functions.
	(unpack_string_ro): Define always. One more argument, change return
	  type.
	(string_gleich, string_equal): Mostly rewritten.
	(copy_string, coerce_imm_ss): Mostly rewritten.
	(coerce_normal_ss, coerce_imm_normal_ss): New functions.
	(coerce_char): Update, treat small strings too.
	(CHAR, SCHAR): Likewise.
	(test_string_limits_ro): Change calling convention.
	(test_string_limits_rw): Change calling convention, make local.
	(test_2_stringsym_limits): Change calling convention.
	(string_eqcomp, string_comp): Change calling convention. Rewritten,
	  treat small strings too.
	(STRING=, STRING/=, STRING<, STRING>, STRING<=, STRING>=): Rewritten.
	(string_eqcomp_ci, string_comp_ci): Change calling convention.
	  Rewritten, treat small strings too.
	(STRING-EQUAL, STRING-NOT-EQUAL, STRING-LESSP, STRING-GREATERP,
	   STRING-NOT-GREATERP, STRING-NOT-LESSP): Rewritten.
	(eqcomp_fun): Change function type.
	(string_search): Change calling convention. Treat len1==0 outside of
	  the loop.
	(SYS::SEARCH-STRING=, SYS::SEARCH-STRING-EQUAL): Mostly rewritten.
	(NSTRING-UPCASE, NSTRING-DOWNCASE, NSTRING-CAPITALIZE): Rewritten.
	(subsstring, SUBSTRING, string_concat): Treat small strings too.
	* array.d (datenvektor_aref): Treat small strings too.
	(datenvektor_store): Treat Rectype_Imm_SmallSstring like
	  Rectype_Imm_Sstring.
	(VECTOR-PUSH-EXTEND): Treat small strings too.
	(ssstring_push_extend, ssstring_extend): Use chartcopy.
	* predtype.d (equal): Use string_eqcomp.
	(elt_compare_T_Char): Treat small strings too.
	(elt_compare_Char_Char): Use string_eqcomp_ci.
	* hashtabl.d (hashcode_string): Treat small strings too.
	(hashcode3_atom): Treat Rectype_Imm_SmallSstring like
	  Rectype_Imm_Sstring.
	(hashcode4_vector_Char): Treat small strings too.
	* package.d (string_hashcode): Treat small strings too.
	* encoding.d (string_to_asciz): Call unpack_sstring_alloca, but call
	  unpack_string_ro only once.
	(string_to_asciz_): Update.
	* sequence.d (WRITE-CHAR-SEQUENCE): Call unpack_sstring_alloca.
	* stream.d (wr_ss_dummy, wr_ss_dummy_nogc): Treat small strings too.
	(rd_ch_str_in, rd_ch_array_str_in): Likewise.
	(MAKE-STRING-INPUT-STREAM): Update.
	(wr_ss_str_out, wr_ss_pphelp): Treat small strings too.
	(rd_ch_buff_in): Likewise.
	(wr_ss_generic): Call unpack_sstring_alloca.
	(wr_ss_unbuffered_unix, wr_ss_unbuffered_mac, wr_ss_unbuffered_dos,
	   wr_ss_buffered_unix, wr_ss_buffered_mac, wr_ss_buffered_dos):
	  Likewise.
	(lisp_completion): Call unpack_sstring_alloca. Use
	  O(terminal_encoding).
	(wr_ss_terminal3): Call unpack_sstring_alloca. Treat small strings
	  too.
	(FILE-STRING-LENGTH): Treat small strings too.
	* io.d (PARSE-INTEGER): Treat small strings too.
	(write_sstring_case, pr_symbol_part, pr_sstring_ab): Likewise.
	(pr_orecord): Treat Rectype_Imm_SmallSstring like
	  Rectype_Imm_Sstring.
	(write_string_up): Update.
	* lisparit.d (read_integer): Call unpack_sstring_alloca.
	(decimal_string): Use chartcopy.
	* foreign.d (convert_to_foreign): Call unpack_sstring_alloca.
	* affi.d (affi_call_argsa, SYSTEM::MEM-WRITE-VECTOR): Likewise.
	* pathname.d (subst_coerce_normal_ss): New function.
	(test_optional_host): Use coerce_normal_ss instead of coerce_ss.
	(PARSE-NAMESTRING): When thing is a symbol, do the case conversion
	  on the :start/:end delimited part, not on the entire symbol-name.
	  Accept small strings too, convert them to normal strings.
	(MAKE-PATHNAME): Call coerce_normal_ss on the device, name and type.
	  Call subst_coerce_normal_ss on the directory.

1999-02-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* package.d (correct_packname): Convert the package name to an
	  immutable string.
	(init_packages): Use immutables strings as package names and
	  nicknames.
	* symbol.d (GENSYM): Make the symbol name immutable.

1999-02-27  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Bug fix for NEXTAPP model.
	* stream.d (lisp_completion): Call begin_error here.
	(lisp_completion_matches): Not here.

1999-02-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* socket.d (create_server_socket): Cast setsockopt argument.

	* modules.d (_NEXT_NULL): New macro.

1999-02-25  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Fix bug in parsing of --hyperspec argument.

	* makemake.in (XCC_DLOPENABLE_EXE_FLAG): Pass -export-dynamic to
	  the linker only if the linker is GNU ld.

1999-02-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* clos.lsp, init.lsp: Do export GENERIC-LABELS and GENERIC-FLET here.

1999-02-22  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* compiler.lsp (compile-file): Output the SYSTEM::VERSION form in
	  upper case.
	* unix/MAGIC.add: Revert last change.

1999-02-21  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Convert dotimesL with loop variables into dotimespL.
	* affi.d (bytecopy): Use dotimespL. Assume length > 0.
	(SYSTEM::MEM-READ): Use dotimespL instead of dotimesL.
	* array.d (reshape): Likewise.
	* charstrg.d (string_gleich, string_equal, SUBSTRING): Likewise.
	* control.d (PSETQ): Likewise.
	* error.d (convert_simple_condition): Likewise.
	* eval.d (sym_value, setq, sym_function, nest_env): Likewise.
	* encoding.d (make_string_, ascii_to_string): Likewise.
	* graph.d (gr_text): Likewise.
	* io.d (test_potential_number_syntax, test_number_syntax, test_dots,
	   upcase_token, uninterned_reader, bit_vector_reader,
	   write_sstring_case, klammer_zu): Likewise.
	* record.d (CLOS::ALLOCATE-STD-INSTANCE, CLOS::%ALLOCATE-INSTANCE,
	   CLOS::%MAKE-INSTANCE): Likewise.
	* spvw.d (main): Likewise.
	* foreign.d (convert_from_foreign_array_fill, convert_to_foreign):
	  Likewise.
	* hashtabl.d (clrhash): Likewise.
	* intread.d (DIGITS_to_I): Likewise.
	* pathname.d (common_case, test_optional_host, all_digits,
	   parse_logical_pathnamestring, legal_name_or_type, legal_name,
	   legal_type, MAKE-PATHNAME, has_wildcards, has_word_wildcards,
	   SYSTEM::DYNLOAD-MODULES): Likewise.
	* predtype.d (heap_statistics_result): Likewise.
	* stream.d (wr_ss_terminal3): Likewise.
	* spvw_debug.d (mem_hex_out): Likewise.
	* spvw_typealloc.d (allocate_vector): Likewise.

	Convert dotimesC with loop variables into dotimespC.
	* affi.d (affi_call_argsa): Use dotimespC instead of dotimesC.
	* arilev1i.d (shiftleft_loop_down, shiftleftcopy_loop_down,
	   shiftright_loop_up): Likewise.
	* array.d (array_dimensions, array_dims_sizes, ARRAY-IN-BOUNDS-P,
	   bit_up): Likewise.
	* eval.d (get_closure, funcall_iclosure, match_subr_key,
	   match_cclosure_key, apply_closure, funcall_subr, funcall_closure):
	  Likewise.
	* charstrg.d (string_concat): Likewise.
	* misc.d (MACHINE-INSTANCE): Likewise.
	* control.d (LET, LET*, SYMBOL-MACROLET): Likewise.
	* foreign.d (FFI::%ELEMENT): Likewise.
	* hashtabl.d (hashcode4_atom): Likewise.
	* lisparit.d (=, /=, <, >, <=, >=): Likewise.
	* record.d (CLOS::%SHARED-INITIALIZE, CLOS::%REINITIALIZE-INSTANCE,
	   do_initialize_instance, CLOS::%MAKE-INSTANCE): Likewise.
	* predtype.d (equalp): Likewise.
	* sequence.d (CONCATENATE): Likewise.
	* spvw.d (for_all_subrs, for_all_constobjs, init_subr_tab_1,
	   init_object_tab_1, init_other_modules_1, init_module_2, main,
	   dynload_modules): Likewise.
	* spvw_typealloc.d (allocate_xrecord_): Likewise.
	* stream.d (test_input_stream_args, test_output_stream_args,
	   clear_linepart, save_line_old): Likewise.

1999-02-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Introduce immutable strings.
	* lispbibl.d (Rectype_Imm_Sstring): New enumeration item.
	(Array_type_sstring): Include it.
	(strmflags_immut_bit_B): New macro.
	(vectorp, simplep, array_simplep, general_vector_p, simple_string_p,
	   stringp, byte_vector_p, arrayp, if_recordp): Update.
	(case_Rectype_Sstring_above, case_Rectype_string_above): Include
	  Rectype_Imm_Sstring.
	(allocate_imm_string): New declaration.
	(with_string_0, with_string): Use unpack_string_ro.
	(unpack_string_ro, unpack_string_rw): New declarations, replace
	  unpack_string.
	(coerce_imm_ss): New declaration.
	(test_string_limits_ro, test_string_limits_rw): New declarations,
	  replace test_string_limits.
	(fehler_sstring_immutable): New declaration.
	(check_sstring_mutable): New macro.
	* spvw_update.d (update_varobject): Treat Rectype_Imm_Sstring like
	  Rectype_Sstring.
	* spvw_garcol.d (gc_mark): Likewise.
	* spvw_genera1.d (walk_area, build_old_generation_cache): Likewise.
	* spvw_typealloc.d (allocate_imm_string): New function.
	* error.d (fehler_sstring_immutable): New function.
	* array.d (datenvektor_store): In case of Rectype_Imm_Sstring, signal
	  an error.
	* charstrg.d (unpack_string_rw): Renamed from unpack_string. Add calls
	  to check_sstring_mutable.
	(unpack_string_ro): New function.
	(string_gleich, string_equal, copy_string): Use unpack_string_ro
	  instead of unpack_string.
	(coerce_imm_ss): New function.
	(coerce_char): Use unpack_string_ro instead of unpack_string.
	(test_index_arg): Return the index, not the new charptr.
	(CHAR, SCHAR): Update.
	(SYS::STORE-CHAR): Update. Call unpack_string_rw instead of
	  unpack_string.
	(SYS::STORE-SCHAR): Update. Add check_sstring_mutable call.
	(test_string_limits_ro): Renamed from test_string_limits.
	  Use unpack_string_ro instead of unpack_string.
	(test_string_limits_rw): New function.
	(test_2_stringsym_limits): Use unpack_string_ro instead of
	  unpack_string.
	(NSTRING-UPCASE, NSTRING-DOWNCASE, NSTRING-CAPITALIZE): Use
	  test_string_limits_rw instead of test_string_limits.
	(SUBSTRING, string_concat): Use unpack_string_ro instead of
	  unpack_string.
	* stream.d (strmflags_immut_bit_B, strmflags_immut_B): New macros.
	(make_twoway_stream, make_echo_stream): Inherit the immut_B from
	  the input stream.
	(rd_ch_str_in, rd_ch_array_str_in): Use unpack_string_ro instead of
	  unpack_string.
	(MAKE-STRING-INPUT-STREAM): Use test_string_limits_ro instead of
	  test_string_limits.
	(rd_ch_buff_in): Likewise. Use unpack_string_ro instead of
	  unpack_string.
	(make_unbuffered_stream, make_buffered_stream): Put strmflags_immut_B
	  into the strmflags if asked for.
	(FILE-STRING-LENGTH): Use unpack_string_ro instead of unpack_string.
	* io.d (string_reader): Create an immutable string, if the stream
	  allows this.
	(uninterned_reader): Likewise.
	(PARSE-INTEGER): Use test_string_limits_ro instead of
	  test_string_limits.
	(pr_orecord): Treat Rectype_Imm_Sstring like Rectype_Sstring.
	(write_string_up): Use test_string_limits_ro instead of
	  test_string_limits.
	* affi.d (affi_call_argsa): Use unpack_string_ro instead of
	  unpack_string.
	(SYSTEM::MEM-READ): Use unpack_string_rw instead of unpack_string.
	(SYSTEM::MEM-WRITE-VECTOR): Use unpack_string_ro instead of
	  unpack_string.
	* package.d (string_hashcode): Use unpack_string_ro instead of
	  unpack_string.
	(intern): Make the symbol-name strings immutable if possible.
	(shadow): Likewise.
	(MAKE-SYMBOL): Likewise.
	(test_names_args): Make the package-name and package-nicknames
	  strings immutable if possible.
	* spvw.d (init_symbol_tab_2): Make the symbol-name strings immutable
	  if possible.
	* pathname.d (PARSE-NAMESTRING): Use test_string_limits_ro instead of
	  test_string_limits.
	* encoding.d (string_to_asciz): Use unpack_string_ro instead of
	  unpack_string.
	* foreign.d (convert_to_foreign): Use unpack_string_ro instead of
	  unpack_string.
	* hashtabl.d (hashcode_string): Use unpack_string_ro instead of
	  unpack_string.
	(hashcode3_atom): Treat Rectype_Imm_Sstring like Rectype_Sstring.
	* sequence.d (READ-CHAR-SEQUENCE): Treat an empty string specially.
	  Then call unpack_string_rw instead of unpack_string.
	(WRITE-CHAR-SEQUENCE): Treat an empty string specially.
	  Then call unpack_string_ro instead of unpack_string.

1999-02-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make room in the strmflags.
	* stream.d (strmflags_i_B, strmflags_ia_B, strmflags_ib_B,
	   strmflags_ic_B): Remove macros.
	(decoded_eltype): kind==eltype_ch implies size==0.
	(test_eltype_arg): When setting eltype_ch, set size = 0.
	(strm_channel_extrafields_struct): bitsize is now unconditional.
	(close_ichannel, close_ochannel): Test for bitsize > 0.
	(make_unbuffered_stream): Set ChannelStream_bitsize in all cases.
	  Don't set strmflags_i...
	(position_file_i_buffered): Dispatch on bitsize, not flags.
	(logical_position_file_start, logical_position_file,
	   logical_position_file_end): Likewise.
	(fill_pseudofuns_buffered): Likewise.
	(make_buffered_stream): Set ChannelStream_bitsize in all cases.
	  Don't set strmflags_i...
	(buffered_flush_everything): Dispatch on bitsize, not flags.
	(closed_buffered): Test for bitsize > 0.
	(SYSTEM::SET-STREAM-ELEMENT-TYPE): Simplify accordingly.

1999-02-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Make BASE-CHAR equivalent to CHARACTER.
	* lispbibl.d (small_char_int_len): Renamed from base_char_int_len.
	(small_char_int_limit): Renamed from base_char_int_limit.
	(scint): Renamed from bcint.
	(small_char_code_limit): Renamed from base_char_code_limit.
	(base_char_int_len, base_char_code_limit): New macros.
	(base_char_p): Define only when needed.
	(small_char_p): New macro.
	* charstrg.d (SYSTEM::BASE-CHAR-P): Define only when needed.
	* spvw.d (init_object_tab): Add :BASE-CHAR=CHARACTER to *features*.
	* io.d: Update.
	* defs2.lsp (dispatch-reader): Don't use base-char-p and
	  base-char-code-limit.
	(designator): Depend upon :BASE-CHAR=CHARACTER.
	(base-char-designator-p): Define only when needed.
	* type.lsp (BASE-CHAR, EXTENDED-CHAR, canonicalize-type): Depend
	  upon :BASE-CHAR=CHARACTER.
	* compiler.lsp (c-typep-alist1, c-typep-alist2): Treat BASE-CHAR
	  and EXTENDED-CHAR depending upon :BASE-CHAR=CHARACTER.

1999-02-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Improve the speed of NLS charset conversions.
	* utils/unicode/nls_table.java: Emit a value for is_ascii_extension.
	* encoding.d (nls_table): New field `is_ascii_extension'.
	(nls_asciiext_mbstowcs, nls_asciiext_wcstombs): New functions.
	(init_encodings): Choose them if possible.
	* pseudofun.d (nls_asciiext_mbstowcs, nls_asciiext_wcstombs): New
	  declarations.

1999-02-20  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* stream.d (init_streamvars): Avoid gcc warning.

1999-02-19  Sam Steingold  <sds@goems.com>

	* defs3.lsp, clos.lsp, init.lsp: do not export `generic-flet',
	`generic-labels'.
	* _impnotes.html is now HTML 3.2 compliant.

1999-02-19  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Improve parsing of --hyperspec argument.

1999-02-18  Sam Steingold  <sds@goems.com>

	* affi.txt, ansicl.txt, cltl2.txt, foreign.txt, module.txt,
	vgagraph.txt: removed.

1999-02-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* makemake.in: Improve parsing of --hyperspec argument.

1999-02-17  Sam Steingold  <sds@goems.com>

	* spvw.d: user ascii* instead of asciz* for constant string
	when initializing *features*.
	* _impnotes.txt, impnotes.html: removed.
	* _impnotes.html: new file.
	* makemake.in, ../configure: new option --hyperspec.

1999-02-12  Sam Steingold  <sds@goems.com>

	* socket.d (create_client_socket): port is unsigned int.
	* stream.d: declare `create_client_socket' appropriately.

1999-02-17  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	* pseudofun.d: Enclose all XPSEUDOs in #ifdef UNICODE.

1999-02-16  Bruno Haible  <bruno@linuix.math.u-bordeaux.fr>

	Unicode support.
	* makemake.in (--with-unicode): New command line option.
	(XCFLAGS): Conditionally add -DUNICODE.
	(UNICODE_INCLUDES, NLS_INCLUDES): New variables.
	(CFILES): Add them.
	  Symlink them.
	(depends): Add $UNICODE_INCLUDES for charstrg. Add $NLS_INCLUDES for
	  encoding.
	* lispbibl.d (CHART_STRUCT): Don't define on m68k and arm CPUs.
	(char_int_len): Define as 16 for UNICODE.
	(Encoding) [UNICODE]: Add more fields.
	(encoding_length): Change value.
	(encoding_xlength): New macro.
	(Encoding_mblen, Encoding_mbstowcs, Encoding_wcslen,
	   Encoding_wcstombs, cslen, cstombs): New macros.
	(allocate_encoding): Use encoding_xlength.
	(make_string): Add an encoding argument.
	(asciz_to_string, string_to_asciz): Likewise.
	(ascii_to_string): New function.
	(with_string_0, with_sstring_0, with_string, with_sstring): Add an
	  encoding argument.
	(pseudofun_): Remove type.
	(Pseudofun): Change definition.
	(P): New macro, moved here from stream.d.
	(max_bytes_per_chart): New macro.
	* genclisph.d (main): Remove `asciz_to_string' declaration.
	  Add `ascii_to_string' declaration.
	* modules/clx/new-clx/e2d.c (care_about_packages): Use ascii_to_string
	  instead of asciz_to_string.
	* constpack.d (LISPPACK_B): Use ascii_to_string instead of
	  asciz_to_string.
	(charset): New package.
	* constsym.d (CHARSET:...): New symbols.
	* constobj.d (O(internal_encoding), O(pathname_encoding),
	   O(terminal_encoding), O(foreign_encoding), O(misc_encoding)): New
	  variables.
	* spvw.d (make_string, asciz_to_string, string_to_asciz): Moved out
	  to encoding.d.
	(fehler_notreached): Use ascii_to_string instead of asciz_to_string.
	(fehler_code_alignment): Use O(terminal_encoding).
	(init_symbol_tab_2): Export symbols in package CHARSET as well.
	  Use ascii_to_string instead of asciz_to_string.
	(init_object_tab): Add :UNICODE to features_initstring. Use
	  ascii_to_string instead of asciz_to_string. Use O(internal_encoding).
	(init_module_2): Use O(internal_encoding).
	(print_license, print_banner): Use O(internal_encoding).
	(main): Use O(internal_encoding) and O(pathname_encoding) and
	  O(misc_encoding). Use ascii_to_string.
	(fehler_dlerror): Use O(misc_encoding) and O(internal_encoding).
	* spvw_language.d (localized_string, localized_object): Use
	  S(iso8859_1).
	* spvw_memfile.d (memflags): Depends on UNICODE.
	(loadmem_update): Use the Pseudofun type instead of void*.
	* encoding.d (MAKE-ENCODING): Accept constant symbols for the :charset
	  argument. Copy the trailing encoding_xlength bytes too.
	(make_string): Moved here from spvw.d. Add encoding argument.
	(asciz_to_string): Likewise.
	(ascii_to_string): New function.
	(string_to_asciz): Moved here from spvw.d. Add encoding argument.
	(hex_table): New variable.
	(fehler_unencodable): New function.
	(uni16_mblen, uni16be_mbstowcs, uni16le_mbstowcs, uni16_wcslen,
	   uni16be_wcstombs, uni16le_wcstombs): New functions.
	(fehler_utf8_invalid1, fehler_utf8_invalid2, fehler_utf8_invalid3,
	   utf8_mblen, utf8_mbstowcs, utf8_wcslen, utf8_wcstombs): New
	  functions.
	(java_mblen, java_mbstowcs, java_wcslen, java_wcstombs): New
	  functions.
	(nls_table): New struct type.
	(nopage): New constant array.
	(nls_*.c): New include files.
	(nls_first_sym, nls_last_sym, nls_num_encodings): New macros.
	(nls_tables): New constant array.
	(nls_mblen, nls_mbstowcs, nls_wcslen, nls_wcstombs): New functions.
	(init_encodings): Entirely rewritten.
	* pseudofun.d (PSEUDOFUN_C): Renamed from PSEUDOFUN_B.
	(PSEUDOFUN_B): New macro.
	(XPSEUDO_A, XPSEUDO_B, XPSEUDO_C): New macros.
	  New XPSEUDO declarations for the functions and tables defined in
	  encoding.d.
	* charstrg.d (nop_page): New variable.
	(up_case, down_case): Add UNICODE support.
	(uni_attribute.c): New include file.
	(unicode_attribute): New macro.
	(alphap): Add UNICODE support.
	(numericp): New macro.
	(alphanumericp): Add UNICODE support.
	(graphic_char_p): Add UNICODE support.
	(SYSTEM::BASE-CHAR-P): Fix comparison with base_char_code_limit.
	(DIGIT-CHAR-P): Add UNICODE support.
	* predtype.d (TYPE-OF): Fix comparison with base_char_code_limit.
	* package.d (init_packages): Use ascii_to_string instead of
	  asciz_to_string.
	* io.d (unicode_attribute, graphic_char_p): New macros.
	(allocate_perchar_table, perchar_table_get, perchar_table_put,
	   copy_perchar_table): Add UNICODE support.
	(allocate_syntax_table, syntax_table_get, syntax_table_put): Move
	  macros. Add UNICODE support.
	(orig_syntax_table): Size is only base_char_code_limit. Add UNICODE
	  support.
	(orig_syntax_table_get): New macro.
	(orig_readtable, copy_readtable_contents): Add UNICODE support.
	(SET-SYNTAX-FROM-CHAR): Permit syntax_table_put to call GC.
	(SET-MACRO-CHARACTER): Likewise.
	(MAKE-DISPATCH-MACRO-CHARACTER): Likewise.
	(attribute_table): Size is only base_char_code_limit. Add UNICODE
	  support.
	(attribute_of): Add UNICODE support.
	(char_reader): Declare code as uintL, so it can hold value up to
	  10*char_code_limit. Recognize #\uxxxx syntax.
	(PARSE-INTEGER): Use orig_syntax_table_get instead of accessing
	  orig_syntax_table directly.
	(pr_orecord): For Rectype_Encoding, also print the charset symbol.
	* defs2.lsp (dispatch-reader): Modify to match changes in the
	  perchar_table_get macro.
	* pathname.d (asciz_dir_to_pathname): Add an encoding argument.
	(PARSE-NAMESTRING): Use O(misc_encoding).
	(default_directory_of, directory_truename, default_directory,
	   canonicalise_filename, canonicalise_dirname, assure_dir_exists):
	  Use O(pathname_encoding).
	(change_default): Likewise.
	(file_exists, directory_exists): Likewise.
	(DELETE-FILE, rename_file, create_backup_file, open_file): Likewise.
	(extract, subdirs, subfiles, with_stat_info,
	   directory_search_1subdir, directory_search_hashcode,
	   directory_search_direntry_ok, directory_search_scandir, DIRECTORY):
	  Likewise.
	(MAKE-DIR, DELETE-DIR, ENSURE-DIRECTORIES-EXIST): Likewise.
	(init_pathnames): Use O(pathname_encoding) and O(misc_encoding).
	(FILE-WRITE-DATE, FILE-AUTHOR): Use O(pathname_encoding).
	(EXECUTE): Use O(pathname_encoding) and O(misc_encoding).
	(SHELL): Use O(misc_encoding).
	(SYSTEM::DYNLOAD-MODULES): Use O(pathname_encoding).
	(SYSTEM::PROGRAM-NAME): Likewise.
	* stream.d (P): Move to lispbibl.d.
	(test_external_format): Accept constant symbols.
	(strm_unbuffered_extrafields_struct): Extend the meaning of status.
	  Rename field `lastbyte' to `bytebuf'.
	(UnbufferedStream_lastbyte): Remove macro.
	(UnbufferedStream_bytebuf): New macro.
	(UnbufferedStreamLow_push_byte, UnbufferedStreamLow_pushfront_byte,
	   UnbufferedStreamLow_pushfront_bytes, UnbufferedStreamLow_pop_byte):
	  New macros.
	(low_read_unbuffered_handle): Use UnbufferedStreamLow_pop_byte and
	  UnbufferedStreamLow_push_byte.
	(low_listen_unbuffered_handle): Use UnbufferedStreamLow_push_byte.
	(low_read_array_unbuffered_handle): Use UnbufferedStreamLow_pop_byte
	  in a loop.
	(rd_ch_unbuffered): Add UNICODE support.
	(listen_unbuffered): Likewise. Use UnbufferedStreamLow_pushfront_byte.
	(rd_ch_array_unbuffered): Add UNICODE support.
	(wr_ch_unbuffered_unix, wr_ch_array_unbuffered_unix): Likewise.
	(wr_ch_unbuffered_mac, wr_ch_array_unbuffered_mac): Likewise.
	(wr_ch_unbuffered_dos, wr_ch_array_unbuffered_dos): Likewise.
	(rd_ch_buffered, rd_ch_array_buffered): Likewise.
	(wr_ch_buffered_unix, wr_ch_array_buffered_unix): Likewise.
	(wr_ch_buffered_mac, wr_ch_array_buffered_mac): Likewise.
	(wr_ch_buffered_dos, wr_ch_array_buffered_dos): Likewise.
	(finish_output_buffered): Use O(pathname_encoding).
	(make_key_event): Use ascii_to_string instead of asciz_to_string.
	(lisp_completion): Use O(terminal_encoding).
	(rd_ch_terminal3): Use O(terminal_encoding).
	(wr_ch_terminal3): Call wr_ch_unbuffered_unix, instead of direct
	  `write' call.
	(wr_ss_terminal3): Call wr_ch_array_unbuffered_unix, instead of
	  direct `full_write' call.
	(make_terminal_stream_): Initialize the encoding. Use
	  O(pathname_encoding).
	(init_term): Use O(misc_encoding).
	(MAKE-PIPE-INPUT-STREAM, MAKE-PIPE-OUTPUT-STREAM,
	   MAKE-PIPE-IO-STREAM): Use O(misc_encoding).
	(low_read_unbuffered_socket): Use UnbufferedStreamLow_pop_byte.
	(low_listen_unbuffered_socket): Use UnbufferedStreamLow_push_byte.
	(low_read_array_unbuffered_socket): Use UnbufferedStreamLow_pop_byte
	  in a loop.
	(SYS::MAKE-SOCKET-STREAM, SOCKET-SERVER, SOCKET-CONNECT): Use
	  O(misc_encoding).
	(SOCKET-SERVICE-PORT): Use S(ascii).
	(publish_host_data): Use O(misc_encoding).
	(make_terminal_io): Use ascii_to_string instead of asciz_to_string.
	(init_streamvars): Likewise.
	(SYSTEM::SET-STREAM-ELEMENT-TYPE): Use UnbufferedStreamLow_push_byte.
	(pseudofun_tab): Include pseudofun.c once more.
	* error.d (write_errorstring): Add UNICODE support. Use
	  O(internal_encoding).
	* misc.d (LISP-IMPLEMENTATION-VERSION): Use ascii_to_string instead of
	  asciz_to_string.
	(MACHINE-TYPE, MACHINE-VERSION, MACHINE-INSTANCE): Use
	  O(misc_encoding). Use ascii_to_string instead of asciz_to_string.
	(SYSTEM::GETENV, SYSTEM::REGISTRY): Use O(misc_encoding).
	* rexx.d (REXX-PUT): Use with_sstring and O(misc_encoding).
	(rexx_getmsg): Use O(misc_encoding).
	(REXX-REPLY): Use with_string and O(misc_encoding). No need to call
	  coerce_ss.
	* graph.d (SYS::GRAPH-INIT): Use ascii_to_string instead of
	  asciz_to_string.
	(SYS::GRAPH-TEXT): Use with_string and an encoding corresponding to
	  the font.
	* foreign.d (register_foreign_variable, register_foreign_function):
